// Battery dimensions
#define ROWS 4
#define COLS 4

// Battery output requirements 
#define GROUPSREQD 3 // groups required in parallel to satisfy the current requirement
#define CELLSREQD 3 // cells required in serial to satisfy the voltage requirement

//#define FGURR // fixed groups, unweighted round robin
//#define FGWRR // fixed groups, weighted round robin
#define GPWRR // group packing, weighted round robin

//#define LTL ltl p1{ 1==0}
#define LTL ltl p1 { []( ((v1 == -1 && v2 == -1 && v3 == -1) || terminate) || (2*(v0 + v2 + v3) >= v1) )}
//[](  \
//((v1 == -1 && v2 == -1 && v3 == -1) || terminate) || \
//(2*(v0 + v2 + v3) >= v1) \
//) \
}

//[]true \
//[]((v1 == -1 && v2 == -1 && v3 == -1) || terminate || (v1 > v3) )
// [] ((v1 == -1 || v2 == -1 || v3 == -1 || terminate) || CONTRACT )

#define HEADTOHEAD // enable this to connect groups head-to-head
//#define MIDTOMID 
//#define HEADTOTAIL

#define ROWSTOCOLS 
//#define COLSTOROWS // enable this to form groups by columns instead of rows in static init and group formation scheduler


//#define LTL 
// -----------------

#define TNDISTANCE 2 // max distance by 1-norm between two cells to be considered thermal neighbors

// memory allocation for groups
#define MAXGRNUM ((ROWS*COLS)/CELLSREQD + 1) //8 // max number of groups 
#define MAXGRSIZE ((ROWS*COLS)/GROUPSREQD + 1)//8 // max number of cells in a group

// all constants are assumed to fit into a byte
// CONSTRAINT occupancy: MAXGRNUM * MAXGRSIZE >= ROWS*COLS
// CONSTRAINT single group: MAXGRSIZE >= ROWS*COLS
// CONSTRAINT: CELLSREQD <= MAXGRSIZE
// CONSTRAINT: GROUPSREQD <= MAXGRNUM
// CONSTRAINT: CELLSREQD*MAXGRNUM >= ROWS*COLS
// CONSTRAINT: CELLSREQD*GROUPSREQD <= ROWS*COLS

#define KGROUPS GROUPSREQD // a parameter of weighted and unweighted KRR: select K most charged groups.
