/**
 * <copyright>
 * Copyright  2011 by Carnegie Mellon University, all rights reserved.
 * 
 * Use of the Open Source AADL Tool Environment (OSATE) is subject to the terms of the license set forth
 * at http://www.eclipse.org/org/documents/epl-v10.html.
 * 
 * NO WARRANTY
 * 
 * ANY INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY OR OTHER PROPERTY OR RIGHTS GRANTED OR PROVIDED BY
 * CARNEGIE MELLON UNIVERSITY PURSUANT TO THIS LICENSE (HEREINAFTER THE ''DELIVERABLES'') ARE ON AN ''AS-IS'' BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING,
 * BUT NOT LIMITED TO, WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY, INFORMATIONAL CONTENT,
 * NONINFRINGEMENT, OR ERROR-FREE OPERATION. CARNEGIE MELLON UNIVERSITY SHALL NOT BE LIABLE FOR INDIRECT, SPECIAL OR
 * CONSEQUENTIAL DAMAGES, SUCH AS LOSS OF PROFITS OR INABILITY TO USE SAID INTELLECTUAL PROPERTY, UNDER THIS LICENSE,
 * REGARDLESS OF WHETHER SUCH PARTY WAS AWARE OF THE POSSIBILITY OF SUCH DAMAGES. LICENSEE AGREES THAT IT WILL NOT
 * MAKE ANY WARRANTY ON BEHALF OF CARNEGIE MELLON UNIVERSITY, EXPRESS OR IMPLIED, TO ANY PERSON CONCERNING THE
 * APPLICATION OF OR THE RESULTS TO BE OBTAINED WITH THE DELIVERABLES UNDER THIS LICENSE.
 * 
 * Licensee hereby agrees to defend, indemnify, and hold harmless Carnegie Mellon University, its trustees, officers,
 * employees, and agents from all claims or demands made against them (and any related losses, expenses, or
 * attorney's fees) arising out of, or relating to Licensee's and/or its sub licensees' negligent use or willful
 * misuse of or negligent conduct or willful misconduct regarding the Software, facilities, or other rights or
 * assistance granted by Carnegie Mellon University under this License, including, but not limited to, any claims of
 * product liability, personal injury, death, damage to property, or violation of any laws or regulations.
 * 
 * Carnegie Mellon University Software Engineering Institute authored documents are sponsored by the U.S. Department
 * of Defense under Contract F19628-00-C-0003. Carnegie Mellon University retains copyrights in all material produced
 * under this contract. The U.S. Government retains a non-exclusive, royalty-free license to publish or reproduce these
 * documents, or allow others to do so, for U.S. Government purposes only pursuant to the copyright license
 * under the contract clause at 252.227.7013.
 * </copyright>
 * 
 */
package org.osate.aadl2;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.osate.aadl2.Aadl2Factory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/uml2/2.0.0/UML originalName='AADL2'"
 * @generated
 */
public interface Aadl2Package extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "aadl2";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://aadl.info/AADL/2.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "aadl2";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	Aadl2Package eINSTANCE = org.osate.aadl2.impl.Aadl2PackageImpl.init();

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ElementImpl <em>Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getElement()
	 * @generated
	 */
	int ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT__OWNED_ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT__OWNED_COMMENT = 1;

	/**
	 * The number of structural features of the '<em>Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.CommentImpl <em>Comment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.CommentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComment()
	 * @generated
	 */
	int COMMENT = 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Body</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__BODY = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Comment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.NamedElementImpl <em>Named Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.NamedElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getNamedElement()
	 * @generated
	 */
	int NAMED_ELEMENT = 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__NAME = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__QUALIFIED_NAME = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Named Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.TypeImpl <em>Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.TypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getType()
	 * @generated
	 */
	int TYPE = 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertyAssociationImpl <em>Property Association</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertyAssociationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPropertyAssociation()
	 * @generated
	 */
	int PROPERTY_ASSOCIATION = 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__PROPERTY = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Applies To</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__APPLIES_TO = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>In Binding</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__IN_BINDING = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Append</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__APPEND = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Constant</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__CONSTANT = ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Value</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION__OWNED_VALUE = ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Property Association</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ASSOCIATION_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.TypedElementImpl <em>Typed Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.TypedElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getTypedElement()
	 * @generated
	 */
	int TYPED_ELEMENT = 7;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPED_ELEMENT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPED_ELEMENT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPED_ELEMENT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPED_ELEMENT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPED_ELEMENT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPED_ELEMENT__TYPE = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Typed Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPED_ELEMENT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BasicPropertyImpl <em>Basic Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BasicPropertyImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBasicProperty()
	 * @generated
	 */
	int BASIC_PROPERTY = 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__OWNED_ELEMENT = TYPED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__OWNED_COMMENT = TYPED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__NAME = TYPED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__QUALIFIED_NAME = TYPED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__OWNED_PROPERTY_ASSOCIATION = TYPED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__TYPE = TYPED_ELEMENT__TYPE;

	/**
	 * The feature id for the '<em><b>Property Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__PROPERTY_TYPE = TYPED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Property Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY__OWNED_PROPERTY_TYPE = TYPED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Basic Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY_FEATURE_COUNT = TYPED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertyImpl <em>Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertyImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProperty()
	 * @generated
	 */
	int PROPERTY = 5;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__OWNED_ELEMENT = BASIC_PROPERTY__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__OWNED_COMMENT = BASIC_PROPERTY__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__NAME = BASIC_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__QUALIFIED_NAME = BASIC_PROPERTY__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__OWNED_PROPERTY_ASSOCIATION = BASIC_PROPERTY__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__TYPE = BASIC_PROPERTY__TYPE;

	/**
	 * The feature id for the '<em><b>Property Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__PROPERTY_TYPE = BASIC_PROPERTY__PROPERTY_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Property Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__OWNED_PROPERTY_TYPE = BASIC_PROPERTY__OWNED_PROPERTY_TYPE;

	/**
	 * The feature id for the '<em><b>Inherit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__INHERIT = BASIC_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__DEFAULT_VALUE = BASIC_PROPERTY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Applies To Metaclass</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__APPLIES_TO_METACLASS = BASIC_PROPERTY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Applies To Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__APPLIES_TO_CLASSIFIER = BASIC_PROPERTY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Applies To</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__APPLIES_TO = BASIC_PROPERTY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Empty List Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__EMPTY_LIST_DEFAULT = BASIC_PROPERTY_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FEATURE_COUNT = BASIC_PROPERTY_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertyTypeImpl <em>Property Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertyTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPropertyType()
	 * @generated
	 */
	int PROPERTY_TYPE = 8;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TYPE__OWNED_ELEMENT = TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TYPE__OWNED_COMMENT = TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TYPE__NAME = TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TYPE__QUALIFIED_NAME = TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TYPE__OWNED_PROPERTY_ASSOCIATION = TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Property Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TYPE_FEATURE_COUNT = TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertyExpressionImpl <em>Property Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertyExpressionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPropertyExpression()
	 * @generated
	 */
	int PROPERTY_EXPRESSION = 11;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertyOwnerImpl <em>Property Owner</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertyOwnerImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPropertyOwner()
	 * @generated
	 */
	int PROPERTY_OWNER = 13;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MetaclassReferenceImpl <em>Metaclass Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MetaclassReferenceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMetaclassReference()
	 * @generated
	 */
	int METACLASS_REFERENCE = 12;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.NamespaceImpl <em>Namespace</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.NamespaceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getNamespace()
	 * @generated
	 */
	int NAMESPACE = 15;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ClassifierImpl <em>Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getClassifier()
	 * @generated
	 */
	int CLASSIFIER = 14;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ClassifierFeatureImpl <em>Classifier Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ClassifierFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getClassifierFeature()
	 * @generated
	 */
	int CLASSIFIER_FEATURE = 16;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RelationshipImpl <em>Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RelationshipImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRelationship()
	 * @generated
	 */
	int RELATIONSHIP = 19;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DirectedRelationshipImpl <em>Directed Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DirectedRelationshipImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDirectedRelationship()
	 * @generated
	 */
	int DIRECTED_RELATIONSHIP = 18;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.GeneralizationImpl <em>Generalization</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.GeneralizationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getGeneralization()
	 * @generated
	 */
	int GENERALIZATION = 17;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModalElementImpl <em>Modal Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModalElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModalElement()
	 * @generated
	 */
	int MODAL_ELEMENT = 21;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AnnexSubclauseImpl <em>Annex Subclause</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AnnexSubclauseImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAnnexSubclause()
	 * @generated
	 */
	int ANNEX_SUBCLAUSE = 20;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModeFeatureImpl <em>Mode Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModeFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModeFeature()
	 * @generated
	 */
	int MODE_FEATURE = 23;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModeImpl <em>Mode</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMode()
	 * @generated
	 */
	int MODE = 22;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RefinableElementImpl <em>Refinable Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RefinableElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRefinableElement()
	 * @generated
	 */
	int REFINABLE_ELEMENT = 26;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.StructuralFeatureImpl <em>Structural Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.StructuralFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getStructuralFeature()
	 * @generated
	 */
	int STRUCTURAL_FEATURE = 25;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PrototypeImpl <em>Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPrototype()
	 * @generated
	 */
	int PROTOTYPE = 24;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PrototypeBindingImpl <em>Prototype Binding</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PrototypeBindingImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPrototypeBinding()
	 * @generated
	 */
	int PROTOTYPE_BINDING = 28;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ContainedNamedElementImpl <em>Contained Named Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ContainedNamedElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getContainedNamedElement()
	 * @generated
	 */
	int CONTAINED_NAMED_ELEMENT = 29;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ContainmentPathElementImpl <em>Containment Path Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ContainmentPathElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getContainmentPathElement()
	 * @generated
	 */
	int CONTAINMENT_PATH_ELEMENT = 30;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ArrayRangeImpl <em>Array Range</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ArrayRangeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getArrayRange()
	 * @generated
	 */
	int ARRAY_RANGE = 31;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModalPropertyValueImpl <em>Modal Property Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModalPropertyValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModalPropertyValue()
	 * @generated
	 */
	int MODAL_PROPERTY_VALUE = 32;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BehavioralFeatureImpl <em>Behavioral Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BehavioralFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBehavioralFeature()
	 * @generated
	 */
	int BEHAVIORAL_FEATURE = 33;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ArraySizeImpl <em>Array Size</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ArraySizeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getArraySize()
	 * @generated
	 */
	int ARRAY_SIZE = 35;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ArrayableElementImpl <em>Arrayable Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ArrayableElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getArrayableElement()
	 * @generated
	 */
	int ARRAYABLE_ELEMENT = 36;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentImplementationReferenceImpl <em>Component Implementation Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentImplementationReferenceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentImplementationReference()
	 * @generated
	 */
	int COMPONENT_IMPLEMENTATION_REFERENCE = 37;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentClassifierImpl <em>Component Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentClassifier()
	 * @generated
	 */
	int COMPONENT_CLASSIFIER = 39;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentImplementationImpl <em>Component Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentImplementation()
	 * @generated
	 */
	int COMPONENT_IMPLEMENTATION = 38;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubcomponentTypeImpl <em>Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubcomponentType()
	 * @generated
	 */
	int SUBCOMPONENT_TYPE = 40;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModeTransitionImpl <em>Mode Transition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModeTransitionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModeTransition()
	 * @generated
	 */
	int MODE_TRANSITION = 42;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModeTransitionTriggerImpl <em>Mode Transition Trigger</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModeTransitionTriggerImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModeTransitionTrigger()
	 * @generated
	 */
	int MODE_TRANSITION_TRIGGER = 43;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.TriggerPortImpl <em>Trigger Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.TriggerPortImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getTriggerPort()
	 * @generated
	 */
	int TRIGGER_PORT = 45;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ContextImpl <em>Context</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ContextImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getContext()
	 * @generated
	 */
	int CONTEXT = 44;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureImpl <em>Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeature()
	 * @generated
	 */
	int FEATURE = 47;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DirectedFeatureImpl <em>Directed Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DirectedFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDirectedFeature()
	 * @generated
	 */
	int DIRECTED_FEATURE = 61;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PortImpl <em>Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PortImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPort()
	 * @generated
	 */
	int PORT = 77;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ConnectionEndImpl <em>Connection End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ConnectionEndImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getConnectionEnd()
	 * @generated
	 */
	int CONNECTION_END = 49;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureConnectionEndImpl <em>Feature Connection End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureConnectionEndImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureConnectionEnd()
	 * @generated
	 */
	int FEATURE_CONNECTION_END = 48;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PortConnectionEndImpl <em>Port Connection End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PortConnectionEndImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPortConnectionEnd()
	 * @generated
	 */
	int PORT_CONNECTION_END = 73;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentTypeImpl <em>Component Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentType()
	 * @generated
	 */
	int COMPONENT_TYPE = 46;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FlowImpl <em>Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FlowImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlow()
	 * @generated
	 */
	int FLOW = 53;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FlowSpecificationImpl <em>Flow Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FlowSpecificationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlowSpecification()
	 * @generated
	 */
	int FLOW_SPECIFICATION = 51;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.TypeExtensionImpl <em>Type Extension</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.TypeExtensionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getTypeExtension()
	 * @generated
	 */
	int TYPE_EXTENSION = 58;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupImpl <em>Feature Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroup()
	 * @generated
	 */
	int FEATURE_GROUP = 59;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupConnectionEndImpl <em>Feature Group Connection End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupConnectionEndImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroupConnectionEnd()
	 * @generated
	 */
	int FEATURE_GROUP_CONNECTION_END = 62;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.CallContextImpl <em>Call Context</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.CallContextImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getCallContext()
	 * @generated
	 */
	int CALL_CONTEXT = 60;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupTypeImpl <em>Feature Group Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroupType()
	 * @generated
	 */
	int FEATURE_GROUP_TYPE = 64;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.GroupExtensionImpl <em>Group Extension</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.GroupExtensionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getGroupExtension()
	 * @generated
	 */
	int GROUP_EXTENSION = 65;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AccessImpl <em>Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AccessImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAccess()
	 * @generated
	 */
	int ACCESS = 67;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusAccessImpl <em>Bus Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusAccessImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBusAccess()
	 * @generated
	 */
	int BUS_ACCESS = 66;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AccessConnectionEndImpl <em>Access Connection End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AccessConnectionEndImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAccessConnectionEnd()
	 * @generated
	 */
	int ACCESS_CONNECTION_END = 68;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusClassifierImpl <em>Bus Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBusClassifier()
	 * @generated
	 */
	int BUS_CLASSIFIER = 174;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusImpl <em>Bus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBus()
	 * @generated
	 */
	int BUS = 69;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusSubcomponentTypeImpl <em>Bus Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBusSubcomponentType()
	 * @generated
	 */
	int BUS_SUBCOMPONENT_TYPE = 70;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataAccessImpl <em>Data Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataAccessImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataAccess()
	 * @generated
	 */
	int DATA_ACCESS = 71;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ParameterConnectionEndImpl <em>Parameter Connection End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ParameterConnectionEndImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getParameterConnectionEnd()
	 * @generated
	 */
	int PARAMETER_CONNECTION_END = 72;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EndToEndFlowElementImpl <em>End To End Flow Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EndToEndFlowElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEndToEndFlowElement()
	 * @generated
	 */
	int END_TO_END_FLOW_ELEMENT = 56;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FlowElementImpl <em>Flow Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FlowElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlowElement()
	 * @generated
	 */
	int FLOW_ELEMENT = 55;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FlowEndImpl <em>Flow End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FlowEndImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlowEnd()
	 * @generated
	 */
	int FLOW_END = 57;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataClassifierImpl <em>Data Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataClassifier()
	 * @generated
	 */
	int DATA_CLASSIFIER = 112;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataImpl <em>Data</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getData()
	 * @generated
	 */
	int DATA = 74;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataSubcomponentTypeImpl <em>Data Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataSubcomponentType()
	 * @generated
	 */
	int DATA_SUBCOMPONENT_TYPE = 75;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataPortImpl <em>Data Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataPortImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataPort()
	 * @generated
	 */
	int DATA_PORT = 76;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EventDataPortImpl <em>Event Data Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EventDataPortImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEventDataPort()
	 * @generated
	 */
	int EVENT_DATA_PORT = 78;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EventPortImpl <em>Event Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EventPortImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEventPort()
	 * @generated
	 */
	int EVENT_PORT = 79;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ParameterImpl <em>Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ParameterImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getParameter()
	 * @generated
	 */
	int PARAMETER = 80;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramAccessImpl <em>Subprogram Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramAccessImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramAccess()
	 * @generated
	 */
	int SUBPROGRAM_ACCESS = 81;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.CalledSubprogramImpl <em>Called Subprogram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.CalledSubprogramImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getCalledSubprogram()
	 * @generated
	 */
	int CALLED_SUBPROGRAM = 27;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramClassifierImpl <em>Subprogram Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramClassifier()
	 * @generated
	 */
	int SUBPROGRAM_CLASSIFIER = 115;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramSubcomponentTypeImpl <em>Subprogram Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramSubcomponentType()
	 * @generated
	 */
	int SUBPROGRAM_SUBCOMPONENT_TYPE = 83;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramImpl <em>Subprogram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogram()
	 * @generated
	 */
	int SUBPROGRAM = 82;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupAccessImpl <em>Subprogram Group Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupAccessImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroupAccess()
	 * @generated
	 */
	int SUBPROGRAM_GROUP_ACCESS = 84;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupClassifierImpl <em>Subprogram Group Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroupClassifier()
	 * @generated
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER = 192;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupSubcomponentTypeImpl <em>Subprogram Group Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroupSubcomponentType()
	 * @generated
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE = 86;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupImpl <em>Subprogram Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroup()
	 * @generated
	 */
	int SUBPROGRAM_GROUP = 85;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractFeatureImpl <em>Abstract Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractFeature()
	 * @generated
	 */
	int ABSTRACT_FEATURE = 87;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubcomponentImpl <em>Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubcomponent()
	 * @generated
	 */
	int SUBCOMPONENT = 90;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentPrototypeImpl <em>Component Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentPrototype()
	 * @generated
	 */
	int COMPONENT_PROTOTYPE = 50;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModeBindingImpl <em>Mode Binding</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModeBindingImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModeBinding()
	 * @generated
	 */
	int MODE_BINDING = 91;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractClassifierImpl <em>Abstract Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractClassifier()
	 * @generated
	 */
	int ABSTRACT_CLASSIFIER = 140;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractImpl <em>Abstract</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstract()
	 * @generated
	 */
	int ABSTRACT = 101;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractSubcomponentTypeImpl <em>Abstract Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractSubcomponentType()
	 * @generated
	 */
	int ABSTRACT_SUBCOMPONENT_TYPE = 102;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FlowImplementationImpl <em>Flow Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FlowImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlowImplementation()
	 * @generated
	 */
	int FLOW_IMPLEMENTATION = 92;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModalPathImpl <em>Modal Path</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModalPathImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModalPath()
	 * @generated
	 */
	int MODAL_PATH = 54;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FlowSegmentImpl <em>Flow Segment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FlowSegmentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlowSegment()
	 * @generated
	 */
	int FLOW_SEGMENT = 93;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ConnectionImpl <em>Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ConnectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getConnection()
	 * @generated
	 */
	int CONNECTION = 94;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ConnectedElementImpl <em>Connected Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ConnectedElementImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getConnectedElement()
	 * @generated
	 */
	int CONNECTED_ELEMENT = 95;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ImplementationExtensionImpl <em>Implementation Extension</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ImplementationExtensionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getImplementationExtension()
	 * @generated
	 */
	int IMPLEMENTATION_EXTENSION = 96;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RealizationImpl <em>Realization</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RealizationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRealization()
	 * @generated
	 */
	int REALIZATION = 97;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EndToEndFlowImpl <em>End To End Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EndToEndFlowImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEndToEndFlow()
	 * @generated
	 */
	int END_TO_END_FLOW = 98;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EndToEndFlowSegmentImpl <em>End To End Flow Segment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EndToEndFlowSegmentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEndToEndFlowSegment()
	 * @generated
	 */
	int END_TO_END_FLOW_SEGMENT = 99;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractSubcomponentImpl <em>Abstract Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractSubcomponent()
	 * @generated
	 */
	int ABSTRACT_SUBCOMPONENT = 100;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AccessConnectionImpl <em>Access Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AccessConnectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAccessConnection()
	 * @generated
	 */
	int ACCESS_CONNECTION = 103;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ParameterConnectionImpl <em>Parameter Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ParameterConnectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getParameterConnection()
	 * @generated
	 */
	int PARAMETER_CONNECTION = 104;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PortConnectionImpl <em>Port Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PortConnectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPortConnection()
	 * @generated
	 */
	int PORT_CONNECTION = 105;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureConnectionImpl <em>Feature Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureConnectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureConnection()
	 * @generated
	 */
	int FEATURE_CONNECTION = 106;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupConnectionImpl <em>Feature Group Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupConnectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroupConnection()
	 * @generated
	 */
	int FEATURE_GROUP_CONNECTION = 107;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AnnexLibraryImpl <em>Annex Library</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AnnexLibraryImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAnnexLibrary()
	 * @generated
	 */
	int ANNEX_LIBRARY = 116;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DefaultAnnexLibraryImpl <em>Default Annex Library</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DefaultAnnexLibraryImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDefaultAnnexLibrary()
	 * @generated
	 */
	int DEFAULT_ANNEX_LIBRARY = 117;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DefaultAnnexSubclauseImpl <em>Default Annex Subclause</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DefaultAnnexSubclauseImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDefaultAnnexSubclause()
	 * @generated
	 */
	int DEFAULT_ANNEX_SUBCLAUSE = 118;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PackageSectionImpl <em>Package Section</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PackageSectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPackageSection()
	 * @generated
	 */
	int PACKAGE_SECTION = 120;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PublicPackageSectionImpl <em>Public Package Section</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PublicPackageSectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPublicPackageSection()
	 * @generated
	 */
	int PUBLIC_PACKAGE_SECTION = 119;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PackageRenameImpl <em>Package Rename</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PackageRenameImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPackageRename()
	 * @generated
	 */
	int PACKAGE_RENAME = 121;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ModelUnitImpl <em>Model Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ModelUnitImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getModelUnit()
	 * @generated
	 */
	int MODEL_UNIT = 123;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AadlPackageImpl <em>Aadl Package</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AadlPackageImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAadlPackage()
	 * @generated
	 */
	int AADL_PACKAGE = 122;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PrivatePackageSectionImpl <em>Private Package Section</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PrivatePackageSectionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPrivatePackageSection()
	 * @generated
	 */
	int PRIVATE_PACKAGE_SECTION = 124;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentTypeRenameImpl <em>Component Type Rename</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentTypeRenameImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentTypeRename()
	 * @generated
	 */
	int COMPONENT_TYPE_RENAME = 125;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupTypeRenameImpl <em>Feature Group Type Rename</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupTypeRenameImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroupTypeRename()
	 * @generated
	 */
	int FEATURE_GROUP_TYPE_RENAME = 126;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractTypeImpl <em>Abstract Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractType()
	 * @generated
	 */
	int ABSTRACT_TYPE = 139;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BehavioredImplementationImpl <em>Behaviored Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BehavioredImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBehavioredImplementation()
	 * @generated
	 */
	int BEHAVIORED_IMPLEMENTATION = 138;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractImplementationImpl <em>Abstract Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractImplementation()
	 * @generated
	 */
	int ABSTRACT_IMPLEMENTATION = 159;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramCallSequenceImpl <em>Subprogram Call Sequence</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramCallSequenceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramCallSequence()
	 * @generated
	 */
	int SUBPROGRAM_CALL_SEQUENCE = 136;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusSubcomponentImpl <em>Bus Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBusSubcomponent()
	 * @generated
	 */
	int BUS_SUBCOMPONENT = 160;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataSubcomponentImpl <em>Data Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataSubcomponent()
	 * @generated
	 */
	int DATA_SUBCOMPONENT = 161;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DeviceSubcomponentImpl <em>Device Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DeviceSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDeviceSubcomponent()
	 * @generated
	 */
	int DEVICE_SUBCOMPONENT = 162;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DeviceImpl <em>Device</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DeviceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDevice()
	 * @generated
	 */
	int DEVICE = 156;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DeviceClassifierImpl <em>Device Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DeviceClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDeviceClassifier()
	 * @generated
	 */
	int DEVICE_CLASSIFIER = 181;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MemorySubcomponentImpl <em>Memory Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MemorySubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMemorySubcomponent()
	 * @generated
	 */
	int MEMORY_SUBCOMPONENT = 163;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MemoryImpl <em>Memory</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MemoryImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMemory()
	 * @generated
	 */
	int MEMORY = 154;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MemoryClassifierImpl <em>Memory Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MemoryClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMemoryClassifier()
	 * @generated
	 */
	int MEMORY_CLASSIFIER = 185;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessSubcomponentImpl <em>Process Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessSubcomponent()
	 * @generated
	 */
	int PROCESS_SUBCOMPONENT = 164;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessImpl <em>Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcess()
	 * @generated
	 */
	int PROCESS = 152;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessClassifierImpl <em>Process Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessClassifier()
	 * @generated
	 */
	int PROCESS_CLASSIFIER = 204;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorSubcomponentImpl <em>Processor Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessorSubcomponent()
	 * @generated
	 */
	int PROCESSOR_SUBCOMPONENT = 165;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorImpl <em>Processor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessor()
	 * @generated
	 */
	int PROCESSOR = 158;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorClassifierImpl <em>Processor Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessorClassifier()
	 * @generated
	 */
	int PROCESSOR_CLASSIFIER = 200;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SystemSubcomponentImpl <em>System Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SystemSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSystemSubcomponent()
	 * @generated
	 */
	int SYSTEM_SUBCOMPONENT = 166;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SystemImpl <em>System</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SystemImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSystem()
	 * @generated
	 */
	int SYSTEM = 150;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SystemClassifierImpl <em>System Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SystemClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSystemClassifier()
	 * @generated
	 */
	int SYSTEM_CLASSIFIER = 196;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramSubcomponentImpl <em>Subprogram Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramSubcomponent()
	 * @generated
	 */
	int SUBPROGRAM_SUBCOMPONENT = 167;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupSubcomponentImpl <em>Subprogram Group Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroupSubcomponent()
	 * @generated
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT = 168;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadSubcomponentImpl <em>Thread Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadSubcomponent()
	 * @generated
	 */
	int THREAD_SUBCOMPONENT = 169;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadImpl <em>Thread</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThread()
	 * @generated
	 */
	int THREAD = 148;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadClassifierImpl <em>Thread Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadClassifier()
	 * @generated
	 */
	int THREAD_CLASSIFIER = 208;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadGroupSubcomponentImpl <em>Thread Group Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadGroupSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadGroupSubcomponent()
	 * @generated
	 */
	int THREAD_GROUP_SUBCOMPONENT = 170;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadGroupImpl <em>Thread Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadGroupImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadGroup()
	 * @generated
	 */
	int THREAD_GROUP = 146;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadGroupClassifierImpl <em>Thread Group Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadGroupClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadGroupClassifier()
	 * @generated
	 */
	int THREAD_GROUP_CLASSIFIER = 212;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualBusSubcomponentImpl <em>Virtual Bus Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualBusSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualBusSubcomponent()
	 * @generated
	 */
	int VIRTUAL_BUS_SUBCOMPONENT = 171;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualBusImpl <em>Virtual Bus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualBusImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualBus()
	 * @generated
	 */
	int VIRTUAL_BUS = 144;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualBusClassifierImpl <em>Virtual Bus Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualBusClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualBusClassifier()
	 * @generated
	 */
	int VIRTUAL_BUS_CLASSIFIER = 216;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualProcessorSubcomponentImpl <em>Virtual Processor Subcomponent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualProcessorSubcomponentImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualProcessorSubcomponent()
	 * @generated
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT = 172;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualProcessorImpl <em>Virtual Processor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualProcessorImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualProcessor()
	 * @generated
	 */
	int VIRTUAL_PROCESSOR = 142;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualProcessorClassifierImpl <em>Virtual Processor Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualProcessorClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualProcessorClassifier()
	 * @generated
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER = 220;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusTypeImpl <em>Bus Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBusType()
	 * @generated
	 */
	int BUS_TYPE = 175;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusImplementationImpl <em>Bus Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBusImplementation()
	 * @generated
	 */
	int BUS_IMPLEMENTATION = 176;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataTypeImpl <em>Data Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataType()
	 * @generated
	 */
	int DATA_TYPE = 178;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataImplementationImpl <em>Data Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataImplementation()
	 * @generated
	 */
	int DATA_IMPLEMENTATION = 179;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DeviceTypeImpl <em>Device Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DeviceTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDeviceType()
	 * @generated
	 */
	int DEVICE_TYPE = 182;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DeviceImplementationImpl <em>Device Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DeviceImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDeviceImplementation()
	 * @generated
	 */
	int DEVICE_IMPLEMENTATION = 183;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MemoryTypeImpl <em>Memory Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MemoryTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMemoryType()
	 * @generated
	 */
	int MEMORY_TYPE = 186;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MemoryImplementationImpl <em>Memory Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MemoryImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMemoryImplementation()
	 * @generated
	 */
	int MEMORY_IMPLEMENTATION = 187;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessTypeImpl <em>Process Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessType()
	 * @generated
	 */
	int PROCESS_TYPE = 205;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorTypeImpl <em>Processor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessorType()
	 * @generated
	 */
	int PROCESSOR_TYPE = 201;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessImplementationImpl <em>Process Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessImplementation()
	 * @generated
	 */
	int PROCESS_IMPLEMENTATION = 206;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorImplementationImpl <em>Processor Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessorImplementation()
	 * @generated
	 */
	int PROCESSOR_IMPLEMENTATION = 202;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramTypeImpl <em>Subprogram Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramType()
	 * @generated
	 */
	int SUBPROGRAM_TYPE = 189;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramImplementationImpl <em>Subprogram Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramImplementation()
	 * @generated
	 */
	int SUBPROGRAM_IMPLEMENTATION = 190;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupTypeImpl <em>Subprogram Group Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroupType()
	 * @generated
	 */
	int SUBPROGRAM_GROUP_TYPE = 193;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupImplementationImpl <em>Subprogram Group Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroupImplementation()
	 * @generated
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION = 194;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SystemTypeImpl <em>System Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SystemTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSystemType()
	 * @generated
	 */
	int SYSTEM_TYPE = 197;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SystemImplementationImpl <em>System Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SystemImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSystemImplementation()
	 * @generated
	 */
	int SYSTEM_IMPLEMENTATION = 198;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadTypeImpl <em>Thread Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadType()
	 * @generated
	 */
	int THREAD_TYPE = 209;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadImplementationImpl <em>Thread Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadImplementation()
	 * @generated
	 */
	int THREAD_IMPLEMENTATION = 210;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadGroupTypeImpl <em>Thread Group Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadGroupTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadGroupType()
	 * @generated
	 */
	int THREAD_GROUP_TYPE = 213;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadGroupImplementationImpl <em>Thread Group Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadGroupImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadGroupImplementation()
	 * @generated
	 */
	int THREAD_GROUP_IMPLEMENTATION = 214;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualBusTypeImpl <em>Virtual Bus Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualBusTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualBusType()
	 * @generated
	 */
	int VIRTUAL_BUS_TYPE = 217;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualBusImplementationImpl <em>Virtual Bus Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualBusImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualBusImplementation()
	 * @generated
	 */
	int VIRTUAL_BUS_IMPLEMENTATION = 218;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualProcessorTypeImpl <em>Virtual Processor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualProcessorTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualProcessorType()
	 * @generated
	 */
	int VIRTUAL_PROCESSOR_TYPE = 221;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualProcessorImplementationImpl <em>Virtual Processor Implementation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualProcessorImplementationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualProcessorImplementation()
	 * @generated
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION = 222;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentPrototypeBindingImpl <em>Component Prototype Binding</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentPrototypeBindingImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentPrototypeBinding()
	 * @generated
	 */
	int COMPONENT_PROTOTYPE_BINDING = 127;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComponentPrototypeActualImpl <em>Component Prototype Actual</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComponentPrototypeActualImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentPrototypeActual()
	 * @generated
	 */
	int COMPONENT_PROTOTYPE_ACTUAL = 128;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupPrototypeImpl <em>Feature Group Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroupPrototype()
	 * @generated
	 */
	int FEATURE_GROUP_PROTOTYPE = 89;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupPrototypeBindingImpl <em>Feature Group Prototype Binding</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupPrototypeBindingImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroupPrototypeBinding()
	 * @generated
	 */
	int FEATURE_GROUP_PROTOTYPE_BINDING = 129;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureGroupPrototypeActualImpl <em>Feature Group Prototype Actual</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureGroupPrototypeActualImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureGroupPrototypeActual()
	 * @generated
	 */
	int FEATURE_GROUP_PROTOTYPE_ACTUAL = 130;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeaturePrototypeImpl <em>Feature Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeaturePrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeaturePrototype()
	 * @generated
	 */
	int FEATURE_PROTOTYPE = 88;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeaturePrototypeBindingImpl <em>Feature Prototype Binding</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeaturePrototypeBindingImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeaturePrototypeBinding()
	 * @generated
	 */
	int FEATURE_PROTOTYPE_BINDING = 132;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeaturePrototypeActualImpl <em>Feature Prototype Actual</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeaturePrototypeActualImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeaturePrototypeActual()
	 * @generated
	 */
	int FEATURE_PROTOTYPE_ACTUAL = 131;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AccessSpecificationImpl <em>Access Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AccessSpecificationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAccessSpecification()
	 * @generated
	 */
	int ACCESS_SPECIFICATION = 133;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PortSpecificationImpl <em>Port Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PortSpecificationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPortSpecification()
	 * @generated
	 */
	int PORT_SPECIFICATION = 134;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeaturePrototypeReferenceImpl <em>Feature Prototype Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeaturePrototypeReferenceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeaturePrototypeReference()
	 * @generated
	 */
	int FEATURE_PROTOTYPE_REFERENCE = 135;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramCallImpl <em>Subprogram Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramCallImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramCall()
	 * @generated
	 */
	int SUBPROGRAM_CALL = 137;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DeviceSubcomponentTypeImpl <em>Device Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DeviceSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDeviceSubcomponentType()
	 * @generated
	 */
	int DEVICE_SUBCOMPONENT_TYPE = 155;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MemorySubcomponentTypeImpl <em>Memory Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MemorySubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMemorySubcomponentType()
	 * @generated
	 */
	int MEMORY_SUBCOMPONENT_TYPE = 153;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessSubcomponentTypeImpl <em>Process Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessSubcomponentType()
	 * @generated
	 */
	int PROCESS_SUBCOMPONENT_TYPE = 151;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorSubcomponentTypeImpl <em>Processor Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessorSubcomponentType()
	 * @generated
	 */
	int PROCESSOR_SUBCOMPONENT_TYPE = 157;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SystemSubcomponentTypeImpl <em>System Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SystemSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSystemSubcomponentType()
	 * @generated
	 */
	int SYSTEM_SUBCOMPONENT_TYPE = 149;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadSubcomponentTypeImpl <em>Thread Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadSubcomponentType()
	 * @generated
	 */
	int THREAD_SUBCOMPONENT_TYPE = 147;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadGroupSubcomponentTypeImpl <em>Thread Group Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadGroupSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadGroupSubcomponentType()
	 * @generated
	 */
	int THREAD_GROUP_SUBCOMPONENT_TYPE = 145;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualProcessorSubcomponentTypeImpl <em>Virtual Processor Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualProcessorSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualProcessorSubcomponentType()
	 * @generated
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE = 141;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractPrototypeImpl <em>Abstract Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractPrototype()
	 * @generated
	 */
	int ABSTRACT_PROTOTYPE = 173;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BusPrototypeImpl <em>Bus Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BusPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBusPrototype()
	 * @generated
	 */
	int BUS_PROTOTYPE = 177;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DataPrototypeImpl <em>Data Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DataPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDataPrototype()
	 * @generated
	 */
	int DATA_PROTOTYPE = 180;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.DevicePrototypeImpl <em>Device Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.DevicePrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDevicePrototype()
	 * @generated
	 */
	int DEVICE_PROTOTYPE = 184;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.MemoryPrototypeImpl <em>Memory Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.MemoryPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getMemoryPrototype()
	 * @generated
	 */
	int MEMORY_PROTOTYPE = 188;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramPrototypeImpl <em>Subprogram Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramPrototype()
	 * @generated
	 */
	int SUBPROGRAM_PROTOTYPE = 191;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramGroupPrototypeImpl <em>Subprogram Group Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramGroupPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramGroupPrototype()
	 * @generated
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE = 195;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SystemPrototypeImpl <em>System Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SystemPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSystemPrototype()
	 * @generated
	 */
	int SYSTEM_PROTOTYPE = 199;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorPrototypeImpl <em>Processor Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessorPrototype()
	 * @generated
	 */
	int PROCESSOR_PROTOTYPE = 203;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessPrototypeImpl <em>Process Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessPrototype()
	 * @generated
	 */
	int PROCESS_PROTOTYPE = 207;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadPrototypeImpl <em>Thread Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadPrototype()
	 * @generated
	 */
	int THREAD_PROTOTYPE = 211;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ThreadGroupPrototypeImpl <em>Thread Group Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ThreadGroupPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getThreadGroupPrototype()
	 * @generated
	 */
	int THREAD_GROUP_PROTOTYPE = 215;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualBusPrototypeImpl <em>Virtual Bus Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualBusPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualBusPrototype()
	 * @generated
	 */
	int VIRTUAL_BUS_PROTOTYPE = 219;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualProcessorPrototypeImpl <em>Virtual Processor Prototype</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualProcessorPrototypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualProcessorPrototype()
	 * @generated
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE = 223;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BasicPropertyAssociationImpl <em>Basic Property Association</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BasicPropertyAssociationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBasicPropertyAssociation()
	 * @generated
	 */
	int BASIC_PROPERTY_ASSOCIATION = 224;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertyConstantImpl <em>Property Constant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertyConstantImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPropertyConstant()
	 * @generated
	 */
	int PROPERTY_CONSTANT = 225;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AbstractNamedValueImpl <em>Abstract Named Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AbstractNamedValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAbstractNamedValue()
	 * @generated
	 */
	int ABSTRACT_NAMED_VALUE = 9;

	/**
	 * The number of structural features of the '<em>Abstract Named Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_NAMED_VALUE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ArraySizePropertyImpl <em>Array Size Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ArraySizePropertyImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getArraySizeProperty()
	 * @generated
	 */
	int ARRAY_SIZE_PROPERTY = 10;

	/**
	 * The number of structural features of the '<em>Array Size Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_SIZE_PROPERTY_FEATURE_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EXPRESSION__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EXPRESSION__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The number of structural features of the '<em>Property Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EXPRESSION_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_OWNER__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_OWNER__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The number of structural features of the '<em>Property Owner</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_OWNER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METACLASS_REFERENCE__OWNED_ELEMENT = PROPERTY_OWNER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METACLASS_REFERENCE__OWNED_COMMENT = PROPERTY_OWNER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Annex Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METACLASS_REFERENCE__ANNEX_NAME = PROPERTY_OWNER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Metaclass Name</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METACLASS_REFERENCE__METACLASS_NAME = PROPERTY_OWNER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Metaclass Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METACLASS_REFERENCE_FEATURE_COUNT = PROPERTY_OWNER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE__OWNED_MEMBER = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE__MEMBER = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Namespace</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__OWNED_ELEMENT = NAMESPACE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__OWNED_COMMENT = NAMESPACE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__NAME = NAMESPACE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__QUALIFIED_NAME = NAMESPACE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = NAMESPACE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__OWNED_MEMBER = NAMESPACE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__MEMBER = NAMESPACE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__CLASSIFIER_FEATURE = NAMESPACE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__INHERITED_MEMBER = NAMESPACE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__GENERALIZATION = NAMESPACE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__GENERAL = NAMESPACE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = NAMESPACE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__OWNED_PROTOTYPE = NAMESPACE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__OWNED_PROTOTYPE_BINDING = NAMESPACE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__NO_PROTOTYPES = NAMESPACE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__NO_ANNEXES = NAMESPACE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER__NO_PROPERTIES = NAMESPACE_FEATURE_COUNT + 9;

	/**
	 * The number of structural features of the '<em>Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE_COUNT = NAMESPACE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE__FEATURING_CLASSIFIER = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Classifier Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_FEATURE_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Related Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__RELATED_ELEMENT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_RELATIONSHIP__OWNED_ELEMENT = RELATIONSHIP__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_RELATIONSHIP__OWNED_COMMENT = RELATIONSHIP__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Related Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_RELATIONSHIP__RELATED_ELEMENT = RELATIONSHIP__RELATED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_RELATIONSHIP__SOURCE = RELATIONSHIP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_RELATIONSHIP__TARGET = RELATIONSHIP_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Directed Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_RELATIONSHIP_FEATURE_COUNT = RELATIONSHIP_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION__OWNED_ELEMENT = DIRECTED_RELATIONSHIP__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION__OWNED_COMMENT = DIRECTED_RELATIONSHIP__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Related Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION__RELATED_ELEMENT = DIRECTED_RELATIONSHIP__RELATED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION__SOURCE = DIRECTED_RELATIONSHIP__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION__TARGET = DIRECTED_RELATIONSHIP__TARGET;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION__GENERAL = DIRECTED_RELATIONSHIP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Specific</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION__SPECIFIC = DIRECTED_RELATIONSHIP_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Generalization</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_FEATURE_COUNT = DIRECTED_RELATIONSHIP_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_ELEMENT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_ELEMENT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_ELEMENT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_ELEMENT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_ELEMENT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_ELEMENT__IN_MODE = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Modal Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_ELEMENT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_SUBCLAUSE__OWNED_ELEMENT = MODAL_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_SUBCLAUSE__OWNED_COMMENT = MODAL_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_SUBCLAUSE__NAME = MODAL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_SUBCLAUSE__QUALIFIED_NAME = MODAL_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_SUBCLAUSE__OWNED_PROPERTY_ASSOCIATION = MODAL_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_SUBCLAUSE__IN_MODE = MODAL_ELEMENT__IN_MODE;

	/**
	 * The number of structural features of the '<em>Annex Subclause</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_SUBCLAUSE_FEATURE_COUNT = MODAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE__OWNED_ELEMENT = CLASSIFIER_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE__OWNED_COMMENT = CLASSIFIER_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE__NAME = CLASSIFIER_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE__QUALIFIED_NAME = CLASSIFIER_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE__OWNED_PROPERTY_ASSOCIATION = CLASSIFIER_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE__FEATURING_CLASSIFIER = CLASSIFIER_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Mode Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE_FEATURE_COUNT = CLASSIFIER_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__OWNED_ELEMENT = MODE_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__OWNED_COMMENT = MODE_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__NAME = MODE_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__QUALIFIED_NAME = MODE_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__OWNED_PROPERTY_ASSOCIATION = MODE_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__FEATURING_CLASSIFIER = MODE_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Initial</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__INITIAL = MODE_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__DERIVED = MODE_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Mode</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE_COUNT = MODE_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT__REFINEMENT_CONTEXT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT__REFINED_ELEMENT = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Refinable Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFINABLE_ELEMENT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__OWNED_ELEMENT = REFINABLE_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__OWNED_COMMENT = REFINABLE_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__NAME = REFINABLE_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__QUALIFIED_NAME = REFINABLE_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION = REFINABLE_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__REFINEMENT_CONTEXT = REFINABLE_ELEMENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__REFINED_ELEMENT = REFINABLE_ELEMENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE__FEATURING_CLASSIFIER = REFINABLE_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Structural Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURAL_FEATURE_FEATURE_COUNT = REFINABLE_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__OWNED_ELEMENT = STRUCTURAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__OWNED_COMMENT = STRUCTURAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__NAME = STRUCTURAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__QUALIFIED_NAME = STRUCTURAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__REFINEMENT_CONTEXT = STRUCTURAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__REFINED_ELEMENT = STRUCTURAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__FEATURING_CLASSIFIER = STRUCTURAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE__REFINED = STRUCTURAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE_FEATURE_COUNT = STRUCTURAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureClassifierImpl <em>Feature Classifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureClassifierImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureClassifier()
	 * @generated
	 */
	int FEATURE_CLASSIFIER = 41;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FeatureTypeImpl <em>Feature Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FeatureTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFeatureType()
	 * @generated
	 */
	int FEATURE_TYPE = 63;

	/**
	 * The number of structural features of the '<em>Called Subprogram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLED_SUBPROGRAM_FEATURE_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE_BINDING__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE_BINDING__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Formal</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE_BINDING__FORMAL = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Prototype Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOTYPE_BINDING_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINED_NAMED_ELEMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINED_NAMED_ELEMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Containment Path Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINED_NAMED_ELEMENT__CONTAINMENT_PATH_ELEMENT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Contained Named Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINED_NAMED_ELEMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_PATH_ELEMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_PATH_ELEMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Range</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_PATH_ELEMENT__ARRAY_RANGE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Named Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_PATH_ELEMENT__NAMED_ELEMENT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Annex Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_PATH_ELEMENT__ANNEX_NAME = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Containment Path Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_PATH_ELEMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RANGE__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RANGE__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Lower Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RANGE__LOWER_BOUND = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RANGE__UPPER_BOUND = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Array Range</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RANGE_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE__OWNED_ELEMENT = MODAL_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE__OWNED_COMMENT = MODAL_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE__NAME = MODAL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE__QUALIFIED_NAME = MODAL_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE__OWNED_PROPERTY_ASSOCIATION = MODAL_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE__IN_MODE = MODAL_ELEMENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Owned Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE__OWNED_VALUE = MODAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Modal Property Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PROPERTY_VALUE_FEATURE_COUNT = MODAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORAL_FEATURE__OWNED_ELEMENT = CLASSIFIER_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORAL_FEATURE__OWNED_COMMENT = CLASSIFIER_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORAL_FEATURE__NAME = CLASSIFIER_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORAL_FEATURE__QUALIFIED_NAME = CLASSIFIER_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORAL_FEATURE__OWNED_PROPERTY_ASSOCIATION = CLASSIFIER_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORAL_FEATURE__FEATURING_CLASSIFIER = CLASSIFIER_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Behavioral Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORAL_FEATURE_FEATURE_COUNT = CLASSIFIER_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ArrayDimensionImpl <em>Array Dimension</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ArrayDimensionImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getArrayDimension()
	 * @generated
	 */
	int ARRAY_DIMENSION = 34;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_DIMENSION__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_DIMENSION__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Size</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_DIMENSION__SIZE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Array Dimension</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_DIMENSION_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_SIZE__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_SIZE__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_SIZE__SIZE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Size Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_SIZE__SIZE_PROPERTY = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Array Size</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_SIZE_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYABLE_ELEMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYABLE_ELEMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYABLE_ELEMENT__ARRAY_DIMENSION = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Arrayable Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYABLE_ELEMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION_REFERENCE__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION_REFERENCE__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Implementation</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION_REFERENCE__IMPLEMENTATION = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION_REFERENCE__OWNED_PROTOTYPE_BINDING = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Component Implementation Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION_REFERENCE_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_ELEMENT = CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_COMMENT = CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__NAME = CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__QUALIFIED_NAME = CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_MEMBER = CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__MEMBER = CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE = CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__INHERITED_MEMBER = CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__GENERALIZATION = CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__GENERAL = CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_PROTOTYPE = CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING = CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__NO_PROTOTYPES = CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__NO_ANNEXES = CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__NO_PROPERTIES = CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_MODE = CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION = CLASSIFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__DERIVED_MODES = CLASSIFIER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__NO_FLOWS = CLASSIFIER_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER__NO_MODES = CLASSIFIER_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Component Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CLASSIFIER_FEATURE_COUNT = CLASSIFIER_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__TYPE = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__EXTENDED = COMPONENT_CLASSIFIER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_CLASSIFIER_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_CLASSIFIER_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_CLASSIFIER_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__NO_CALLS = COMPONENT_CLASSIFIER_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_CLASSIFIER_FEATURE_COUNT + 17;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_CLASSIFIER_FEATURE_COUNT + 18;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_CLASSIFIER_FEATURE_COUNT + 19;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_CLASSIFIER_FEATURE_COUNT + 20;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_CLASSIFIER_FEATURE_COUNT + 21;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_CLASSIFIER_FEATURE_COUNT + 22;

	/**
	 * The number of structural features of the '<em>Component Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 23;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT_TYPE__OWNED_ELEMENT = TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT_TYPE__OWNED_COMMENT = TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT_TYPE__NAME = TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT_TYPE__QUALIFIED_NAME = TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT_TYPE_FEATURE_COUNT = TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Feature Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CLASSIFIER_FEATURE_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__OWNED_ELEMENT = MODE_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__OWNED_COMMENT = MODE_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__NAME = MODE_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__QUALIFIED_NAME = MODE_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__OWNED_PROPERTY_ASSOCIATION = MODE_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__FEATURING_CLASSIFIER = MODE_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__SOURCE = MODE_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__DESTINATION = MODE_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Trigger</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION__OWNED_TRIGGER = MODE_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Mode Transition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION_FEATURE_COUNT = MODE_FEATURE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION_TRIGGER__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION_TRIGGER__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION_TRIGGER__CONTEXT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Trigger Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION_TRIGGER__TRIGGER_PORT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Mode Transition Trigger</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_TRANSITION_TRIGGER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.FlowFeatureImpl <em>Flow Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.FlowFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlowFeature()
	 * @generated
	 */
	int FLOW_FEATURE = 52;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Context</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_PORT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_PORT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_PORT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_PORT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_PORT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ProcessorFeatureImpl <em>Processor Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ProcessorFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getProcessorFeature()
	 * @generated
	 */
	int PROCESSOR_FEATURE = 108;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.InternalFeatureImpl <em>Internal Feature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.InternalFeatureImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getInternalFeature()
	 * @generated
	 */
	int INTERNAL_FEATURE = 109;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EventSourceImpl <em>Event Source</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EventSourceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEventSource()
	 * @generated
	 */
	int EVENT_SOURCE = 110;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EventDataSourceImpl <em>Event Data Source</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EventDataSourceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEventDataSource()
	 * @generated
	 */
	int EVENT_DATA_SOURCE = 111;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PortProxyImpl <em>Port Proxy</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PortProxyImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPortProxy()
	 * @generated
	 */
	int PORT_PROXY = 113;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.SubprogramProxyImpl <em>Subprogram Proxy</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.SubprogramProxyImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getSubprogramProxy()
	 * @generated
	 */
	int SUBPROGRAM_PROXY = 114;

	/**
	 * The number of structural features of the '<em>Trigger Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_PORT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_FEATURE = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__EXTENDED = COMPONENT_CLASSIFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_EXTENSION = COMPONENT_CLASSIFIER_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_FEATURE_GROUP = COMPONENT_CLASSIFIER_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_CLASSIFIER_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NO_FEATURES = COMPONENT_CLASSIFIER_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Component Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__OWNED_ELEMENT = STRUCTURAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__OWNED_COMMENT = STRUCTURAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__NAME = STRUCTURAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__QUALIFIED_NAME = STRUCTURAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__OWNED_PROPERTY_ASSOCIATION = STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__REFINEMENT_CONTEXT = STRUCTURAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__REFINED_ELEMENT = STRUCTURAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__FEATURING_CLASSIFIER = STRUCTURAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__ARRAY_DIMENSION = STRUCTURAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__PROTOTYPE = STRUCTURAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__FEATURE_CLASSIFIER = STRUCTURAL_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__REFINED = STRUCTURAL_FEATURE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE__CLASSIFIER = STRUCTURAL_FEATURE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_FEATURE_COUNT = STRUCTURAL_FEATURE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_END__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_END__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_END__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_END__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_END__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Connection End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_END_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION_END__OWNED_ELEMENT = CONNECTION_END__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION_END__OWNED_COMMENT = CONNECTION_END__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION_END__NAME = CONNECTION_END__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION_END__QUALIFIED_NAME = CONNECTION_END__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION_END__OWNED_PROPERTY_ASSOCIATION = CONNECTION_END__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Feature Connection End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION_END_FEATURE_COUNT = CONNECTION_END_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__OWNED_ELEMENT = PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__OWNED_COMMENT = PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__NAME = PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__QUALIFIED_NAME = PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT = PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__REFINED_ELEMENT = PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER = PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__REFINED = PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__ARRAY = PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER = PROTOTYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Component Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_FEATURE_COUNT = PROTOTYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__OWNED_ELEMENT = STRUCTURAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__OWNED_COMMENT = STRUCTURAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__NAME = STRUCTURAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__QUALIFIED_NAME = STRUCTURAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__OWNED_PROPERTY_ASSOCIATION = STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__REFINEMENT_CONTEXT = STRUCTURAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__REFINED_ELEMENT = STRUCTURAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE__FEATURING_CLASSIFIER = STRUCTURAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Flow Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE_FEATURE_COUNT = STRUCTURAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__OWNED_ELEMENT = FLOW_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__OWNED_COMMENT = FLOW_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__NAME = FLOW_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__QUALIFIED_NAME = FLOW_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__OWNED_PROPERTY_ASSOCIATION = FLOW_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__REFINEMENT_CONTEXT = FLOW_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__REFINED_ELEMENT = FLOW_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__FEATURING_CLASSIFIER = FLOW_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__IN_MODE = FLOW_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__IN_MODE_OR_TRANSITION = FLOW_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__REFINED = FLOW_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__KIND = FLOW_FEATURE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Out End</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__OUT_END = FLOW_FEATURE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>In End</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION__IN_END = FLOW_FEATURE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Flow Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SPECIFICATION_FEATURE_COUNT = FLOW_FEATURE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH__OWNED_ELEMENT = MODAL_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH__OWNED_COMMENT = MODAL_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH__NAME = MODAL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH__QUALIFIED_NAME = MODAL_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH__OWNED_PROPERTY_ASSOCIATION = MODAL_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH__IN_MODE = MODAL_ELEMENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH__IN_MODE_OR_TRANSITION = MODAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Modal Path</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODAL_PATH_FEATURE_COUNT = MODAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_ELEMENT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_ELEMENT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_ELEMENT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_ELEMENT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_ELEMENT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>End To End Flow Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_ELEMENT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ELEMENT__OWNED_ELEMENT = END_TO_END_FLOW_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ELEMENT__OWNED_COMMENT = END_TO_END_FLOW_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ELEMENT__NAME = END_TO_END_FLOW_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ELEMENT__QUALIFIED_NAME = END_TO_END_FLOW_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ELEMENT__OWNED_PROPERTY_ASSOCIATION = END_TO_END_FLOW_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Flow Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ELEMENT_FEATURE_COUNT = END_TO_END_FLOW_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_END__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_END__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_END__CONTEXT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Feature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_END__FEATURE = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Flow End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_END_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__OWNED_ELEMENT = GENERALIZATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__OWNED_COMMENT = GENERALIZATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Related Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__RELATED_ELEMENT = GENERALIZATION__RELATED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__SOURCE = GENERALIZATION__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__TARGET = GENERALIZATION__TARGET;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__GENERAL = GENERALIZATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Specific</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__SPECIFIC = GENERALIZATION__SPECIFIC;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION__EXTENDED = GENERALIZATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Type Extension</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_EXTENSION_FEATURE_COUNT = GENERALIZATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__OWNED_ELEMENT = FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__OWNED_COMMENT = FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__NAME = FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__QUALIFIED_NAME = FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__OWNED_PROPERTY_ASSOCIATION = FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__REFINEMENT_CONTEXT = FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__REFINED_ELEMENT = FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__FEATURING_CLASSIFIER = FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__ARRAY_DIMENSION = FEATURE__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__PROTOTYPE = FEATURE__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__FEATURE_CLASSIFIER = FEATURE__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__REFINED = FEATURE__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__CLASSIFIER = FEATURE__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE__DIRECTION = FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Directed Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTED_FEATURE_FEATURE_COUNT = FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__OWNED_ELEMENT = DIRECTED_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__OWNED_COMMENT = DIRECTED_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__NAME = DIRECTED_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__QUALIFIED_NAME = DIRECTED_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__OWNED_PROPERTY_ASSOCIATION = DIRECTED_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__REFINEMENT_CONTEXT = DIRECTED_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__REFINED_ELEMENT = DIRECTED_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__FEATURING_CLASSIFIER = DIRECTED_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__ARRAY_DIMENSION = DIRECTED_FEATURE__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__PROTOTYPE = DIRECTED_FEATURE__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__FEATURE_CLASSIFIER = DIRECTED_FEATURE__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__REFINED = DIRECTED_FEATURE__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__CLASSIFIER = DIRECTED_FEATURE__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__DIRECTION = DIRECTED_FEATURE__DIRECTION;

	/**
	 * The feature id for the '<em><b>Inverse</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__INVERSE = DIRECTED_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Feature Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__FEATURE_TYPE = DIRECTED_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Feature Group Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__FEATURE_GROUP_TYPE = DIRECTED_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Feature Group Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP__FEATURE_GROUP_PROTOTYPE = DIRECTED_FEATURE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Feature Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_FEATURE_COUNT = DIRECTED_FEATURE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Call Context</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_CONTEXT_FEATURE_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION_END__OWNED_ELEMENT = CONNECTION_END__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION_END__OWNED_COMMENT = CONNECTION_END__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION_END__NAME = CONNECTION_END__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION_END__QUALIFIED_NAME = CONNECTION_END__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION_END__OWNED_PROPERTY_ASSOCIATION = CONNECTION_END__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Feature Group Connection End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION_END_FEATURE_COUNT = CONNECTION_END_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Feature Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_TYPE_FEATURE_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_ELEMENT = CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_COMMENT = CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__NAME = CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__QUALIFIED_NAME = CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_PROPERTY_ASSOCIATION = CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_MEMBER = CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__MEMBER = CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__CLASSIFIER_FEATURE = CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__INHERITED_MEMBER = CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__GENERALIZATION = CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__GENERAL = CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_ANNEX_SUBCLAUSE = CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_PROTOTYPE = CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_PROTOTYPE_BINDING = CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__NO_PROTOTYPES = CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__NO_ANNEXES = CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__NO_PROPERTIES = CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_FEATURE = CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__EXTENDED = CLASSIFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Inverse</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__INVERSE = CLASSIFIER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_EXTENSION = CLASSIFIER_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Bus Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_BUS_ACCESS = CLASSIFIER_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_DATA_ACCESS = CLASSIFIER_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_DATA_PORT = CLASSIFIER_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_EVENT_DATA_PORT = CLASSIFIER_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_EVENT_PORT = CLASSIFIER_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_FEATURE_GROUP = CLASSIFIER_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Owned Parameter</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_PARAMETER = CLASSIFIER_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_SUBPROGRAM_ACCESS = CLASSIFIER_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = CLASSIFIER_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE__OWNED_ABSTRACT_FEATURE = CLASSIFIER_FEATURE_COUNT + 13;

	/**
	 * The number of structural features of the '<em>Feature Group Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_FEATURE_COUNT = CLASSIFIER_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__OWNED_ELEMENT = GENERALIZATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__OWNED_COMMENT = GENERALIZATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Related Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__RELATED_ELEMENT = GENERALIZATION__RELATED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__SOURCE = GENERALIZATION__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__TARGET = GENERALIZATION__TARGET;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__GENERAL = GENERALIZATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Specific</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__SPECIFIC = GENERALIZATION__SPECIFIC;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION__EXTENDED = GENERALIZATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Group Extension</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_EXTENSION_FEATURE_COUNT = GENERALIZATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__OWNED_ELEMENT = FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__OWNED_COMMENT = FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__NAME = FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__QUALIFIED_NAME = FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__OWNED_PROPERTY_ASSOCIATION = FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__REFINEMENT_CONTEXT = FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__REFINED_ELEMENT = FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__FEATURING_CLASSIFIER = FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__ARRAY_DIMENSION = FEATURE__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__PROTOTYPE = FEATURE__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__FEATURE_CLASSIFIER = FEATURE__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__REFINED = FEATURE__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__CLASSIFIER = FEATURE__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__KIND = FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS__CATEGORY = FEATURE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_FEATURE_COUNT = FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__OWNED_ELEMENT = ACCESS__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__OWNED_COMMENT = ACCESS__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__NAME = ACCESS__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__QUALIFIED_NAME = ACCESS__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__OWNED_PROPERTY_ASSOCIATION = ACCESS__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__REFINEMENT_CONTEXT = ACCESS__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__REFINED_ELEMENT = ACCESS__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__FEATURING_CLASSIFIER = ACCESS__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__ARRAY_DIMENSION = ACCESS__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__PROTOTYPE = ACCESS__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__FEATURE_CLASSIFIER = ACCESS__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__REFINED = ACCESS__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__CLASSIFIER = ACCESS__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__KIND = ACCESS__KIND;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__CATEGORY = ACCESS__CATEGORY;

	/**
	 * The feature id for the '<em><b>Bus Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS__BUS_FEATURE_CLASSIFIER = ACCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Bus Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_ACCESS_FEATURE_COUNT = ACCESS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION_END__OWNED_ELEMENT = CONNECTION_END__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION_END__OWNED_COMMENT = CONNECTION_END__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION_END__NAME = CONNECTION_END__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION_END__QUALIFIED_NAME = CONNECTION_END__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION_END__OWNED_PROPERTY_ASSOCIATION = CONNECTION_END__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Access Connection End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION_END_FEATURE_COUNT = CONNECTION_END_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT_TYPE__OWNED_ELEMENT = BUS__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT_TYPE__OWNED_COMMENT = BUS__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT_TYPE__NAME = BUS__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT_TYPE__QUALIFIED_NAME = BUS__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = BUS__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Bus Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT_TYPE_FEATURE_COUNT = BUS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__OWNED_ELEMENT = ACCESS__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__OWNED_COMMENT = ACCESS__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__NAME = ACCESS__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__QUALIFIED_NAME = ACCESS__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__OWNED_PROPERTY_ASSOCIATION = ACCESS__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__REFINEMENT_CONTEXT = ACCESS__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__REFINED_ELEMENT = ACCESS__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__FEATURING_CLASSIFIER = ACCESS__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__ARRAY_DIMENSION = ACCESS__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__PROTOTYPE = ACCESS__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__FEATURE_CLASSIFIER = ACCESS__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__REFINED = ACCESS__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__CLASSIFIER = ACCESS__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__KIND = ACCESS__KIND;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__CATEGORY = ACCESS__CATEGORY;

	/**
	 * The feature id for the '<em><b>Data Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__DATA_FEATURE_CLASSIFIER = ACCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Data Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS_FEATURE_COUNT = ACCESS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION_END__OWNED_ELEMENT = CONNECTION_END__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION_END__OWNED_COMMENT = CONNECTION_END__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION_END__NAME = CONNECTION_END__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION_END__QUALIFIED_NAME = CONNECTION_END__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION_END__OWNED_PROPERTY_ASSOCIATION = CONNECTION_END__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Parameter Connection End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION_END_FEATURE_COUNT = CONNECTION_END_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_END__OWNED_ELEMENT = CONNECTION_END__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_END__OWNED_COMMENT = CONNECTION_END__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_END__NAME = CONNECTION_END__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_END__QUALIFIED_NAME = CONNECTION_END__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_END__OWNED_PROPERTY_ASSOCIATION = CONNECTION_END__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Port Connection End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_END_FEATURE_COUNT = CONNECTION_END_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Data</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT_TYPE__OWNED_ELEMENT = DATA__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT_TYPE__OWNED_COMMENT = DATA__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT_TYPE__NAME = DATA__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT_TYPE__QUALIFIED_NAME = DATA__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = DATA__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Data Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT_TYPE_FEATURE_COUNT = DATA_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__OWNED_ELEMENT = DIRECTED_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__OWNED_COMMENT = DIRECTED_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__NAME = DIRECTED_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__QUALIFIED_NAME = DIRECTED_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__OWNED_PROPERTY_ASSOCIATION = DIRECTED_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__REFINEMENT_CONTEXT = DIRECTED_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__REFINED_ELEMENT = DIRECTED_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__FEATURING_CLASSIFIER = DIRECTED_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__ARRAY_DIMENSION = DIRECTED_FEATURE__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__PROTOTYPE = DIRECTED_FEATURE__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__FEATURE_CLASSIFIER = DIRECTED_FEATURE__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__REFINED = DIRECTED_FEATURE__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__CLASSIFIER = DIRECTED_FEATURE__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__DIRECTION = DIRECTED_FEATURE__DIRECTION;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__CATEGORY = DIRECTED_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_FEATURE_COUNT = DIRECTED_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__OWNED_ELEMENT = PORT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__OWNED_COMMENT = PORT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__NAME = PORT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__QUALIFIED_NAME = PORT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__OWNED_PROPERTY_ASSOCIATION = PORT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__REFINEMENT_CONTEXT = PORT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__REFINED_ELEMENT = PORT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__FEATURING_CLASSIFIER = PORT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__ARRAY_DIMENSION = PORT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__PROTOTYPE = PORT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__FEATURE_CLASSIFIER = PORT__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__REFINED = PORT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__CLASSIFIER = PORT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__DIRECTION = PORT__DIRECTION;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__CATEGORY = PORT__CATEGORY;

	/**
	 * The feature id for the '<em><b>Data Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT__DATA_FEATURE_CLASSIFIER = PORT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Data Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PORT_FEATURE_COUNT = PORT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__OWNED_ELEMENT = PORT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__OWNED_COMMENT = PORT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__NAME = PORT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__QUALIFIED_NAME = PORT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__OWNED_PROPERTY_ASSOCIATION = PORT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__REFINEMENT_CONTEXT = PORT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__REFINED_ELEMENT = PORT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__FEATURING_CLASSIFIER = PORT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__ARRAY_DIMENSION = PORT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__PROTOTYPE = PORT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__FEATURE_CLASSIFIER = PORT__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__REFINED = PORT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__CLASSIFIER = PORT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__DIRECTION = PORT__DIRECTION;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__CATEGORY = PORT__CATEGORY;

	/**
	 * The feature id for the '<em><b>Data Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT__DATA_FEATURE_CLASSIFIER = PORT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Event Data Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_PORT_FEATURE_COUNT = PORT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__OWNED_ELEMENT = PORT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__OWNED_COMMENT = PORT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__NAME = PORT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__QUALIFIED_NAME = PORT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__OWNED_PROPERTY_ASSOCIATION = PORT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__REFINEMENT_CONTEXT = PORT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__REFINED_ELEMENT = PORT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__FEATURING_CLASSIFIER = PORT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__ARRAY_DIMENSION = PORT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__PROTOTYPE = PORT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__FEATURE_CLASSIFIER = PORT__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__REFINED = PORT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__CLASSIFIER = PORT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__DIRECTION = PORT__DIRECTION;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT__CATEGORY = PORT__CATEGORY;

	/**
	 * The number of structural features of the '<em>Event Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_PORT_FEATURE_COUNT = PORT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__OWNED_ELEMENT = DIRECTED_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__OWNED_COMMENT = DIRECTED_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__NAME = DIRECTED_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__QUALIFIED_NAME = DIRECTED_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__OWNED_PROPERTY_ASSOCIATION = DIRECTED_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__REFINEMENT_CONTEXT = DIRECTED_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__REFINED_ELEMENT = DIRECTED_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__FEATURING_CLASSIFIER = DIRECTED_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__ARRAY_DIMENSION = DIRECTED_FEATURE__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__PROTOTYPE = DIRECTED_FEATURE__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__FEATURE_CLASSIFIER = DIRECTED_FEATURE__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__REFINED = DIRECTED_FEATURE__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__CLASSIFIER = DIRECTED_FEATURE__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__DIRECTION = DIRECTED_FEATURE__DIRECTION;

	/**
	 * The feature id for the '<em><b>Data Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__DATA_FEATURE_CLASSIFIER = DIRECTED_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_FEATURE_COUNT = DIRECTED_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__OWNED_ELEMENT = ACCESS__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__OWNED_COMMENT = ACCESS__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__NAME = ACCESS__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__QUALIFIED_NAME = ACCESS__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__OWNED_PROPERTY_ASSOCIATION = ACCESS__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__REFINEMENT_CONTEXT = ACCESS__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__REFINED_ELEMENT = ACCESS__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__FEATURING_CLASSIFIER = ACCESS__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__ARRAY_DIMENSION = ACCESS__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__PROTOTYPE = ACCESS__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__FEATURE_CLASSIFIER = ACCESS__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__REFINED = ACCESS__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__CLASSIFIER = ACCESS__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__KIND = ACCESS__KIND;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__CATEGORY = ACCESS__CATEGORY;

	/**
	 * The feature id for the '<em><b>Subprogram Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS__SUBPROGRAM_FEATURE_CLASSIFIER = ACCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subprogram Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_ACCESS_FEATURE_COUNT = ACCESS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Subprogram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT_TYPE__OWNED_ELEMENT = SUBCOMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT_TYPE__OWNED_COMMENT = SUBCOMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT_TYPE__NAME = SUBCOMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT_TYPE__QUALIFIED_NAME = SUBCOMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Subprogram Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT_TYPE_FEATURE_COUNT = SUBCOMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__OWNED_ELEMENT = ACCESS__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__OWNED_COMMENT = ACCESS__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__NAME = ACCESS__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__QUALIFIED_NAME = ACCESS__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__OWNED_PROPERTY_ASSOCIATION = ACCESS__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__REFINEMENT_CONTEXT = ACCESS__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__REFINED_ELEMENT = ACCESS__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__FEATURING_CLASSIFIER = ACCESS__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__ARRAY_DIMENSION = ACCESS__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__PROTOTYPE = ACCESS__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__FEATURE_CLASSIFIER = ACCESS__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__REFINED = ACCESS__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__CLASSIFIER = ACCESS__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__KIND = ACCESS__KIND;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__CATEGORY = ACCESS__CATEGORY;

	/**
	 * The feature id for the '<em><b>Subprogram Group Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS__SUBPROGRAM_GROUP_FEATURE_CLASSIFIER = ACCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subprogram Group Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_ACCESS_FEATURE_COUNT = ACCESS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Subprogram Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE__OWNED_ELEMENT = SUBCOMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE__OWNED_COMMENT = SUBCOMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE__NAME = SUBCOMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE__QUALIFIED_NAME = SUBCOMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Subprogram Group Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE_FEATURE_COUNT = SUBCOMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__OWNED_ELEMENT = DIRECTED_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__OWNED_COMMENT = DIRECTED_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__NAME = DIRECTED_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__QUALIFIED_NAME = DIRECTED_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__OWNED_PROPERTY_ASSOCIATION = DIRECTED_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__REFINEMENT_CONTEXT = DIRECTED_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__REFINED_ELEMENT = DIRECTED_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__FEATURING_CLASSIFIER = DIRECTED_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__ARRAY_DIMENSION = DIRECTED_FEATURE__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__PROTOTYPE = DIRECTED_FEATURE__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Feature Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__FEATURE_CLASSIFIER = DIRECTED_FEATURE__FEATURE_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__REFINED = DIRECTED_FEATURE__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__CLASSIFIER = DIRECTED_FEATURE__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__DIRECTION = DIRECTED_FEATURE__DIRECTION;

	/**
	 * The feature id for the '<em><b>Feature Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE__FEATURE_PROTOTYPE = DIRECTED_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Abstract Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE_FEATURE_COUNT = DIRECTED_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__OWNED_ELEMENT = PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__OWNED_COMMENT = PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__NAME = PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__QUALIFIED_NAME = PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__REFINEMENT_CONTEXT = PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__REFINED_ELEMENT = PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__FEATURING_CLASSIFIER = PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__REFINED = PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__DIRECTION = PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE__CONSTRAINING_CLASSIFIER = PROTOTYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Feature Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_FEATURE_COUNT = PROTOTYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__OWNED_ELEMENT = PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__OWNED_COMMENT = PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__NAME = PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__QUALIFIED_NAME = PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__REFINEMENT_CONTEXT = PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__REFINED_ELEMENT = PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__FEATURING_CLASSIFIER = PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__REFINED = PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Constraining Feature Group Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE__CONSTRAINING_FEATURE_GROUP_TYPE = PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Feature Group Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_FEATURE_COUNT = PROTOTYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__OWNED_ELEMENT = STRUCTURAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__OWNED_COMMENT = STRUCTURAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__NAME = STRUCTURAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__QUALIFIED_NAME = STRUCTURAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__REFINEMENT_CONTEXT = STRUCTURAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__REFINED_ELEMENT = STRUCTURAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__FEATURING_CLASSIFIER = STRUCTURAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__IN_MODE = STRUCTURAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__ARRAY_DIMENSION = STRUCTURAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__SUBCOMPONENT_TYPE = STRUCTURAL_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = STRUCTURAL_FEATURE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__PROTOTYPE = STRUCTURAL_FEATURE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__OWNED_MODE_BINDING = STRUCTURAL_FEATURE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__ALL_MODES = STRUCTURAL_FEATURE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__IMPLEMENTATION_REFERENCE = STRUCTURAL_FEATURE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__REFINED = STRUCTURAL_FEATURE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT__CLASSIFIER = STRUCTURAL_FEATURE_FEATURE_COUNT + 9;

	/**
	 * The number of structural features of the '<em>Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBCOMPONENT_FEATURE_COUNT = STRUCTURAL_FEATURE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_BINDING__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_BINDING__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Parent Mode</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_BINDING__PARENT_MODE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Derived Mode</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_BINDING__DERIVED_MODE = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Mode Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_BINDING_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__OWNED_ELEMENT = MODAL_PATH__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__OWNED_COMMENT = MODAL_PATH__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__NAME = MODAL_PATH__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__QUALIFIED_NAME = MODAL_PATH__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = MODAL_PATH__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__IN_MODE = MODAL_PATH__IN_MODE;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__IN_MODE_OR_TRANSITION = MODAL_PATH__IN_MODE_OR_TRANSITION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__FEATURING_CLASSIFIER = MODAL_PATH_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__KIND = MODAL_PATH_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Specification</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__SPECIFICATION = MODAL_PATH_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Flow Segment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION__OWNED_FLOW_SEGMENT = MODAL_PATH_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Flow Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_IMPLEMENTATION_FEATURE_COUNT = MODAL_PATH_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SEGMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SEGMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Flow Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SEGMENT__FLOW_ELEMENT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SEGMENT__CONTEXT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Flow Segment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_SEGMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__OWNED_ELEMENT = STRUCTURAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__OWNED_COMMENT = STRUCTURAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__NAME = STRUCTURAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__QUALIFIED_NAME = STRUCTURAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__OWNED_PROPERTY_ASSOCIATION = STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__REFINEMENT_CONTEXT = STRUCTURAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__REFINED_ELEMENT = STRUCTURAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__FEATURING_CLASSIFIER = STRUCTURAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__IN_MODE = STRUCTURAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__IN_MODE_OR_TRANSITION = STRUCTURAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__DESTINATION = STRUCTURAL_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Source</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__SOURCE = STRUCTURAL_FEATURE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Bidirectional</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__BIDIRECTIONAL = STRUCTURAL_FEATURE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__REFINED = STRUCTURAL_FEATURE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_FEATURE_COUNT = STRUCTURAL_FEATURE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_ELEMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_ELEMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_ELEMENT__CONTEXT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Connection End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_ELEMENT__CONNECTION_END = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Connected Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_ELEMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__OWNED_ELEMENT = GENERALIZATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__OWNED_COMMENT = GENERALIZATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Related Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__RELATED_ELEMENT = GENERALIZATION__RELATED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__SOURCE = GENERALIZATION__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__TARGET = GENERALIZATION__TARGET;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__GENERAL = GENERALIZATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Specific</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__SPECIFIC = GENERALIZATION__SPECIFIC;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION__EXTENDED = GENERALIZATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Implementation Extension</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_EXTENSION_FEATURE_COUNT = GENERALIZATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__OWNED_ELEMENT = GENERALIZATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__OWNED_COMMENT = GENERALIZATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Related Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__RELATED_ELEMENT = GENERALIZATION__RELATED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__SOURCE = GENERALIZATION__SOURCE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__TARGET = GENERALIZATION__TARGET;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__GENERAL = GENERALIZATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Specific</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__SPECIFIC = GENERALIZATION__SPECIFIC;

	/**
	 * The feature id for the '<em><b>Implemented</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION__IMPLEMENTED = GENERALIZATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Realization</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZATION_FEATURE_COUNT = GENERALIZATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__OWNED_ELEMENT = FLOW_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__OWNED_COMMENT = FLOW_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__NAME = FLOW_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__QUALIFIED_NAME = FLOW_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__OWNED_PROPERTY_ASSOCIATION = FLOW_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__REFINEMENT_CONTEXT = FLOW_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__REFINED_ELEMENT = FLOW_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__FEATURING_CLASSIFIER = FLOW_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__IN_MODE = FLOW_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__IN_MODE_OR_TRANSITION = FLOW_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__REFINED = FLOW_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow Segment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW__OWNED_END_TO_END_FLOW_SEGMENT = FLOW_FEATURE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>End To End Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_FEATURE_COUNT = FLOW_FEATURE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_SEGMENT__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_SEGMENT__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Flow Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_SEGMENT__FLOW_ELEMENT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_SEGMENT__CONTEXT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>End To End Flow Segment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_TO_END_FLOW_SEGMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Abstract Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT__ABSTRACT_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Abstract Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Abstract</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT_TYPE__OWNED_ELEMENT = ABSTRACT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT_TYPE__OWNED_COMMENT = ABSTRACT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT_TYPE__NAME = ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT_TYPE__QUALIFIED_NAME = ABSTRACT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = ABSTRACT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Abstract Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SUBCOMPONENT_TYPE_FEATURE_COUNT = ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__OWNED_ELEMENT = CONNECTION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__OWNED_COMMENT = CONNECTION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__NAME = CONNECTION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__QUALIFIED_NAME = CONNECTION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__OWNED_PROPERTY_ASSOCIATION = CONNECTION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__REFINEMENT_CONTEXT = CONNECTION__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__REFINED_ELEMENT = CONNECTION__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__FEATURING_CLASSIFIER = CONNECTION__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__IN_MODE = CONNECTION__IN_MODE;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__IN_MODE_OR_TRANSITION = CONNECTION__IN_MODE_OR_TRANSITION;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__DESTINATION = CONNECTION__DESTINATION;

	/**
	 * The feature id for the '<em><b>Source</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__SOURCE = CONNECTION__SOURCE;

	/**
	 * The feature id for the '<em><b>Bidirectional</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__BIDIRECTIONAL = CONNECTION__BIDIRECTIONAL;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__REFINED = CONNECTION__REFINED;

	/**
	 * The feature id for the '<em><b>Access Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION__ACCESS_CATEGORY = CONNECTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Access Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONNECTION_FEATURE_COUNT = CONNECTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__OWNED_ELEMENT = CONNECTION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__OWNED_COMMENT = CONNECTION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__NAME = CONNECTION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__QUALIFIED_NAME = CONNECTION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__OWNED_PROPERTY_ASSOCIATION = CONNECTION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__REFINEMENT_CONTEXT = CONNECTION__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__REFINED_ELEMENT = CONNECTION__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__FEATURING_CLASSIFIER = CONNECTION__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__IN_MODE = CONNECTION__IN_MODE;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__IN_MODE_OR_TRANSITION = CONNECTION__IN_MODE_OR_TRANSITION;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__DESTINATION = CONNECTION__DESTINATION;

	/**
	 * The feature id for the '<em><b>Source</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__SOURCE = CONNECTION__SOURCE;

	/**
	 * The feature id for the '<em><b>Bidirectional</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__BIDIRECTIONAL = CONNECTION__BIDIRECTIONAL;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION__REFINED = CONNECTION__REFINED;

	/**
	 * The number of structural features of the '<em>Parameter Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_CONNECTION_FEATURE_COUNT = CONNECTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__OWNED_ELEMENT = CONNECTION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__OWNED_COMMENT = CONNECTION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__NAME = CONNECTION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__QUALIFIED_NAME = CONNECTION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__OWNED_PROPERTY_ASSOCIATION = CONNECTION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__REFINEMENT_CONTEXT = CONNECTION__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__REFINED_ELEMENT = CONNECTION__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__FEATURING_CLASSIFIER = CONNECTION__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__IN_MODE = CONNECTION__IN_MODE;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__IN_MODE_OR_TRANSITION = CONNECTION__IN_MODE_OR_TRANSITION;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__DESTINATION = CONNECTION__DESTINATION;

	/**
	 * The feature id for the '<em><b>Source</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__SOURCE = CONNECTION__SOURCE;

	/**
	 * The feature id for the '<em><b>Bidirectional</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__BIDIRECTIONAL = CONNECTION__BIDIRECTIONAL;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__REFINED = CONNECTION__REFINED;

	/**
	 * The number of structural features of the '<em>Port Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_FEATURE_COUNT = CONNECTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__OWNED_ELEMENT = CONNECTION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__OWNED_COMMENT = CONNECTION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__NAME = CONNECTION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__QUALIFIED_NAME = CONNECTION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__OWNED_PROPERTY_ASSOCIATION = CONNECTION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__REFINEMENT_CONTEXT = CONNECTION__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__REFINED_ELEMENT = CONNECTION__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__FEATURING_CLASSIFIER = CONNECTION__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__IN_MODE = CONNECTION__IN_MODE;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__IN_MODE_OR_TRANSITION = CONNECTION__IN_MODE_OR_TRANSITION;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__DESTINATION = CONNECTION__DESTINATION;

	/**
	 * The feature id for the '<em><b>Source</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__SOURCE = CONNECTION__SOURCE;

	/**
	 * The feature id for the '<em><b>Bidirectional</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__BIDIRECTIONAL = CONNECTION__BIDIRECTIONAL;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION__REFINED = CONNECTION__REFINED;

	/**
	 * The number of structural features of the '<em>Feature Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONNECTION_FEATURE_COUNT = CONNECTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__OWNED_ELEMENT = CONNECTION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__OWNED_COMMENT = CONNECTION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__NAME = CONNECTION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__QUALIFIED_NAME = CONNECTION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__OWNED_PROPERTY_ASSOCIATION = CONNECTION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__REFINEMENT_CONTEXT = CONNECTION__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__REFINED_ELEMENT = CONNECTION__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__FEATURING_CLASSIFIER = CONNECTION__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__IN_MODE = CONNECTION__IN_MODE;

	/**
	 * The feature id for the '<em><b>In Mode Or Transition</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__IN_MODE_OR_TRANSITION = CONNECTION__IN_MODE_OR_TRANSITION;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__DESTINATION = CONNECTION__DESTINATION;

	/**
	 * The feature id for the '<em><b>Source</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__SOURCE = CONNECTION__SOURCE;

	/**
	 * The feature id for the '<em><b>Bidirectional</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__BIDIRECTIONAL = CONNECTION__BIDIRECTIONAL;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION__REFINED = CONNECTION__REFINED;

	/**
	 * The number of structural features of the '<em>Feature Group Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_CONNECTION_FEATURE_COUNT = CONNECTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__OWNED_ELEMENT = STRUCTURAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__OWNED_COMMENT = STRUCTURAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__NAME = STRUCTURAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__QUALIFIED_NAME = STRUCTURAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__OWNED_PROPERTY_ASSOCIATION = STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__REFINEMENT_CONTEXT = STRUCTURAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__REFINED_ELEMENT = STRUCTURAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__FEATURING_CLASSIFIER = STRUCTURAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE__IN_MODE = STRUCTURAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Processor Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE_FEATURE_COUNT = STRUCTURAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__OWNED_ELEMENT = STRUCTURAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__OWNED_COMMENT = STRUCTURAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__NAME = STRUCTURAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__QUALIFIED_NAME = STRUCTURAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__OWNED_PROPERTY_ASSOCIATION = STRUCTURAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__REFINEMENT_CONTEXT = STRUCTURAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__REFINED_ELEMENT = STRUCTURAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__FEATURING_CLASSIFIER = STRUCTURAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__IN_MODE = STRUCTURAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE__DIRECTION = STRUCTURAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Internal Feature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_FEATURE_FEATURE_COUNT = STRUCTURAL_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__OWNED_ELEMENT = INTERNAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__OWNED_COMMENT = INTERNAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__NAME = INTERNAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__QUALIFIED_NAME = INTERNAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__OWNED_PROPERTY_ASSOCIATION = INTERNAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__REFINEMENT_CONTEXT = INTERNAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__REFINED_ELEMENT = INTERNAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__FEATURING_CLASSIFIER = INTERNAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__IN_MODE = INTERNAL_FEATURE__IN_MODE;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE__DIRECTION = INTERNAL_FEATURE__DIRECTION;

	/**
	 * The number of structural features of the '<em>Event Source</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SOURCE_FEATURE_COUNT = INTERNAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__OWNED_ELEMENT = INTERNAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__OWNED_COMMENT = INTERNAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__NAME = INTERNAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__QUALIFIED_NAME = INTERNAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__OWNED_PROPERTY_ASSOCIATION = INTERNAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__REFINEMENT_CONTEXT = INTERNAL_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__REFINED_ELEMENT = INTERNAL_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__FEATURING_CLASSIFIER = INTERNAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__IN_MODE = INTERNAL_FEATURE__IN_MODE;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__DIRECTION = INTERNAL_FEATURE__DIRECTION;

	/**
	 * The feature id for the '<em><b>Data Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE__DATA_CLASSIFIER = INTERNAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Event Data Source</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_DATA_SOURCE_FEATURE_COUNT = INTERNAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.VirtualBusSubcomponentTypeImpl <em>Virtual Bus Subcomponent Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.VirtualBusSubcomponentTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getVirtualBusSubcomponentType()
	 * @generated
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_TYPE = 143;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Data Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__OWNED_ELEMENT = PROCESSOR_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__OWNED_COMMENT = PROCESSOR_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__NAME = PROCESSOR_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__QUALIFIED_NAME = PROCESSOR_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__OWNED_PROPERTY_ASSOCIATION = PROCESSOR_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__REFINEMENT_CONTEXT = PROCESSOR_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__REFINED_ELEMENT = PROCESSOR_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__FEATURING_CLASSIFIER = PROCESSOR_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__IN_MODE = PROCESSOR_FEATURE__IN_MODE;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__DIRECTION = PROCESSOR_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Data Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY__DATA_CLASSIFIER = PROCESSOR_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Port Proxy</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_PROXY_FEATURE_COUNT = PROCESSOR_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__OWNED_ELEMENT = PROCESSOR_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__OWNED_COMMENT = PROCESSOR_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__NAME = PROCESSOR_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__QUALIFIED_NAME = PROCESSOR_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__OWNED_PROPERTY_ASSOCIATION = PROCESSOR_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__REFINEMENT_CONTEXT = PROCESSOR_FEATURE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__REFINED_ELEMENT = PROCESSOR_FEATURE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__FEATURING_CLASSIFIER = PROCESSOR_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__IN_MODE = PROCESSOR_FEATURE__IN_MODE;

	/**
	 * The feature id for the '<em><b>Subprogram Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY__SUBPROGRAM_CLASSIFIER = PROCESSOR_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subprogram Proxy</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROXY_FEATURE_COUNT = PROCESSOR_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Subprogram Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_LIBRARY__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_LIBRARY__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_LIBRARY__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_LIBRARY__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_LIBRARY__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Annex Library</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANNEX_LIBRARY_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY__OWNED_ELEMENT = ANNEX_LIBRARY__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY__OWNED_COMMENT = ANNEX_LIBRARY__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY__NAME = ANNEX_LIBRARY__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY__QUALIFIED_NAME = ANNEX_LIBRARY__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY__OWNED_PROPERTY_ASSOCIATION = ANNEX_LIBRARY__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Source Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY__SOURCE_TEXT = ANNEX_LIBRARY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parsed Annex Library</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY__PARSED_ANNEX_LIBRARY = ANNEX_LIBRARY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Default Annex Library</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_LIBRARY_FEATURE_COUNT = ANNEX_LIBRARY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__OWNED_ELEMENT = ANNEX_SUBCLAUSE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__OWNED_COMMENT = ANNEX_SUBCLAUSE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__NAME = ANNEX_SUBCLAUSE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__QUALIFIED_NAME = ANNEX_SUBCLAUSE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__OWNED_PROPERTY_ASSOCIATION = ANNEX_SUBCLAUSE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__IN_MODE = ANNEX_SUBCLAUSE__IN_MODE;

	/**
	 * The feature id for the '<em><b>Source Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__SOURCE_TEXT = ANNEX_SUBCLAUSE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parsed Annex Subclause</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE__PARSED_ANNEX_SUBCLAUSE = ANNEX_SUBCLAUSE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Default Annex Subclause</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_ANNEX_SUBCLAUSE_FEATURE_COUNT = ANNEX_SUBCLAUSE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_ELEMENT = NAMESPACE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_COMMENT = NAMESPACE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__NAME = NAMESPACE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__QUALIFIED_NAME = NAMESPACE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_PROPERTY_ASSOCIATION = NAMESPACE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_MEMBER = NAMESPACE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__MEMBER = NAMESPACE__MEMBER;

	/**
	 * The feature id for the '<em><b>Owned Package Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_PACKAGE_RENAME = NAMESPACE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Component Type Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_COMPONENT_TYPE_RENAME = NAMESPACE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Classifier</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_CLASSIFIER = NAMESPACE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Type Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_FEATURE_GROUP_TYPE_RENAME = NAMESPACE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Annex Library</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__OWNED_ANNEX_LIBRARY = NAMESPACE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Imported Unit</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__IMPORTED_UNIT = NAMESPACE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__NO_ANNEXES = NAMESPACE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION__NO_PROPERTIES = NAMESPACE_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Package Section</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SECTION_FEATURE_COUNT = NAMESPACE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_ELEMENT = PACKAGE_SECTION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_COMMENT = PACKAGE_SECTION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__NAME = PACKAGE_SECTION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__QUALIFIED_NAME = PACKAGE_SECTION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_PROPERTY_ASSOCIATION = PACKAGE_SECTION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_MEMBER = PACKAGE_SECTION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__MEMBER = PACKAGE_SECTION__MEMBER;

	/**
	 * The feature id for the '<em><b>Owned Package Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_PACKAGE_RENAME = PACKAGE_SECTION__OWNED_PACKAGE_RENAME;

	/**
	 * The feature id for the '<em><b>Owned Component Type Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_COMPONENT_TYPE_RENAME = PACKAGE_SECTION__OWNED_COMPONENT_TYPE_RENAME;

	/**
	 * The feature id for the '<em><b>Owned Classifier</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_CLASSIFIER = PACKAGE_SECTION__OWNED_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Type Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_FEATURE_GROUP_TYPE_RENAME = PACKAGE_SECTION__OWNED_FEATURE_GROUP_TYPE_RENAME;

	/**
	 * The feature id for the '<em><b>Owned Annex Library</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__OWNED_ANNEX_LIBRARY = PACKAGE_SECTION__OWNED_ANNEX_LIBRARY;

	/**
	 * The feature id for the '<em><b>Imported Unit</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__IMPORTED_UNIT = PACKAGE_SECTION__IMPORTED_UNIT;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__NO_ANNEXES = PACKAGE_SECTION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__NO_PROPERTIES = PACKAGE_SECTION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Private Section</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION__PRIVATE_SECTION = PACKAGE_SECTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Public Package Section</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUBLIC_PACKAGE_SECTION_FEATURE_COUNT = PACKAGE_SECTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Renamed Package</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME__RENAMED_PACKAGE = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Rename All</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME__RENAME_ALL = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Package Rename</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_RENAME_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UNIT__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UNIT__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UNIT__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UNIT__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UNIT__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Model Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UNIT_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__OWNED_ELEMENT = MODEL_UNIT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__OWNED_COMMENT = MODEL_UNIT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__NAME = MODEL_UNIT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__QUALIFIED_NAME = MODEL_UNIT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__OWNED_PROPERTY_ASSOCIATION = MODEL_UNIT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Public Section</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__OWNED_PUBLIC_SECTION = MODEL_UNIT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Private Section</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__OWNED_PRIVATE_SECTION = MODEL_UNIT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Public Section</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__PUBLIC_SECTION = MODEL_UNIT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Private Section</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE__PRIVATE_SECTION = MODEL_UNIT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Aadl Package</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_PACKAGE_FEATURE_COUNT = MODEL_UNIT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_ELEMENT = PACKAGE_SECTION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_COMMENT = PACKAGE_SECTION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__NAME = PACKAGE_SECTION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__QUALIFIED_NAME = PACKAGE_SECTION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_PROPERTY_ASSOCIATION = PACKAGE_SECTION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_MEMBER = PACKAGE_SECTION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__MEMBER = PACKAGE_SECTION__MEMBER;

	/**
	 * The feature id for the '<em><b>Owned Package Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_PACKAGE_RENAME = PACKAGE_SECTION__OWNED_PACKAGE_RENAME;

	/**
	 * The feature id for the '<em><b>Owned Component Type Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_COMPONENT_TYPE_RENAME = PACKAGE_SECTION__OWNED_COMPONENT_TYPE_RENAME;

	/**
	 * The feature id for the '<em><b>Owned Classifier</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_CLASSIFIER = PACKAGE_SECTION__OWNED_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Type Rename</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_FEATURE_GROUP_TYPE_RENAME = PACKAGE_SECTION__OWNED_FEATURE_GROUP_TYPE_RENAME;

	/**
	 * The feature id for the '<em><b>Owned Annex Library</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__OWNED_ANNEX_LIBRARY = PACKAGE_SECTION__OWNED_ANNEX_LIBRARY;

	/**
	 * The feature id for the '<em><b>Imported Unit</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__IMPORTED_UNIT = PACKAGE_SECTION__IMPORTED_UNIT;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__NO_ANNEXES = PACKAGE_SECTION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__NO_PROPERTIES = PACKAGE_SECTION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Public Section</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION__PUBLIC_SECTION = PACKAGE_SECTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Private Package Section</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE_PACKAGE_SECTION_FEATURE_COUNT = PACKAGE_SECTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME__CATEGORY = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Renamed Component Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME__RENAMED_COMPONENT_TYPE = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Component Type Rename</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_RENAME_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_RENAME__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_RENAME__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_RENAME__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_RENAME__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_RENAME__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Renamed Feature Group Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_RENAME__RENAMED_FEATURE_GROUP_TYPE = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Feature Group Type Rename</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_TYPE_RENAME_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_BINDING__OWNED_ELEMENT = PROTOTYPE_BINDING__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_BINDING__OWNED_COMMENT = PROTOTYPE_BINDING__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Formal</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_BINDING__FORMAL = PROTOTYPE_BINDING__FORMAL;

	/**
	 * The feature id for the '<em><b>Actual</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_BINDING__ACTUAL = PROTOTYPE_BINDING_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Component Prototype Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_BINDING_FEATURE_COUNT = PROTOTYPE_BINDING_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_ACTUAL__OWNED_ELEMENT = ARRAYABLE_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_ACTUAL__OWNED_COMMENT = ARRAYABLE_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_ACTUAL__ARRAY_DIMENSION = ARRAYABLE_ELEMENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_ACTUAL__CATEGORY = ARRAYABLE_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_ACTUAL__BINDING = ARRAYABLE_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_ACTUAL__SUBCOMPONENT_TYPE = ARRAYABLE_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Component Prototype Actual</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_PROTOTYPE_ACTUAL_FEATURE_COUNT = ARRAYABLE_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_BINDING__OWNED_ELEMENT = PROTOTYPE_BINDING__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_BINDING__OWNED_COMMENT = PROTOTYPE_BINDING__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Formal</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_BINDING__FORMAL = PROTOTYPE_BINDING__FORMAL;

	/**
	 * The feature id for the '<em><b>Actual</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_BINDING__ACTUAL = PROTOTYPE_BINDING_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Feature Group Prototype Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_BINDING_FEATURE_COUNT = PROTOTYPE_BINDING_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_ACTUAL__OWNED_ELEMENT = ARRAYABLE_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_ACTUAL__OWNED_COMMENT = ARRAYABLE_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_ACTUAL__ARRAY_DIMENSION = ARRAYABLE_ELEMENT__ARRAY_DIMENSION;

	/**
	 * The number of structural features of the '<em>Feature Prototype Actual</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT = ARRAYABLE_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_ACTUAL__OWNED_ELEMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_ACTUAL__OWNED_COMMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_ACTUAL__ARRAY_DIMENSION = FEATURE_PROTOTYPE_ACTUAL__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_ACTUAL__BINDING = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Feature Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_ACTUAL__FEATURE_TYPE = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Feature Group Prototype Actual</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_GROUP_PROTOTYPE_ACTUAL_FEATURE_COUNT = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_BINDING__OWNED_ELEMENT = PROTOTYPE_BINDING__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_BINDING__OWNED_COMMENT = PROTOTYPE_BINDING__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Formal</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_BINDING__FORMAL = PROTOTYPE_BINDING__FORMAL;

	/**
	 * The feature id for the '<em><b>Actual</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_BINDING__ACTUAL = PROTOTYPE_BINDING_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Feature Prototype Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_BINDING_FEATURE_COUNT = PROTOTYPE_BINDING_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION__OWNED_ELEMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION__OWNED_COMMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION__ARRAY_DIMENSION = FEATURE_PROTOTYPE_ACTUAL__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION__KIND = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION__CATEGORY = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION__CLASSIFIER = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Component Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION__COMPONENT_PROTOTYPE = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Access Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_SPECIFICATION_FEATURE_COUNT = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION__OWNED_ELEMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION__OWNED_COMMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION__ARRAY_DIMENSION = FEATURE_PROTOTYPE_ACTUAL__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION__DIRECTION = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION__CATEGORY = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION__CLASSIFIER = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Component Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION__COMPONENT_PROTOTYPE = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Port Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_SPECIFICATION_FEATURE_COUNT = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_REFERENCE__OWNED_ELEMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_REFERENCE__OWNED_COMMENT = FEATURE_PROTOTYPE_ACTUAL__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_REFERENCE__ARRAY_DIMENSION = FEATURE_PROTOTYPE_ACTUAL__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_REFERENCE__DIRECTION = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_REFERENCE__PROTOTYPE = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Feature Prototype Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_PROTOTYPE_REFERENCE_FEATURE_COUNT = FEATURE_PROTOTYPE_ACTUAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__OWNED_ELEMENT = BEHAVIORAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__OWNED_COMMENT = BEHAVIORAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__NAME = BEHAVIORAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__QUALIFIED_NAME = BEHAVIORAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__OWNED_PROPERTY_ASSOCIATION = BEHAVIORAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__FEATURING_CLASSIFIER = BEHAVIORAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__IN_MODE = BEHAVIORAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Call</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE__OWNED_SUBPROGRAM_CALL = BEHAVIORAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Subprogram Call Sequence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_SEQUENCE_FEATURE_COUNT = BEHAVIORAL_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__OWNED_ELEMENT = BEHAVIORAL_FEATURE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__OWNED_COMMENT = BEHAVIORAL_FEATURE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__NAME = BEHAVIORAL_FEATURE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__QUALIFIED_NAME = BEHAVIORAL_FEATURE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__OWNED_PROPERTY_ASSOCIATION = BEHAVIORAL_FEATURE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__FEATURING_CLASSIFIER = BEHAVIORAL_FEATURE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Called Subprogram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__CALLED_SUBPROGRAM = BEHAVIORAL_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL__CONTEXT = BEHAVIORAL_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Subprogram Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_CALL_FEATURE_COUNT = BEHAVIORAL_FEATURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Subprogram Call</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__SUBPROGRAM_CALL = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Call Sequence</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_CALL_SEQUENCE = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Behaviored Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Bus Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_BUS_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_DATA_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Abstract Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Abstract Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE__OWNED_ELEMENT = SUBCOMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE__OWNED_COMMENT = SUBCOMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE__NAME = SUBCOMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE__QUALIFIED_NAME = SUBCOMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Virtual Processor Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE_FEATURE_COUNT = SUBCOMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Virtual Processor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_TYPE__OWNED_ELEMENT = SUBCOMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_TYPE__OWNED_COMMENT = SUBCOMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_TYPE__NAME = SUBCOMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_TYPE__QUALIFIED_NAME = SUBCOMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Virtual Bus Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_TYPE_FEATURE_COUNT = SUBCOMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Virtual Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT_TYPE__OWNED_ELEMENT = SUBCOMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT_TYPE__OWNED_COMMENT = SUBCOMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT_TYPE__NAME = SUBCOMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT_TYPE__QUALIFIED_NAME = SUBCOMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Thread Group Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT_TYPE_FEATURE_COUNT = SUBCOMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Thread Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT_TYPE__OWNED_ELEMENT = SUBCOMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT_TYPE__OWNED_COMMENT = SUBCOMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT_TYPE__NAME = SUBCOMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT_TYPE__QUALIFIED_NAME = SUBCOMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Thread Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT_TYPE_FEATURE_COUNT = SUBCOMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Thread</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT_TYPE__OWNED_ELEMENT = SUBCOMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT_TYPE__OWNED_COMMENT = SUBCOMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT_TYPE__NAME = SUBCOMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT_TYPE__QUALIFIED_NAME = SUBCOMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>System Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT_TYPE_FEATURE_COUNT = SUBCOMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT_TYPE__OWNED_ELEMENT = PROCESS__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT_TYPE__OWNED_COMMENT = PROCESS__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT_TYPE__NAME = PROCESS__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT_TYPE__QUALIFIED_NAME = PROCESS__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = PROCESS__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Process Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT_TYPE_FEATURE_COUNT = PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Memory</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT_TYPE__OWNED_ELEMENT = MEMORY__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT_TYPE__OWNED_COMMENT = MEMORY__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT_TYPE__NAME = MEMORY__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT_TYPE__QUALIFIED_NAME = MEMORY__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = MEMORY__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Memory Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT_TYPE_FEATURE_COUNT = MEMORY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Device</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT_TYPE__OWNED_ELEMENT = DEVICE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT_TYPE__OWNED_COMMENT = DEVICE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT_TYPE__NAME = DEVICE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT_TYPE__QUALIFIED_NAME = DEVICE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = DEVICE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Device Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT_TYPE_FEATURE_COUNT = DEVICE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Processor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT_TYPE__OWNED_ELEMENT = PROCESSOR__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT_TYPE__OWNED_COMMENT = PROCESSOR__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT_TYPE__NAME = PROCESSOR__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT_TYPE__QUALIFIED_NAME = PROCESSOR__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION = PROCESSOR__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Processor Subcomponent Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT_TYPE_FEATURE_COUNT = PROCESSOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_ELEMENT = BEHAVIORED_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_COMMENT = BEHAVIORED_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NAME = BEHAVIORED_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__QUALIFIED_NAME = BEHAVIORED_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = BEHAVIORED_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_MEMBER = BEHAVIORED_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__MEMBER = BEHAVIORED_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__CLASSIFIER_FEATURE = BEHAVIORED_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__INHERITED_MEMBER = BEHAVIORED_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__GENERALIZATION = BEHAVIORED_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__GENERAL = BEHAVIORED_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = BEHAVIORED_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PROTOTYPE = BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_PROTOTYPES = BEHAVIORED_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_ANNEXES = BEHAVIORED_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_PROPERTIES = BEHAVIORED_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_MODE = BEHAVIORED_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_MODE_TRANSITION = BEHAVIORED_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__DERIVED_MODES = BEHAVIORED_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_FLOWS = BEHAVIORED_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_MODES = BEHAVIORED_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__TYPE = BEHAVIORED_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__EXTENDED = BEHAVIORED_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = BEHAVIORED_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_EXTENSION = BEHAVIORED_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_REALIZATION = BEHAVIORED_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_END_TO_END_FLOW = BEHAVIORED_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PORT_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_SUBCOMPONENTS = BEHAVIORED_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_CONNECTIONS = BEHAVIORED_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__NO_CALLS = BEHAVIORED_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = BEHAVIORED_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = BEHAVIORED_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_EVENT_SOURCE = BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PORT_PROXY = BEHAVIORED_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Subprogram Call</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__SUBPROGRAM_CALL = BEHAVIORED_IMPLEMENTATION__SUBPROGRAM_CALL;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Call Sequence</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_SUBPROGRAM_CALL_SEQUENCE = BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_CALL_SEQUENCE;

	/**
	 * The feature id for the '<em><b>Owned Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_BUS_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Device Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_DEVICE_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Memory Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_MEMORY_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Process Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PROCESS_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Processor Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_PROCESSOR_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned System Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_SYSTEM_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_SUBPROGRAM_GROUP_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Owned Thread Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_THREAD_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Owned Thread Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_THREAD_GROUP_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Owned Virtual Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_VIRTUAL_BUS_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Owned Virtual Processor Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION__OWNED_VIRTUAL_PROCESSOR_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 12;

	/**
	 * The number of structural features of the '<em>Abstract Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_IMPLEMENTATION_FEATURE_COUNT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Bus Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT__BUS_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Bus Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Data Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT__DATA_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Data Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Device Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT__DEVICE_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Device Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Memory Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT__MEMORY_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Memory Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Process Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT__PROCESS_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Process Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Processor Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT__PROCESSOR_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Processor Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>System Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT__SYSTEM_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>System Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Subprogram Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT__SUBPROGRAM_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subprogram Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Subprogram Group Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT__SUBPROGRAM_GROUP_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subprogram Group Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Thread Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT__THREAD_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Thread Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Thread Group Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT__THREAD_GROUP_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Thread Group Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Virtual Bus Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT__VIRTUAL_BUS_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Virtual Bus Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__OWNED_ELEMENT = SUBCOMPONENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__OWNED_COMMENT = SUBCOMPONENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__NAME = SUBCOMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__QUALIFIED_NAME = SUBCOMPONENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION = SUBCOMPONENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__REFINEMENT_CONTEXT = SUBCOMPONENT__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__REFINED_ELEMENT = SUBCOMPONENT__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__FEATURING_CLASSIFIER = SUBCOMPONENT__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>In Mode</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__IN_MODE = SUBCOMPONENT__IN_MODE;

	/**
	 * The feature id for the '<em><b>Array Dimension</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__ARRAY_DIMENSION = SUBCOMPONENT__ARRAY_DIMENSION;

	/**
	 * The feature id for the '<em><b>Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__SUBCOMPONENT_TYPE = SUBCOMPONENT__SUBCOMPONENT_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__OWNED_PROTOTYPE_BINDING = SUBCOMPONENT__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>Prototype</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__PROTOTYPE = SUBCOMPONENT__PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Mode Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__OWNED_MODE_BINDING = SUBCOMPONENT__OWNED_MODE_BINDING;

	/**
	 * The feature id for the '<em><b>All Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__ALL_MODES = SUBCOMPONENT__ALL_MODES;

	/**
	 * The feature id for the '<em><b>Implementation Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__IMPLEMENTATION_REFERENCE = SUBCOMPONENT__IMPLEMENTATION_REFERENCE;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__REFINED = SUBCOMPONENT__REFINED;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__CLASSIFIER = SUBCOMPONENT__CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Virtual Processor Subcomponent Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT__VIRTUAL_PROCESSOR_SUBCOMPONENT_TYPE = SUBCOMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Virtual Processor Subcomponent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_SUBCOMPONENT_FEATURE_COUNT = SUBCOMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Abstract Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Bus Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Bus Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_BUS_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Bus Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Virtual Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION__OWNED_VIRTUAL_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Bus Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Bus Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_DATA_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Data Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Data Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Data Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Device Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Bus Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_BUS_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Device Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Virtual Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION__OWNED_VIRTUAL_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Device Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Device Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Memory Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Bus Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_BUS_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Memory Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Memory Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION__OWNED_MEMORY_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Memory Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Memory Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Parameter</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_PARAMETER = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_DATA_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Subprogram Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_ELEMENT = BEHAVIORED_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_COMMENT = BEHAVIORED_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NAME = BEHAVIORED_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__QUALIFIED_NAME = BEHAVIORED_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = BEHAVIORED_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_MEMBER = BEHAVIORED_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__MEMBER = BEHAVIORED_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__CLASSIFIER_FEATURE = BEHAVIORED_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__INHERITED_MEMBER = BEHAVIORED_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__GENERALIZATION = BEHAVIORED_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__GENERAL = BEHAVIORED_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = BEHAVIORED_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_PROTOTYPE = BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_PROTOTYPES = BEHAVIORED_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_ANNEXES = BEHAVIORED_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_PROPERTIES = BEHAVIORED_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_MODE = BEHAVIORED_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_MODE_TRANSITION = BEHAVIORED_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__DERIVED_MODES = BEHAVIORED_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_FLOWS = BEHAVIORED_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_MODES = BEHAVIORED_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__TYPE = BEHAVIORED_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__EXTENDED = BEHAVIORED_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = BEHAVIORED_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_EXTENSION = BEHAVIORED_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_REALIZATION = BEHAVIORED_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_END_TO_END_FLOW = BEHAVIORED_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_PORT_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_SUBCOMPONENTS = BEHAVIORED_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_CONNECTIONS = BEHAVIORED_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__NO_CALLS = BEHAVIORED_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = BEHAVIORED_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = BEHAVIORED_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_EVENT_SOURCE = BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_PORT_PROXY = BEHAVIORED_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Subprogram Call</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__SUBPROGRAM_CALL = BEHAVIORED_IMPLEMENTATION__SUBPROGRAM_CALL;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Call Sequence</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_SUBPROGRAM_CALL_SEQUENCE = BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_CALL_SEQUENCE;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Subprogram Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_IMPLEMENTATION_FEATURE_COUNT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Subprogram Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Subprogram Group Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Subprogram Group Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_SUBPROGRAM_GROUP_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Subprogram Group Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Subprogram Group Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBPROGRAM_GROUP_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>System Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Bus Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_BUS_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_DATA_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>System Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Device Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_DEVICE_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Memory Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_MEMORY_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Process Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PROCESS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Processor Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_PROCESSOR_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_SUBPROGRAM_GROUP_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Owned System Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_SYSTEM_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Owned Virtual Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_VIRTUAL_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Owned Virtual Processor Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION__OWNED_VIRTUAL_PROCESSOR_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 10;

	/**
	 * The number of structural features of the '<em>System Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>System Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Processor Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Bus Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_BUS_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Processor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Memory Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_MEMORY_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Virtual Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_VIRTUAL_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Virtual Processor Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION__OWNED_VIRTUAL_PROCESSOR_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Processor Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Processor Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Process Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_DATA_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Process Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_SUBPROGRAM_GROUP_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Thread Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_THREAD_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Thread Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION__OWNED_THREAD_GROUP_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Process Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Process Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Thread Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_DATA_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Thread Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_ELEMENT = BEHAVIORED_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_COMMENT = BEHAVIORED_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NAME = BEHAVIORED_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__QUALIFIED_NAME = BEHAVIORED_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = BEHAVIORED_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_MEMBER = BEHAVIORED_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__MEMBER = BEHAVIORED_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__CLASSIFIER_FEATURE = BEHAVIORED_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__INHERITED_MEMBER = BEHAVIORED_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__GENERALIZATION = BEHAVIORED_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__GENERAL = BEHAVIORED_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = BEHAVIORED_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_PROTOTYPE = BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = BEHAVIORED_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_PROTOTYPES = BEHAVIORED_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_ANNEXES = BEHAVIORED_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_PROPERTIES = BEHAVIORED_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_MODE = BEHAVIORED_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_MODE_TRANSITION = BEHAVIORED_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__DERIVED_MODES = BEHAVIORED_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_FLOWS = BEHAVIORED_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_MODES = BEHAVIORED_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__TYPE = BEHAVIORED_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__EXTENDED = BEHAVIORED_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = BEHAVIORED_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_EXTENSION = BEHAVIORED_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_REALIZATION = BEHAVIORED_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_END_TO_END_FLOW = BEHAVIORED_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_PORT_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = BEHAVIORED_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_SUBCOMPONENTS = BEHAVIORED_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_CONNECTIONS = BEHAVIORED_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__NO_CALLS = BEHAVIORED_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = BEHAVIORED_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = BEHAVIORED_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_EVENT_SOURCE = BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = BEHAVIORED_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_PORT_PROXY = BEHAVIORED_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Subprogram Call</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__SUBPROGRAM_CALL = BEHAVIORED_IMPLEMENTATION__SUBPROGRAM_CALL;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Call Sequence</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_SUBPROGRAM_CALL_SEQUENCE = BEHAVIORED_IMPLEMENTATION__OWNED_SUBPROGRAM_CALL_SEQUENCE;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_SUBPROGRAM_GROUP_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Thread Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_IMPLEMENTATION_FEATURE_COUNT = BEHAVIORED_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Thread Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Thread Group Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_DATA_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Thread Group Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Data Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_DATA_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Thread Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_THREAD_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Thread Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_THREAD_GROUP_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_SUBPROGRAM_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION__OWNED_SUBPROGRAM_GROUP_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Thread Group Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Thread Group Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_GROUP_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Virtual Bus Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Virtual Bus Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Virtual Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION__OWNED_VIRTUAL_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Virtual Bus Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Virtual Bus Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_BUS_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_ELEMENT = COMPONENT_CLASSIFIER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_COMMENT = COMPONENT_CLASSIFIER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__NAME = COMPONENT_CLASSIFIER__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__QUALIFIED_NAME = COMPONENT_CLASSIFIER__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION = COMPONENT_CLASSIFIER__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_MEMBER = COMPONENT_CLASSIFIER__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__MEMBER = COMPONENT_CLASSIFIER__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__CLASSIFIER_FEATURE = COMPONENT_CLASSIFIER__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__INHERITED_MEMBER = COMPONENT_CLASSIFIER__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__GENERALIZATION = COMPONENT_CLASSIFIER__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__GENERAL = COMPONENT_CLASSIFIER__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE = COMPONENT_CLASSIFIER__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_PROTOTYPE = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_PROTOTYPE_BINDING = COMPONENT_CLASSIFIER__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__NO_PROTOTYPES = COMPONENT_CLASSIFIER__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__NO_ANNEXES = COMPONENT_CLASSIFIER__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__NO_PROPERTIES = COMPONENT_CLASSIFIER__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_MODE = COMPONENT_CLASSIFIER__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__OWNED_MODE_TRANSITION = COMPONENT_CLASSIFIER__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__DERIVED_MODES = COMPONENT_CLASSIFIER__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__NO_FLOWS = COMPONENT_CLASSIFIER__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER__NO_MODES = COMPONENT_CLASSIFIER__NO_MODES;

	/**
	 * The number of structural features of the '<em>Virtual Processor Classifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_CLASSIFIER_FEATURE_COUNT = COMPONENT_CLASSIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_ELEMENT = COMPONENT_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_COMMENT = COMPONENT_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__QUALIFIED_NAME = COMPONENT_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_MEMBER = COMPONENT_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__MEMBER = COMPONENT_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__CLASSIFIER_FEATURE = COMPONENT_TYPE__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__INHERITED_MEMBER = COMPONENT_TYPE__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__GENERALIZATION = COMPONENT_TYPE__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__GENERAL = COMPONENT_TYPE__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_ANNEX_SUBCLAUSE = COMPONENT_TYPE__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_PROTOTYPE = COMPONENT_TYPE__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_PROTOTYPE_BINDING = COMPONENT_TYPE__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__NO_PROTOTYPES = COMPONENT_TYPE__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__NO_ANNEXES = COMPONENT_TYPE__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__NO_PROPERTIES = COMPONENT_TYPE__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_MODE = COMPONENT_TYPE__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_MODE_TRANSITION = COMPONENT_TYPE__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__DERIVED_MODES = COMPONENT_TYPE__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__NO_FLOWS = COMPONENT_TYPE__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__NO_MODES = COMPONENT_TYPE__NO_MODES;

	/**
	 * The feature id for the '<em><b>Owned Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_FEATURE = COMPONENT_TYPE__OWNED_FEATURE;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__EXTENDED = COMPONENT_TYPE__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Specification</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_FLOW_SPECIFICATION = COMPONENT_TYPE__OWNED_FLOW_SPECIFICATION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_EXTENSION = COMPONENT_TYPE__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_FEATURE_GROUP = COMPONENT_TYPE__OWNED_FEATURE_GROUP;

	/**
	 * The feature id for the '<em><b>Owned Abstract Feature</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_ABSTRACT_FEATURE = COMPONENT_TYPE__OWNED_ABSTRACT_FEATURE;

	/**
	 * The feature id for the '<em><b>No Features</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__NO_FEATURES = COMPONENT_TYPE__NO_FEATURES;

	/**
	 * The feature id for the '<em><b>Owned Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Event Data Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_EVENT_DATA_PORT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Event Port</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_EVENT_PORT = COMPONENT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_SUBPROGRAM_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Group Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE__OWNED_SUBPROGRAM_GROUP_ACCESS = COMPONENT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Virtual Processor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_ELEMENT = COMPONENT_IMPLEMENTATION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_COMMENT = COMPONENT_IMPLEMENTATION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NAME = COMPONENT_IMPLEMENTATION__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__QUALIFIED_NAME = COMPONENT_IMPLEMENTATION__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION = COMPONENT_IMPLEMENTATION__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_MEMBER = COMPONENT_IMPLEMENTATION__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__MEMBER = COMPONENT_IMPLEMENTATION__MEMBER;

	/**
	 * The feature id for the '<em><b>Classifier Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__CLASSIFIER_FEATURE = COMPONENT_IMPLEMENTATION__CLASSIFIER_FEATURE;

	/**
	 * The feature id for the '<em><b>Inherited Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__INHERITED_MEMBER = COMPONENT_IMPLEMENTATION__INHERITED_MEMBER;

	/**
	 * The feature id for the '<em><b>Generalization</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__GENERALIZATION = COMPONENT_IMPLEMENTATION__GENERALIZATION;

	/**
	 * The feature id for the '<em><b>General</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__GENERAL = COMPONENT_IMPLEMENTATION__GENERAL;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE = COMPONENT_IMPLEMENTATION__OWNED_ANNEX_SUBCLAUSE;

	/**
	 * The feature id for the '<em><b>Owned Prototype</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_PROTOTYPE = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE;

	/**
	 * The feature id for the '<em><b>Owned Prototype Binding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING = COMPONENT_IMPLEMENTATION__OWNED_PROTOTYPE_BINDING;

	/**
	 * The feature id for the '<em><b>No Prototypes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_PROTOTYPES = COMPONENT_IMPLEMENTATION__NO_PROTOTYPES;

	/**
	 * The feature id for the '<em><b>No Annexes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_ANNEXES = COMPONENT_IMPLEMENTATION__NO_ANNEXES;

	/**
	 * The feature id for the '<em><b>No Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_PROPERTIES = COMPONENT_IMPLEMENTATION__NO_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Owned Mode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_MODE = COMPONENT_IMPLEMENTATION__OWNED_MODE;

	/**
	 * The feature id for the '<em><b>Owned Mode Transition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_MODE_TRANSITION = COMPONENT_IMPLEMENTATION__OWNED_MODE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Derived Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__DERIVED_MODES = COMPONENT_IMPLEMENTATION__DERIVED_MODES;

	/**
	 * The feature id for the '<em><b>No Flows</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_FLOWS = COMPONENT_IMPLEMENTATION__NO_FLOWS;

	/**
	 * The feature id for the '<em><b>No Modes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_MODES = COMPONENT_IMPLEMENTATION__NO_MODES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__TYPE = COMPONENT_IMPLEMENTATION__TYPE;

	/**
	 * The feature id for the '<em><b>Owned Subcomponent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Extended</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__EXTENDED = COMPONENT_IMPLEMENTATION__EXTENDED;

	/**
	 * The feature id for the '<em><b>Owned Flow Implementation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION = COMPONENT_IMPLEMENTATION__OWNED_FLOW_IMPLEMENTATION;

	/**
	 * The feature id for the '<em><b>Owned Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Extension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_EXTENSION = COMPONENT_IMPLEMENTATION__OWNED_EXTENSION;

	/**
	 * The feature id for the '<em><b>Owned Realization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_REALIZATION = COMPONENT_IMPLEMENTATION__OWNED_REALIZATION;

	/**
	 * The feature id for the '<em><b>Owned End To End Flow</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_END_TO_END_FLOW = COMPONENT_IMPLEMENTATION__OWNED_END_TO_END_FLOW;

	/**
	 * The feature id for the '<em><b>Owned Abstract Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT = COMPONENT_IMPLEMENTATION__OWNED_ABSTRACT_SUBCOMPONENT;

	/**
	 * The feature id for the '<em><b>Owned Access Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_ACCESS_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_ACCESS_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Parameter Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PARAMETER_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Port Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_PORT_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_PORT_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_FEATURE_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_CONNECTION;

	/**
	 * The feature id for the '<em><b>Owned Feature Group Connection</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION = COMPONENT_IMPLEMENTATION__OWNED_FEATURE_GROUP_CONNECTION;

	/**
	 * The feature id for the '<em><b>No Subcomponents</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_SUBCOMPONENTS = COMPONENT_IMPLEMENTATION__NO_SUBCOMPONENTS;

	/**
	 * The feature id for the '<em><b>No Connections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_CONNECTIONS = COMPONENT_IMPLEMENTATION__NO_CONNECTIONS;

	/**
	 * The feature id for the '<em><b>No Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__NO_CALLS = COMPONENT_IMPLEMENTATION__NO_CALLS;

	/**
	 * The feature id for the '<em><b>Owned Processor Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_PROCESSOR_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Internal Feature</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_INTERNAL_FEATURE = COMPONENT_IMPLEMENTATION__OWNED_INTERNAL_FEATURE;

	/**
	 * The feature id for the '<em><b>Owned Event Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_EVENT_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Event Data Source</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE = COMPONENT_IMPLEMENTATION__OWNED_EVENT_DATA_SOURCE;

	/**
	 * The feature id for the '<em><b>Owned Port Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_PORT_PROXY = COMPONENT_IMPLEMENTATION__OWNED_PORT_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Subprogram Proxy</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY = COMPONENT_IMPLEMENTATION__OWNED_SUBPROGRAM_PROXY;

	/**
	 * The feature id for the '<em><b>Owned Virtual Bus Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_VIRTUAL_BUS_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Virtual Processor Subcomponent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION__OWNED_VIRTUAL_PROCESSOR_SUBCOMPONENT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Virtual Processor Implementation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_IMPLEMENTATION_FEATURE_COUNT = COMPONENT_IMPLEMENTATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__OWNED_ELEMENT = COMPONENT_PROTOTYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__OWNED_COMMENT = COMPONENT_PROTOTYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__NAME = COMPONENT_PROTOTYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__QUALIFIED_NAME = COMPONENT_PROTOTYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION = COMPONENT_PROTOTYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Refinement Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__REFINEMENT_CONTEXT = COMPONENT_PROTOTYPE__REFINEMENT_CONTEXT;

	/**
	 * The feature id for the '<em><b>Refined Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__REFINED_ELEMENT = COMPONENT_PROTOTYPE__REFINED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Featuring Classifier</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__FEATURING_CLASSIFIER = COMPONENT_PROTOTYPE__FEATURING_CLASSIFIER;

	/**
	 * The feature id for the '<em><b>Refined</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__REFINED = COMPONENT_PROTOTYPE__REFINED;

	/**
	 * The feature id for the '<em><b>Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__ARRAY = COMPONENT_PROTOTYPE__ARRAY;

	/**
	 * The feature id for the '<em><b>Constraining Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE__CONSTRAINING_CLASSIFIER = COMPONENT_PROTOTYPE__CONSTRAINING_CLASSIFIER;

	/**
	 * The number of structural features of the '<em>Virtual Processor Prototype</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_PROCESSOR_PROTOTYPE_FEATURE_COUNT = COMPONENT_PROTOTYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY_ASSOCIATION__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY_ASSOCIATION__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY_ASSOCIATION__PROPERTY = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY_ASSOCIATION__OWNED_VALUE = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Basic Property Association</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_PROPERTY_ASSOCIATION_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__OWNED_ELEMENT = TYPED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__OWNED_COMMENT = TYPED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__NAME = TYPED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__QUALIFIED_NAME = TYPED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__OWNED_PROPERTY_ASSOCIATION = TYPED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__TYPE = TYPED_ELEMENT__TYPE;

	/**
	 * The feature id for the '<em><b>Property Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__PROPERTY_TYPE = TYPED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Property Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__OWNED_PROPERTY_TYPE = TYPED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Constant Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT__CONSTANT_VALUE = TYPED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Property Constant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_CONSTANT_FEATURE_COUNT = TYPED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertyValueImpl <em>Property Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertyValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPropertyValue()
	 * @generated
	 */
	int PROPERTY_VALUE = 227;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EnumerationLiteralImpl <em>Enumeration Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EnumerationLiteralImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEnumerationLiteral()
	 * @generated
	 */
	int ENUMERATION_LITERAL = 230;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.UnitLiteralImpl <em>Unit Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.UnitLiteralImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getUnitLiteral()
	 * @generated
	 */
	int UNIT_LITERAL = 229;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE__OWNED_ELEMENT = PROPERTY_EXPRESSION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE__OWNED_COMMENT = PROPERTY_EXPRESSION__OWNED_COMMENT;

	/**
	 * The number of structural features of the '<em>Property Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_FEATURE_COUNT = PROPERTY_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.NumberValueImpl <em>Number Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.NumberValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getNumberValue()
	 * @generated
	 */
	int NUMBER_VALUE = 228;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.StringLiteralImpl <em>String Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.StringLiteralImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getStringLiteral()
	 * @generated
	 */
	int STRING_LITERAL = 226;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_LITERAL__OWNED_ELEMENT = PROPERTY_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_LITERAL__OWNED_COMMENT = PROPERTY_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_LITERAL__VALUE = PROPERTY_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>String Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_LITERAL_FEATURE_COUNT = PROPERTY_VALUE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_VALUE__OWNED_ELEMENT = PROPERTY_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_VALUE__OWNED_COMMENT = PROPERTY_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_VALUE__UNIT = PROPERTY_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Number Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_VALUE_FEATURE_COUNT = PROPERTY_VALUE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_LITERAL__OWNED_ELEMENT = NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_LITERAL__OWNED_COMMENT = NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_LITERAL__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_LITERAL__QUALIFIED_NAME = NAMED_ELEMENT__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_LITERAL__OWNED_PROPERTY_ASSOCIATION = NAMED_ELEMENT__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Enumeration Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_LITERAL_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL__OWNED_ELEMENT = ENUMERATION_LITERAL__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL__OWNED_COMMENT = ENUMERATION_LITERAL__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL__NAME = ENUMERATION_LITERAL__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL__QUALIFIED_NAME = ENUMERATION_LITERAL__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL__OWNED_PROPERTY_ASSOCIATION = ENUMERATION_LITERAL__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Base Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL__BASE_UNIT = ENUMERATION_LITERAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL__FACTOR = ENUMERATION_LITERAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Unit Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_LITERAL_FEATURE_COUNT = ENUMERATION_LITERAL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ClassifierValueImpl <em>Classifier Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ClassifierValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getClassifierValue()
	 * @generated
	 */
	int CLASSIFIER_VALUE = 231;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_VALUE__OWNED_ELEMENT = PROPERTY_OWNER__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_VALUE__OWNED_COMMENT = PROPERTY_OWNER__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Classifier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_VALUE__CLASSIFIER = PROPERTY_OWNER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Classifier Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_VALUE_FEATURE_COUNT = PROPERTY_OWNER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ReferenceValueImpl <em>Reference Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ReferenceValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getReferenceValue()
	 * @generated
	 */
	int REFERENCE_VALUE = 232;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_VALUE__OWNED_ELEMENT = CONTAINED_NAMED_ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_VALUE__OWNED_COMMENT = CONTAINED_NAMED_ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Containment Path Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_VALUE__CONTAINMENT_PATH_ELEMENT = CONTAINED_NAMED_ELEMENT__CONTAINMENT_PATH_ELEMENT;

	/**
	 * The number of structural features of the '<em>Reference Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_VALUE_FEATURE_COUNT = CONTAINED_NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.BooleanLiteralImpl <em>Boolean Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.BooleanLiteralImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBooleanLiteral()
	 * @generated
	 */
	int BOOLEAN_LITERAL = 233;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_LITERAL__OWNED_ELEMENT = PROPERTY_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_LITERAL__OWNED_COMMENT = PROPERTY_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_LITERAL__VALUE = PROPERTY_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Boolean Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_LITERAL_FEATURE_COUNT = PROPERTY_VALUE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RangeValueImpl <em>Range Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RangeValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRangeValue()
	 * @generated
	 */
	int RANGE_VALUE = 234;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_VALUE__OWNED_ELEMENT = PROPERTY_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_VALUE__OWNED_COMMENT = PROPERTY_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Minimum</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_VALUE__MINIMUM = PROPERTY_VALUE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Maximum</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_VALUE__MAXIMUM = PROPERTY_VALUE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Delta</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_VALUE__DELTA = PROPERTY_VALUE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Range Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_VALUE_FEATURE_COUNT = PROPERTY_VALUE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.IntegerLiteralImpl <em>Integer Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.IntegerLiteralImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getIntegerLiteral()
	 * @generated
	 */
	int INTEGER_LITERAL = 235;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL__OWNED_ELEMENT = NUMBER_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL__OWNED_COMMENT = NUMBER_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL__UNIT = NUMBER_VALUE__UNIT;

	/**
	 * The feature id for the '<em><b>Base</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL__BASE = NUMBER_VALUE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL__VALUE = NUMBER_VALUE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Integer Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL_FEATURE_COUNT = NUMBER_VALUE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RealLiteralImpl <em>Real Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RealLiteralImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRealLiteral()
	 * @generated
	 */
	int REAL_LITERAL = 236;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_LITERAL__OWNED_ELEMENT = NUMBER_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_LITERAL__OWNED_COMMENT = NUMBER_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_LITERAL__UNIT = NUMBER_VALUE__UNIT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_LITERAL__VALUE = NUMBER_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Real Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_LITERAL_FEATURE_COUNT = NUMBER_VALUE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.OperationImpl <em>Operation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.OperationImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getOperation()
	 * @generated
	 */
	int OPERATION = 237;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION__OWNED_ELEMENT = PROPERTY_EXPRESSION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION__OWNED_COMMENT = PROPERTY_EXPRESSION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Op</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION__OP = PROPERTY_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Property Expression</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION__OWNED_PROPERTY_EXPRESSION = PROPERTY_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Operation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_FEATURE_COUNT = PROPERTY_EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RecordValueImpl <em>Record Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RecordValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRecordValue()
	 * @generated
	 */
	int RECORD_VALUE = 238;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_VALUE__OWNED_ELEMENT = PROPERTY_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_VALUE__OWNED_COMMENT = PROPERTY_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Owned Field Value</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_VALUE__OWNED_FIELD_VALUE = PROPERTY_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Record Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_VALUE_FEATURE_COUNT = PROPERTY_VALUE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ComputedValueImpl <em>Computed Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ComputedValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComputedValue()
	 * @generated
	 */
	int COMPUTED_VALUE = 239;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTED_VALUE__OWNED_ELEMENT = PROPERTY_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTED_VALUE__OWNED_COMMENT = PROPERTY_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Function</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTED_VALUE__FUNCTION = PROPERTY_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Computed Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTED_VALUE_FEATURE_COUNT = PROPERTY_VALUE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ListValueImpl <em>List Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ListValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getListValue()
	 * @generated
	 */
	int LIST_VALUE = 240;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_VALUE__OWNED_ELEMENT = PROPERTY_EXPRESSION__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_VALUE__OWNED_COMMENT = PROPERTY_EXPRESSION__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Owned List Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_VALUE__OWNED_LIST_ELEMENT = PROPERTY_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>List Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_VALUE_FEATURE_COUNT = PROPERTY_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.NamedValueImpl <em>Named Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.NamedValueImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getNamedValue()
	 * @generated
	 */
	int NAMED_VALUE = 241;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_VALUE__OWNED_ELEMENT = PROPERTY_VALUE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_VALUE__OWNED_COMMENT = PROPERTY_VALUE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Named Value</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_VALUE__NAMED_VALUE = PROPERTY_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Named Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_VALUE_FEATURE_COUNT = PROPERTY_VALUE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.PropertySetImpl <em>Property Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.PropertySetImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPropertySet()
	 * @generated
	 */
	int PROPERTY_SET = 242;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_ELEMENT = NAMESPACE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_COMMENT = NAMESPACE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__NAME = NAMESPACE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__QUALIFIED_NAME = NAMESPACE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_PROPERTY_ASSOCIATION = NAMESPACE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_MEMBER = NAMESPACE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__MEMBER = NAMESPACE__MEMBER;

	/**
	 * The feature id for the '<em><b>Owned Property Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_PROPERTY_TYPE = NAMESPACE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_PROPERTY = NAMESPACE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Owned Property Constant</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_PROPERTY_CONSTANT = NAMESPACE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Imported Unit</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__IMPORTED_UNIT = NAMESPACE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owned Annex Subclause</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET__OWNED_ANNEX_SUBCLAUSE = NAMESPACE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Property Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET_FEATURE_COUNT = NAMESPACE_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.GlobalNamespaceImpl <em>Global Namespace</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.GlobalNamespaceImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getGlobalNamespace()
	 * @generated
	 */
	int GLOBAL_NAMESPACE = 243;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__OWNED_ELEMENT = NAMESPACE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__OWNED_COMMENT = NAMESPACE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__NAME = NAMESPACE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__QUALIFIED_NAME = NAMESPACE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__OWNED_PROPERTY_ASSOCIATION = NAMESPACE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__OWNED_MEMBER = NAMESPACE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__MEMBER = NAMESPACE__MEMBER;

	/**
	 * The feature id for the '<em><b>Package</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__PACKAGE = NAMESPACE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Property Set</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE__PROPERTY_SET = NAMESPACE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Global Namespace</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GLOBAL_NAMESPACE_FEATURE_COUNT = NAMESPACE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.NonListTypeImpl <em>Non List Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.NonListTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getNonListType()
	 * @generated
	 */
	int NON_LIST_TYPE = 244;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_LIST_TYPE__OWNED_ELEMENT = PROPERTY_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_LIST_TYPE__OWNED_COMMENT = PROPERTY_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_LIST_TYPE__NAME = PROPERTY_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_LIST_TYPE__QUALIFIED_NAME = PROPERTY_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_LIST_TYPE__OWNED_PROPERTY_ASSOCIATION = PROPERTY_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Non List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_LIST_TYPE_FEATURE_COUNT = PROPERTY_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AadlBooleanImpl <em>Aadl Boolean</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AadlBooleanImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAadlBoolean()
	 * @generated
	 */
	int AADL_BOOLEAN = 245;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_BOOLEAN__OWNED_ELEMENT = NON_LIST_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_BOOLEAN__OWNED_COMMENT = NON_LIST_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_BOOLEAN__NAME = NON_LIST_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_BOOLEAN__QUALIFIED_NAME = NON_LIST_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_BOOLEAN__OWNED_PROPERTY_ASSOCIATION = NON_LIST_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Aadl Boolean</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_BOOLEAN_FEATURE_COUNT = NON_LIST_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AadlStringImpl <em>Aadl String</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AadlStringImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAadlString()
	 * @generated
	 */
	int AADL_STRING = 246;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_STRING__OWNED_ELEMENT = NON_LIST_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_STRING__OWNED_COMMENT = NON_LIST_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_STRING__NAME = NON_LIST_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_STRING__QUALIFIED_NAME = NON_LIST_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_STRING__OWNED_PROPERTY_ASSOCIATION = NON_LIST_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The number of structural features of the '<em>Aadl String</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_STRING_FEATURE_COUNT = NON_LIST_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.NumberTypeImpl <em>Number Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.NumberTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getNumberType()
	 * @generated
	 */
	int NUMBER_TYPE = 248;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__OWNED_ELEMENT = NON_LIST_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__OWNED_COMMENT = NON_LIST_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__NAME = NON_LIST_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__QUALIFIED_NAME = NON_LIST_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__OWNED_PROPERTY_ASSOCIATION = NON_LIST_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Units Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__OWNED_UNITS_TYPE = NON_LIST_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Units Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__UNITS_TYPE = NON_LIST_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE__RANGE = NON_LIST_TYPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Number Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_TYPE_FEATURE_COUNT = NON_LIST_TYPE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AadlIntegerImpl <em>Aadl Integer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AadlIntegerImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAadlInteger()
	 * @generated
	 */
	int AADL_INTEGER = 247;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__OWNED_ELEMENT = NUMBER_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__OWNED_COMMENT = NUMBER_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__NAME = NUMBER_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__QUALIFIED_NAME = NUMBER_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__OWNED_PROPERTY_ASSOCIATION = NUMBER_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Units Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__OWNED_UNITS_TYPE = NUMBER_TYPE__OWNED_UNITS_TYPE;

	/**
	 * The feature id for the '<em><b>Units Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__UNITS_TYPE = NUMBER_TYPE__UNITS_TYPE;

	/**
	 * The feature id for the '<em><b>Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER__RANGE = NUMBER_TYPE__RANGE;

	/**
	 * The number of structural features of the '<em>Aadl Integer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_INTEGER_FEATURE_COUNT = NUMBER_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.EnumerationTypeImpl <em>Enumeration Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.EnumerationTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getEnumerationType()
	 * @generated
	 */
	int ENUMERATION_TYPE = 250;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__OWNED_ELEMENT = NAMESPACE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__OWNED_COMMENT = NAMESPACE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__NAME = NAMESPACE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__QUALIFIED_NAME = NAMESPACE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__OWNED_PROPERTY_ASSOCIATION = NAMESPACE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__OWNED_MEMBER = NAMESPACE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__MEMBER = NAMESPACE__MEMBER;

	/**
	 * The feature id for the '<em><b>Owned Literal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__OWNED_LITERAL = NAMESPACE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Enumeration Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE_FEATURE_COUNT = NAMESPACE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.UnitsTypeImpl <em>Units Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.UnitsTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getUnitsType()
	 * @generated
	 */
	int UNITS_TYPE = 249;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__OWNED_ELEMENT = ENUMERATION_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__OWNED_COMMENT = ENUMERATION_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__NAME = ENUMERATION_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__QUALIFIED_NAME = ENUMERATION_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__OWNED_PROPERTY_ASSOCIATION = ENUMERATION_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__OWNED_MEMBER = ENUMERATION_TYPE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__MEMBER = ENUMERATION_TYPE__MEMBER;

	/**
	 * The feature id for the '<em><b>Owned Literal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE__OWNED_LITERAL = ENUMERATION_TYPE__OWNED_LITERAL;

	/**
	 * The number of structural features of the '<em>Units Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNITS_TYPE_FEATURE_COUNT = ENUMERATION_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.NumericRangeImpl <em>Numeric Range</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.NumericRangeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getNumericRange()
	 * @generated
	 */
	int NUMERIC_RANGE = 251;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMERIC_RANGE__OWNED_ELEMENT = ELEMENT__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMERIC_RANGE__OWNED_COMMENT = ELEMENT__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMERIC_RANGE__UPPER_BOUND = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Lower Bound</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMERIC_RANGE__LOWER_BOUND = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Numeric Range</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMERIC_RANGE_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.AadlRealImpl <em>Aadl Real</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.AadlRealImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAadlReal()
	 * @generated
	 */
	int AADL_REAL = 252;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__OWNED_ELEMENT = NUMBER_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__OWNED_COMMENT = NUMBER_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__NAME = NUMBER_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__QUALIFIED_NAME = NUMBER_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__OWNED_PROPERTY_ASSOCIATION = NUMBER_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Units Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__OWNED_UNITS_TYPE = NUMBER_TYPE__OWNED_UNITS_TYPE;

	/**
	 * The feature id for the '<em><b>Units Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__UNITS_TYPE = NUMBER_TYPE__UNITS_TYPE;

	/**
	 * The feature id for the '<em><b>Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL__RANGE = NUMBER_TYPE__RANGE;

	/**
	 * The number of structural features of the '<em>Aadl Real</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AADL_REAL_FEATURE_COUNT = NUMBER_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ClassifierTypeImpl <em>Classifier Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ClassifierTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getClassifierType()
	 * @generated
	 */
	int CLASSIFIER_TYPE = 253;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_TYPE__OWNED_ELEMENT = NON_LIST_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_TYPE__OWNED_COMMENT = NON_LIST_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_TYPE__NAME = NON_LIST_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_TYPE__QUALIFIED_NAME = NON_LIST_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_TYPE__OWNED_PROPERTY_ASSOCIATION = NON_LIST_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Classifier Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_TYPE__CLASSIFIER_REFERENCE = NON_LIST_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Classifier Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_TYPE_FEATURE_COUNT = NON_LIST_TYPE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RangeTypeImpl <em>Range Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RangeTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRangeType()
	 * @generated
	 */
	int RANGE_TYPE = 254;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE__OWNED_ELEMENT = NON_LIST_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE__OWNED_COMMENT = NON_LIST_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE__NAME = NON_LIST_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE__QUALIFIED_NAME = NON_LIST_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE__OWNED_PROPERTY_ASSOCIATION = NON_LIST_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Number Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE__OWNED_NUMBER_TYPE = NON_LIST_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Number Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE__NUMBER_TYPE = NON_LIST_TYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Range Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANGE_TYPE_FEATURE_COUNT = NON_LIST_TYPE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RecordTypeImpl <em>Record Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RecordTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRecordType()
	 * @generated
	 */
	int RECORD_TYPE = 255;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__OWNED_ELEMENT = NAMESPACE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__OWNED_COMMENT = NAMESPACE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__NAME = NAMESPACE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__QUALIFIED_NAME = NAMESPACE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__OWNED_PROPERTY_ASSOCIATION = NAMESPACE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__OWNED_MEMBER = NAMESPACE__OWNED_MEMBER;

	/**
	 * The feature id for the '<em><b>Member</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__MEMBER = NAMESPACE__MEMBER;

	/**
	 * The feature id for the '<em><b>Owned Field</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__OWNED_FIELD = NAMESPACE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Record Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE_FEATURE_COUNT = NAMESPACE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.RecordFieldImpl <em>Record Field</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.RecordFieldImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getRecordField()
	 * @generated
	 */
	int RECORD_FIELD = 256;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__OWNED_ELEMENT = BASIC_PROPERTY__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__OWNED_COMMENT = BASIC_PROPERTY__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__NAME = BASIC_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__QUALIFIED_NAME = BASIC_PROPERTY__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__OWNED_PROPERTY_ASSOCIATION = BASIC_PROPERTY__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__TYPE = BASIC_PROPERTY__TYPE;

	/**
	 * The feature id for the '<em><b>Property Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__PROPERTY_TYPE = BASIC_PROPERTY__PROPERTY_TYPE;

	/**
	 * The feature id for the '<em><b>Owned Property Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD__OWNED_PROPERTY_TYPE = BASIC_PROPERTY__OWNED_PROPERTY_TYPE;

	/**
	 * The number of structural features of the '<em>Record Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_FIELD_FEATURE_COUNT = BASIC_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ReferenceTypeImpl <em>Reference Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ReferenceTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getReferenceType()
	 * @generated
	 */
	int REFERENCE_TYPE = 257;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_TYPE__OWNED_ELEMENT = NON_LIST_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_TYPE__OWNED_COMMENT = NON_LIST_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_TYPE__NAME = NON_LIST_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_TYPE__QUALIFIED_NAME = NON_LIST_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_TYPE__OWNED_PROPERTY_ASSOCIATION = NON_LIST_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Named Element Reference</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_TYPE__NAMED_ELEMENT_REFERENCE = NON_LIST_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Reference Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_TYPE_FEATURE_COUNT = NON_LIST_TYPE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.impl.ListTypeImpl <em>List Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.ListTypeImpl
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getListType()
	 * @generated
	 */
	int LIST_TYPE = 258;

	/**
	 * The feature id for the '<em><b>Owned Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE__OWNED_ELEMENT = PROPERTY_TYPE__OWNED_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Comment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE__OWNED_COMMENT = PROPERTY_TYPE__OWNED_COMMENT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE__NAME = PROPERTY_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Qualified Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE__QUALIFIED_NAME = PROPERTY_TYPE__QUALIFIED_NAME;

	/**
	 * The feature id for the '<em><b>Owned Property Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE__OWNED_PROPERTY_ASSOCIATION = PROPERTY_TYPE__OWNED_PROPERTY_ASSOCIATION;

	/**
	 * The feature id for the '<em><b>Owned Element Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE__OWNED_ELEMENT_TYPE = PROPERTY_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Element Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE__ELEMENT_TYPE = PROPERTY_TYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_TYPE_FEATURE_COUNT = PROPERTY_TYPE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.DirectionType <em>Direction Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.DirectionType
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getDirectionType()
	 * @generated
	 */
	int DIRECTION_TYPE = 260;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.PortCategory <em>Port Category</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.PortCategory
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getPortCategory()
	 * @generated
	 */
	int PORT_CATEGORY = 263;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.FlowKind <em>Flow Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.FlowKind
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getFlowKind()
	 * @generated
	 */
	int FLOW_KIND = 259;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.AccessType <em>Access Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.AccessType
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAccessType()
	 * @generated
	 */
	int ACCESS_TYPE = 261;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.AccessCategory <em>Access Category</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.AccessCategory
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getAccessCategory()
	 * @generated
	 */
	int ACCESS_CATEGORY = 262;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.ComponentCategory <em>Component Category</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.ComponentCategory
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getComponentCategory()
	 * @generated
	 */
	int COMPONENT_CATEGORY = 264;

	/**
	 * The meta object id for the '{@link org.osate.aadl2.OperationKind <em>Operation Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.OperationKind
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getOperationKind()
	 * @generated
	 */
	int OPERATION_KIND = 265;

	/**
	 * The meta object id for the '<em>String</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.lang.String
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getString()
	 * @generated
	 */
	int STRING = 266;

	/**
	 * The meta object id for the '<em>Boolean</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getBoolean()
	 * @generated
	 */
	int BOOLEAN = 267;

	/**
	 * The meta object id for the '<em>Integer</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getInteger()
	 * @generated
	 */
	int INTEGER = 268;

	/**
	 * The meta object id for the '<em>Real</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.osate.aadl2.impl.Aadl2PackageImpl#getReal()
	 * @generated
	 */
	int REAL = 269;

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Element <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Element</em>'.
	 * @see org.osate.aadl2.Element
	 * @generated
	 */
	EClass getElement();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Element#getOwnedElements <em>Owned Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Element</em>'.
	 * @see org.osate.aadl2.Element#getOwnedElements()
	 * @see #getElement()
	 * @generated
	 */
	EReference getElement_OwnedElement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Element#getOwnedComments <em>Owned Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Comment</em>'.
	 * @see org.osate.aadl2.Element#getOwnedComments()
	 * @see #getElement()
	 * @generated
	 */
	EReference getElement_OwnedComment();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Comment <em>Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comment</em>'.
	 * @see org.osate.aadl2.Comment
	 * @generated
	 */
	EClass getComment();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Comment#getBody <em>Body</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Body</em>'.
	 * @see org.osate.aadl2.Comment#getBody()
	 * @see #getComment()
	 * @generated
	 */
	EAttribute getComment_Body();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Type <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type</em>'.
	 * @see org.osate.aadl2.Type
	 * @generated
	 */
	EClass getType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Named Element</em>'.
	 * @see org.osate.aadl2.NamedElement
	 * @generated
	 */
	EClass getNamedElement();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.NamedElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.osate.aadl2.NamedElement#getName()
	 * @see #getNamedElement()
	 * @generated
	 */
	EAttribute getNamedElement_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.NamedElement#getQualifiedName <em>Qualified Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Qualified Name</em>'.
	 * @see org.osate.aadl2.NamedElement#getQualifiedName()
	 * @see #getNamedElement()
	 * @generated
	 */
	EAttribute getNamedElement_QualifiedName();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.NamedElement#getOwnedPropertyAssociations <em>Owned Property Association</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Property Association</em>'.
	 * @see org.osate.aadl2.NamedElement#getOwnedPropertyAssociations()
	 * @see #getNamedElement()
	 * @generated
	 */
	EReference getNamedElement_OwnedPropertyAssociation();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PropertyAssociation <em>Property Association</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Association</em>'.
	 * @see org.osate.aadl2.PropertyAssociation
	 * @generated
	 */
	EClass getPropertyAssociation();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PropertyAssociation#getProperty <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Property</em>'.
	 * @see org.osate.aadl2.PropertyAssociation#getProperty()
	 * @see #getPropertyAssociation()
	 * @generated
	 */
	EReference getPropertyAssociation_Property();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PropertyAssociation#getAppliesTos <em>Applies To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Applies To</em>'.
	 * @see org.osate.aadl2.PropertyAssociation#getAppliesTos()
	 * @see #getPropertyAssociation()
	 * @generated
	 */
	EReference getPropertyAssociation_AppliesTo();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.PropertyAssociation#getInBindings <em>In Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>In Binding</em>'.
	 * @see org.osate.aadl2.PropertyAssociation#getInBindings()
	 * @see #getPropertyAssociation()
	 * @generated
	 */
	EReference getPropertyAssociation_InBinding();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PropertyAssociation#isAppend <em>Append</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Append</em>'.
	 * @see org.osate.aadl2.PropertyAssociation#isAppend()
	 * @see #getPropertyAssociation()
	 * @generated
	 */
	EAttribute getPropertyAssociation_Append();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PropertyAssociation#isConstant <em>Constant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Constant</em>'.
	 * @see org.osate.aadl2.PropertyAssociation#isConstant()
	 * @see #getPropertyAssociation()
	 * @generated
	 */
	EAttribute getPropertyAssociation_Constant();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PropertyAssociation#getOwnedValues <em>Owned Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Value</em>'.
	 * @see org.osate.aadl2.PropertyAssociation#getOwnedValues()
	 * @see #getPropertyAssociation()
	 * @generated
	 */
	EReference getPropertyAssociation_OwnedValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Property <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property</em>'.
	 * @see org.osate.aadl2.Property
	 * @generated
	 */
	EClass getProperty();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Property#isInherit <em>Inherit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Inherit</em>'.
	 * @see org.osate.aadl2.Property#isInherit()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Inherit();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.Property#getDefaultValue <em>Default Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Default Value</em>'.
	 * @see org.osate.aadl2.Property#getDefaultValue()
	 * @see #getProperty()
	 * @generated
	 */
	EReference getProperty_DefaultValue();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Property#getAppliesToMetaclasses <em>Applies To Metaclass</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Applies To Metaclass</em>'.
	 * @see org.osate.aadl2.Property#getAppliesToMetaclasses()
	 * @see #getProperty()
	 * @generated
	 */
	EReference getProperty_AppliesToMetaclass();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Property#getAppliesToClassifiers <em>Applies To Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Applies To Classifier</em>'.
	 * @see org.osate.aadl2.Property#getAppliesToClassifiers()
	 * @see #getProperty()
	 * @generated
	 */
	EReference getProperty_AppliesToClassifier();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Property#getAppliesTos <em>Applies To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Applies To</em>'.
	 * @see org.osate.aadl2.Property#getAppliesTos()
	 * @see #getProperty()
	 * @generated
	 */
	EReference getProperty_AppliesTo();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Property#isEmptyListDefault <em>Empty List Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Empty List Default</em>'.
	 * @see org.osate.aadl2.Property#isEmptyListDefault()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_EmptyListDefault();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BasicProperty <em>Basic Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Basic Property</em>'.
	 * @see org.osate.aadl2.BasicProperty
	 * @generated
	 */
	EClass getBasicProperty();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.BasicProperty#getPropertyType <em>Property Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Property Type</em>'.
	 * @see org.osate.aadl2.BasicProperty#getPropertyType()
	 * @see #getBasicProperty()
	 * @generated
	 */
	EReference getBasicProperty_PropertyType();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.BasicProperty#getOwnedPropertyType <em>Owned Property Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Property Type</em>'.
	 * @see org.osate.aadl2.BasicProperty#getOwnedPropertyType()
	 * @see #getBasicProperty()
	 * @generated
	 */
	EReference getBasicProperty_OwnedPropertyType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.TypedElement <em>Typed Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Typed Element</em>'.
	 * @see org.osate.aadl2.TypedElement
	 * @generated
	 */
	EClass getTypedElement();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.TypedElement#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see org.osate.aadl2.TypedElement#getType()
	 * @see #getTypedElement()
	 * @generated
	 */
	EReference getTypedElement_Type();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PropertyType <em>Property Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Type</em>'.
	 * @see org.osate.aadl2.PropertyType
	 * @generated
	 */
	EClass getPropertyType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PropertyExpression <em>Property Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Expression</em>'.
	 * @see org.osate.aadl2.PropertyExpression
	 * @generated
	 */
	EClass getPropertyExpression();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.MetaclassReference <em>Metaclass Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Metaclass Reference</em>'.
	 * @see org.osate.aadl2.MetaclassReference
	 * @generated
	 */
	EClass getMetaclassReference();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.MetaclassReference#getAnnexName <em>Annex Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Annex Name</em>'.
	 * @see org.osate.aadl2.MetaclassReference#getAnnexName()
	 * @see #getMetaclassReference()
	 * @generated
	 */
	EAttribute getMetaclassReference_AnnexName();

	/**
	 * Returns the meta object for the attribute list '{@link org.osate.aadl2.MetaclassReference#getMetaclassNames <em>Metaclass Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Metaclass Name</em>'.
	 * @see org.osate.aadl2.MetaclassReference#getMetaclassNames()
	 * @see #getMetaclassReference()
	 * @generated
	 */
	EAttribute getMetaclassReference_MetaclassName();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PropertyOwner <em>Property Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Owner</em>'.
	 * @see org.osate.aadl2.PropertyOwner
	 * @generated
	 */
	EClass getPropertyOwner();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Classifier <em>Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Classifier</em>'.
	 * @see org.osate.aadl2.Classifier
	 * @generated
	 */
	EClass getClassifier();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Classifier#getClassifierFeatures <em>Classifier Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Classifier Feature</em>'.
	 * @see org.osate.aadl2.Classifier#getClassifierFeatures()
	 * @see #getClassifier()
	 * @generated
	 */
	EReference getClassifier_ClassifierFeature();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Classifier#getInheritedMembers <em>Inherited Member</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Inherited Member</em>'.
	 * @see org.osate.aadl2.Classifier#getInheritedMembers()
	 * @see #getClassifier()
	 * @generated
	 */
	EReference getClassifier_InheritedMember();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Classifier#getGeneralizations <em>Generalization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Generalization</em>'.
	 * @see org.osate.aadl2.Classifier#getGeneralizations()
	 * @see #getClassifier()
	 * @generated
	 */
	EReference getClassifier_Generalization();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Classifier#getGenerals <em>General</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>General</em>'.
	 * @see org.osate.aadl2.Classifier#getGenerals()
	 * @see #getClassifier()
	 * @generated
	 */
	EReference getClassifier_General();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Classifier#getOwnedAnnexSubclauses <em>Owned Annex Subclause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Annex Subclause</em>'.
	 * @see org.osate.aadl2.Classifier#getOwnedAnnexSubclauses()
	 * @see #getClassifier()
	 * @generated
	 */
	EReference getClassifier_OwnedAnnexSubclause();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Classifier#getOwnedPrototypes <em>Owned Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Prototype</em>'.
	 * @see org.osate.aadl2.Classifier#getOwnedPrototypes()
	 * @see #getClassifier()
	 * @generated
	 */
	EReference getClassifier_OwnedPrototype();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Classifier#getOwnedPrototypeBindings <em>Owned Prototype Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Prototype Binding</em>'.
	 * @see org.osate.aadl2.Classifier#getOwnedPrototypeBindings()
	 * @see #getClassifier()
	 * @generated
	 */
	EReference getClassifier_OwnedPrototypeBinding();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Classifier#isNoPrototypes <em>No Prototypes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Prototypes</em>'.
	 * @see org.osate.aadl2.Classifier#isNoPrototypes()
	 * @see #getClassifier()
	 * @generated
	 */
	EAttribute getClassifier_NoPrototypes();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Classifier#isNoAnnexes <em>No Annexes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Annexes</em>'.
	 * @see org.osate.aadl2.Classifier#isNoAnnexes()
	 * @see #getClassifier()
	 * @generated
	 */
	EAttribute getClassifier_NoAnnexes();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Classifier#isNoProperties <em>No Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Properties</em>'.
	 * @see org.osate.aadl2.Classifier#isNoProperties()
	 * @see #getClassifier()
	 * @generated
	 */
	EAttribute getClassifier_NoProperties();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Namespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Namespace</em>'.
	 * @see org.osate.aadl2.Namespace
	 * @generated
	 */
	EClass getNamespace();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Namespace#getOwnedMembers <em>Owned Member</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Member</em>'.
	 * @see org.osate.aadl2.Namespace#getOwnedMembers()
	 * @see #getNamespace()
	 * @generated
	 */
	EReference getNamespace_OwnedMember();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Namespace#getMembers <em>Member</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Member</em>'.
	 * @see org.osate.aadl2.Namespace#getMembers()
	 * @see #getNamespace()
	 * @generated
	 */
	EReference getNamespace_Member();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ClassifierFeature <em>Classifier Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Classifier Feature</em>'.
	 * @see org.osate.aadl2.ClassifierFeature
	 * @generated
	 */
	EClass getClassifierFeature();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ClassifierFeature#getFeaturingClassifiers <em>Featuring Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Featuring Classifier</em>'.
	 * @see org.osate.aadl2.ClassifierFeature#getFeaturingClassifiers()
	 * @see #getClassifierFeature()
	 * @generated
	 */
	EReference getClassifierFeature_FeaturingClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Generalization <em>Generalization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generalization</em>'.
	 * @see org.osate.aadl2.Generalization
	 * @generated
	 */
	EClass getGeneralization();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Generalization#getGeneral <em>General</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>General</em>'.
	 * @see org.osate.aadl2.Generalization#getGeneral()
	 * @see #getGeneralization()
	 * @generated
	 */
	EReference getGeneralization_General();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Generalization#getSpecific <em>Specific</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Specific</em>'.
	 * @see org.osate.aadl2.Generalization#getSpecific()
	 * @see #getGeneralization()
	 * @generated
	 */
	EReference getGeneralization_Specific();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DirectedRelationship <em>Directed Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Directed Relationship</em>'.
	 * @see org.osate.aadl2.DirectedRelationship
	 * @generated
	 */
	EClass getDirectedRelationship();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.DirectedRelationship#getSources <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Source</em>'.
	 * @see org.osate.aadl2.DirectedRelationship#getSources()
	 * @see #getDirectedRelationship()
	 * @generated
	 */
	EReference getDirectedRelationship_Source();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.DirectedRelationship#getTargets <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Target</em>'.
	 * @see org.osate.aadl2.DirectedRelationship#getTargets()
	 * @see #getDirectedRelationship()
	 * @generated
	 */
	EReference getDirectedRelationship_Target();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Relationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship</em>'.
	 * @see org.osate.aadl2.Relationship
	 * @generated
	 */
	EClass getRelationship();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.Relationship#getRelatedElements <em>Related Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Related Element</em>'.
	 * @see org.osate.aadl2.Relationship#getRelatedElements()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_RelatedElement();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AnnexSubclause <em>Annex Subclause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Annex Subclause</em>'.
	 * @see org.osate.aadl2.AnnexSubclause
	 * @generated
	 */
	EClass getAnnexSubclause();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModalElement <em>Modal Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Modal Element</em>'.
	 * @see org.osate.aadl2.ModalElement
	 * @generated
	 */
	EClass getModalElement();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ModalElement#getInModes <em>In Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>In Mode</em>'.
	 * @see org.osate.aadl2.ModalElement#getInModes()
	 * @see #getModalElement()
	 * @generated
	 */
	EReference getModalElement_InMode();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Mode <em>Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode</em>'.
	 * @see org.osate.aadl2.Mode
	 * @generated
	 */
	EClass getMode();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Mode#isInitial <em>Initial</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial</em>'.
	 * @see org.osate.aadl2.Mode#isInitial()
	 * @see #getMode()
	 * @generated
	 */
	EAttribute getMode_Initial();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Mode#isDerived <em>Derived</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Derived</em>'.
	 * @see org.osate.aadl2.Mode#isDerived()
	 * @see #getMode()
	 * @generated
	 */
	EAttribute getMode_Derived();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModeFeature <em>Mode Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Feature</em>'.
	 * @see org.osate.aadl2.ModeFeature
	 * @generated
	 */
	EClass getModeFeature();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Prototype <em>Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Prototype</em>'.
	 * @see org.osate.aadl2.Prototype
	 * @generated
	 */
	EClass getPrototype();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Prototype#getRefined <em>Refined</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refined</em>'.
	 * @see org.osate.aadl2.Prototype#getRefined()
	 * @see #getPrototype()
	 * @generated
	 */
	EReference getPrototype_Refined();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.StructuralFeature <em>Structural Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Structural Feature</em>'.
	 * @see org.osate.aadl2.StructuralFeature
	 * @generated
	 */
	EClass getStructuralFeature();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.RefinableElement <em>Refinable Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Refinable Element</em>'.
	 * @see org.osate.aadl2.RefinableElement
	 * @generated
	 */
	EClass getRefinableElement();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.RefinableElement#getRefinementContext <em>Refinement Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refinement Context</em>'.
	 * @see org.osate.aadl2.RefinableElement#getRefinementContext()
	 * @see #getRefinableElement()
	 * @generated
	 */
	EReference getRefinableElement_RefinementContext();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.RefinableElement#getRefinedElement <em>Refined Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refined Element</em>'.
	 * @see org.osate.aadl2.RefinableElement#getRefinedElement()
	 * @see #getRefinableElement()
	 * @generated
	 */
	EReference getRefinableElement_RefinedElement();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureClassifier <em>Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Classifier</em>'.
	 * @see org.osate.aadl2.FeatureClassifier
	 * @generated
	 */
	EClass getFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PrototypeBinding <em>Prototype Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Prototype Binding</em>'.
	 * @see org.osate.aadl2.PrototypeBinding
	 * @generated
	 */
	EClass getPrototypeBinding();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PrototypeBinding#getFormal <em>Formal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Formal</em>'.
	 * @see org.osate.aadl2.PrototypeBinding#getFormal()
	 * @see #getPrototypeBinding()
	 * @generated
	 */
	EReference getPrototypeBinding_Formal();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ContainedNamedElement <em>Contained Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Contained Named Element</em>'.
	 * @see org.osate.aadl2.ContainedNamedElement
	 * @generated
	 */
	EClass getContainedNamedElement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ContainedNamedElement#getContainmentPathElements <em>Containment Path Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Containment Path Element</em>'.
	 * @see org.osate.aadl2.ContainedNamedElement#getContainmentPathElements()
	 * @see #getContainedNamedElement()
	 * @generated
	 */
	EReference getContainedNamedElement_ContainmentPathElement();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ContainmentPathElement <em>Containment Path Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Containment Path Element</em>'.
	 * @see org.osate.aadl2.ContainmentPathElement
	 * @generated
	 */
	EClass getContainmentPathElement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ContainmentPathElement#getArrayRanges <em>Array Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Array Range</em>'.
	 * @see org.osate.aadl2.ContainmentPathElement#getArrayRanges()
	 * @see #getContainmentPathElement()
	 * @generated
	 */
	EReference getContainmentPathElement_ArrayRange();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ContainmentPathElement#getNamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Named Element</em>'.
	 * @see org.osate.aadl2.ContainmentPathElement#getNamedElement()
	 * @see #getContainmentPathElement()
	 * @generated
	 */
	EReference getContainmentPathElement_NamedElement();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ContainmentPathElement#getAnnexName <em>Annex Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Annex Name</em>'.
	 * @see org.osate.aadl2.ContainmentPathElement#getAnnexName()
	 * @see #getContainmentPathElement()
	 * @generated
	 */
	EAttribute getContainmentPathElement_AnnexName();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ArrayRange <em>Array Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Range</em>'.
	 * @see org.osate.aadl2.ArrayRange
	 * @generated
	 */
	EClass getArrayRange();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ArrayRange#getLowerBound <em>Lower Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lower Bound</em>'.
	 * @see org.osate.aadl2.ArrayRange#getLowerBound()
	 * @see #getArrayRange()
	 * @generated
	 */
	EAttribute getArrayRange_LowerBound();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ArrayRange#getUpperBound <em>Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Upper Bound</em>'.
	 * @see org.osate.aadl2.ArrayRange#getUpperBound()
	 * @see #getArrayRange()
	 * @generated
	 */
	EAttribute getArrayRange_UpperBound();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModalPropertyValue <em>Modal Property Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Modal Property Value</em>'.
	 * @see org.osate.aadl2.ModalPropertyValue
	 * @generated
	 */
	EClass getModalPropertyValue();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.ModalPropertyValue#getOwnedValue <em>Owned Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Value</em>'.
	 * @see org.osate.aadl2.ModalPropertyValue#getOwnedValue()
	 * @see #getModalPropertyValue()
	 * @generated
	 */
	EReference getModalPropertyValue_OwnedValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BehavioralFeature <em>Behavioral Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Behavioral Feature</em>'.
	 * @see org.osate.aadl2.BehavioralFeature
	 * @generated
	 */
	EClass getBehavioralFeature();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ArrayDimension <em>Array Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Dimension</em>'.
	 * @see org.osate.aadl2.ArrayDimension
	 * @generated
	 */
	EClass getArrayDimension();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.ArrayDimension#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Size</em>'.
	 * @see org.osate.aadl2.ArrayDimension#getSize()
	 * @see #getArrayDimension()
	 * @generated
	 */
	EReference getArrayDimension_Size();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ArraySize <em>Array Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Size</em>'.
	 * @see org.osate.aadl2.ArraySize
	 * @generated
	 */
	EClass getArraySize();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ArraySize#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see org.osate.aadl2.ArraySize#getSize()
	 * @see #getArraySize()
	 * @generated
	 */
	EAttribute getArraySize_Size();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ArraySize#getSizeProperty <em>Size Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Size Property</em>'.
	 * @see org.osate.aadl2.ArraySize#getSizeProperty()
	 * @see #getArraySize()
	 * @generated
	 */
	EReference getArraySize_SizeProperty();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ArrayableElement <em>Arrayable Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Arrayable Element</em>'.
	 * @see org.osate.aadl2.ArrayableElement
	 * @generated
	 */
	EClass getArrayableElement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ArrayableElement#getArrayDimensions <em>Array Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Array Dimension</em>'.
	 * @see org.osate.aadl2.ArrayableElement#getArrayDimensions()
	 * @see #getArrayableElement()
	 * @generated
	 */
	EReference getArrayableElement_ArrayDimension();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentImplementationReference <em>Component Implementation Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Implementation Reference</em>'.
	 * @see org.osate.aadl2.ComponentImplementationReference
	 * @generated
	 */
	EClass getComponentImplementationReference();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ComponentImplementationReference#getImplementation <em>Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Implementation</em>'.
	 * @see org.osate.aadl2.ComponentImplementationReference#getImplementation()
	 * @see #getComponentImplementationReference()
	 * @generated
	 */
	EReference getComponentImplementationReference_Implementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementationReference#getOwnedPrototypeBindings <em>Owned Prototype Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Prototype Binding</em>'.
	 * @see org.osate.aadl2.ComponentImplementationReference#getOwnedPrototypeBindings()
	 * @see #getComponentImplementationReference()
	 * @generated
	 */
	EReference getComponentImplementationReference_OwnedPrototypeBinding();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentImplementation <em>Component Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Implementation</em>'.
	 * @see org.osate.aadl2.ComponentImplementation
	 * @generated
	 */
	EClass getComponentImplementation();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ComponentImplementation#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getType()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_Type();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedSubcomponents <em>Owned Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Subcomponent</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedSubcomponents()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ComponentImplementation#getExtended <em>Extended</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Extended</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getExtended()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_Extended();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedFlowImplementations <em>Owned Flow Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Flow Implementation</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedFlowImplementations()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedFlowImplementation();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedConnections <em>Owned Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Connection</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedConnections()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedConnection();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.ComponentImplementation#getOwnedExtension <em>Owned Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Extension</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedExtension()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedExtension();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.ComponentImplementation#getOwnedRealization <em>Owned Realization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Realization</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedRealization()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedRealization();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedEndToEndFlows <em>Owned End To End Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned End To End Flow</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedEndToEndFlows()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedEndToEndFlow();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedAbstractSubcomponents <em>Owned Abstract Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Abstract Subcomponent</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedAbstractSubcomponents()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedAbstractSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedAccessConnections <em>Owned Access Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Access Connection</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedAccessConnections()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedAccessConnection();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedParameterConnections <em>Owned Parameter Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Parameter Connection</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedParameterConnections()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedParameterConnection();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedPortConnections <em>Owned Port Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Port Connection</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedPortConnections()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedPortConnection();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedFeatureConnections <em>Owned Feature Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Feature Connection</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedFeatureConnections()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedFeatureConnection();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedFeatureGroupConnections <em>Owned Feature Group Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Feature Group Connection</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedFeatureGroupConnections()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedFeatureGroupConnection();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentImplementation#isNoSubcomponents <em>No Subcomponents</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Subcomponents</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#isNoSubcomponents()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EAttribute getComponentImplementation_NoSubcomponents();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentImplementation#isNoConnections <em>No Connections</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Connections</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#isNoConnections()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EAttribute getComponentImplementation_NoConnections();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentImplementation#isNoCalls <em>No Calls</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Calls</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#isNoCalls()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EAttribute getComponentImplementation_NoCalls();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedProcessorFeatures <em>Owned Processor Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Processor Feature</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedProcessorFeatures()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedProcessorFeature();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedInternalFeatures <em>Owned Internal Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Internal Feature</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedInternalFeatures()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedInternalFeature();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedEventSources <em>Owned Event Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Source</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedEventSources()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedEventSource();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedEventDataSources <em>Owned Event Data Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Source</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedEventDataSources()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedEventDataSource();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedPortProxies <em>Owned Port Proxy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Port Proxy</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedPortProxies()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedPortProxy();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentImplementation#getOwnedSubprogramProxies <em>Owned Subprogram Proxy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Proxy</em>'.
	 * @see org.osate.aadl2.ComponentImplementation#getOwnedSubprogramProxies()
	 * @see #getComponentImplementation()
	 * @generated
	 */
	EReference getComponentImplementation_OwnedSubprogramProxy();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentClassifier <em>Component Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Classifier</em>'.
	 * @see org.osate.aadl2.ComponentClassifier
	 * @generated
	 */
	EClass getComponentClassifier();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentClassifier#getOwnedModes <em>Owned Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Mode</em>'.
	 * @see org.osate.aadl2.ComponentClassifier#getOwnedModes()
	 * @see #getComponentClassifier()
	 * @generated
	 */
	EReference getComponentClassifier_OwnedMode();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentClassifier#getOwnedModeTransitions <em>Owned Mode Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Mode Transition</em>'.
	 * @see org.osate.aadl2.ComponentClassifier#getOwnedModeTransitions()
	 * @see #getComponentClassifier()
	 * @generated
	 */
	EReference getComponentClassifier_OwnedModeTransition();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentClassifier#isDerivedModes <em>Derived Modes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Derived Modes</em>'.
	 * @see org.osate.aadl2.ComponentClassifier#isDerivedModes()
	 * @see #getComponentClassifier()
	 * @generated
	 */
	EAttribute getComponentClassifier_DerivedModes();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentClassifier#isNoFlows <em>No Flows</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Flows</em>'.
	 * @see org.osate.aadl2.ComponentClassifier#isNoFlows()
	 * @see #getComponentClassifier()
	 * @generated
	 */
	EAttribute getComponentClassifier_NoFlows();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentClassifier#isNoModes <em>No Modes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Modes</em>'.
	 * @see org.osate.aadl2.ComponentClassifier#isNoModes()
	 * @see #getComponentClassifier()
	 * @generated
	 */
	EAttribute getComponentClassifier_NoModes();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubcomponentType <em>Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subcomponent Type</em>'.
	 * @see org.osate.aadl2.SubcomponentType
	 * @generated
	 */
	EClass getSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModeTransition <em>Mode Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Transition</em>'.
	 * @see org.osate.aadl2.ModeTransition
	 * @generated
	 */
	EClass getModeTransition();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ModeTransition#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see org.osate.aadl2.ModeTransition#getSource()
	 * @see #getModeTransition()
	 * @generated
	 */
	EReference getModeTransition_Source();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ModeTransition#getDestination <em>Destination</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Destination</em>'.
	 * @see org.osate.aadl2.ModeTransition#getDestination()
	 * @see #getModeTransition()
	 * @generated
	 */
	EReference getModeTransition_Destination();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ModeTransition#getOwnedTriggers <em>Owned Trigger</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Trigger</em>'.
	 * @see org.osate.aadl2.ModeTransition#getOwnedTriggers()
	 * @see #getModeTransition()
	 * @generated
	 */
	EReference getModeTransition_OwnedTrigger();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModeTransitionTrigger <em>Mode Transition Trigger</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Transition Trigger</em>'.
	 * @see org.osate.aadl2.ModeTransitionTrigger
	 * @generated
	 */
	EClass getModeTransitionTrigger();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ModeTransitionTrigger#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Context</em>'.
	 * @see org.osate.aadl2.ModeTransitionTrigger#getContext()
	 * @see #getModeTransitionTrigger()
	 * @generated
	 */
	EReference getModeTransitionTrigger_Context();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ModeTransitionTrigger#getTriggerPort <em>Trigger Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Trigger Port</em>'.
	 * @see org.osate.aadl2.ModeTransitionTrigger#getTriggerPort()
	 * @see #getModeTransitionTrigger()
	 * @generated
	 */
	EReference getModeTransitionTrigger_TriggerPort();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.TriggerPort <em>Trigger Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trigger Port</em>'.
	 * @see org.osate.aadl2.TriggerPort
	 * @generated
	 */
	EClass getTriggerPort();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Context <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Context</em>'.
	 * @see org.osate.aadl2.Context
	 * @generated
	 */
	EClass getContext();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Port <em>Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port</em>'.
	 * @see org.osate.aadl2.Port
	 * @generated
	 */
	EClass getPort();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Port#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see org.osate.aadl2.Port#getCategory()
	 * @see #getPort()
	 * @generated
	 */
	EAttribute getPort_Category();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DirectedFeature <em>Directed Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Directed Feature</em>'.
	 * @see org.osate.aadl2.DirectedFeature
	 * @generated
	 */
	EClass getDirectedFeature();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.DirectedFeature#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see org.osate.aadl2.DirectedFeature#getDirection()
	 * @see #getDirectedFeature()
	 * @generated
	 */
	EAttribute getDirectedFeature_Direction();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Feature <em>Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature</em>'.
	 * @see org.osate.aadl2.Feature
	 * @generated
	 */
	EClass getFeature();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Feature#getPrototype <em>Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Prototype</em>'.
	 * @see org.osate.aadl2.Feature#getPrototype()
	 * @see #getFeature()
	 * @generated
	 */
	EReference getFeature_Prototype();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Feature#getFeatureClassifier <em>Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature Classifier</em>'.
	 * @see org.osate.aadl2.Feature#getFeatureClassifier()
	 * @see #getFeature()
	 * @generated
	 */
	EReference getFeature_FeatureClassifier();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Feature#getClassifier <em>Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Classifier</em>'.
	 * @see org.osate.aadl2.Feature#getClassifier()
	 * @see #getFeature()
	 * @generated
	 */
	EReference getFeature_Classifier();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Feature#getRefined <em>Refined</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refined</em>'.
	 * @see org.osate.aadl2.Feature#getRefined()
	 * @see #getFeature()
	 * @generated
	 */
	EReference getFeature_Refined();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureConnectionEnd <em>Feature Connection End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Connection End</em>'.
	 * @see org.osate.aadl2.FeatureConnectionEnd
	 * @generated
	 */
	EClass getFeatureConnectionEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ConnectionEnd <em>Connection End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connection End</em>'.
	 * @see org.osate.aadl2.ConnectionEnd
	 * @generated
	 */
	EClass getConnectionEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PortConnectionEnd <em>Port Connection End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Connection End</em>'.
	 * @see org.osate.aadl2.PortConnectionEnd
	 * @generated
	 */
	EClass getPortConnectionEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentType <em>Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Type</em>'.
	 * @see org.osate.aadl2.ComponentType
	 * @generated
	 */
	EClass getComponentType();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ComponentType#getOwnedFeatures <em>Owned Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Feature</em>'.
	 * @see org.osate.aadl2.ComponentType#getOwnedFeatures()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_OwnedFeature();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ComponentType#getExtended <em>Extended</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Extended</em>'.
	 * @see org.osate.aadl2.ComponentType#getExtended()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_Extended();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentType#getOwnedFlowSpecifications <em>Owned Flow Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Flow Specification</em>'.
	 * @see org.osate.aadl2.ComponentType#getOwnedFlowSpecifications()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_OwnedFlowSpecification();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.ComponentType#getOwnedExtension <em>Owned Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Extension</em>'.
	 * @see org.osate.aadl2.ComponentType#getOwnedExtension()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_OwnedExtension();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentType#getOwnedFeatureGroups <em>Owned Feature Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Feature Group</em>'.
	 * @see org.osate.aadl2.ComponentType#getOwnedFeatureGroups()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_OwnedFeatureGroup();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentType#getOwnedAbstractFeatures <em>Owned Abstract Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Abstract Feature</em>'.
	 * @see org.osate.aadl2.ComponentType#getOwnedAbstractFeatures()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_OwnedAbstractFeature();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentType#isNoFeatures <em>No Features</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Features</em>'.
	 * @see org.osate.aadl2.ComponentType#isNoFeatures()
	 * @see #getComponentType()
	 * @generated
	 */
	EAttribute getComponentType_NoFeatures();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FlowSpecification <em>Flow Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Specification</em>'.
	 * @see org.osate.aadl2.FlowSpecification
	 * @generated
	 */
	EClass getFlowSpecification();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FlowSpecification#getRefined <em>Refined</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refined</em>'.
	 * @see org.osate.aadl2.FlowSpecification#getRefined()
	 * @see #getFlowSpecification()
	 * @generated
	 */
	EReference getFlowSpecification_Refined();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.FlowSpecification#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see org.osate.aadl2.FlowSpecification#getKind()
	 * @see #getFlowSpecification()
	 * @generated
	 */
	EAttribute getFlowSpecification_Kind();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.FlowSpecification#getOutEnd <em>Out End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Out End</em>'.
	 * @see org.osate.aadl2.FlowSpecification#getOutEnd()
	 * @see #getFlowSpecification()
	 * @generated
	 */
	EReference getFlowSpecification_OutEnd();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.FlowSpecification#getInEnd <em>In End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>In End</em>'.
	 * @see org.osate.aadl2.FlowSpecification#getInEnd()
	 * @see #getFlowSpecification()
	 * @generated
	 */
	EReference getFlowSpecification_InEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FlowFeature <em>Flow Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Feature</em>'.
	 * @see org.osate.aadl2.FlowFeature
	 * @generated
	 */
	EClass getFlowFeature();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Flow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow</em>'.
	 * @see org.osate.aadl2.Flow
	 * @generated
	 */
	EClass getFlow();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.TypeExtension <em>Type Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Extension</em>'.
	 * @see org.osate.aadl2.TypeExtension
	 * @generated
	 */
	EClass getTypeExtension();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.TypeExtension#getExtended <em>Extended</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Extended</em>'.
	 * @see org.osate.aadl2.TypeExtension#getExtended()
	 * @see #getTypeExtension()
	 * @generated
	 */
	EReference getTypeExtension_Extended();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroup <em>Feature Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group</em>'.
	 * @see org.osate.aadl2.FeatureGroup
	 * @generated
	 */
	EClass getFeatureGroup();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.FeatureGroup#isInverse <em>Inverse</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Inverse</em>'.
	 * @see org.osate.aadl2.FeatureGroup#isInverse()
	 * @see #getFeatureGroup()
	 * @generated
	 */
	EAttribute getFeatureGroup_Inverse();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroup#getFeatureType <em>Feature Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature Type</em>'.
	 * @see org.osate.aadl2.FeatureGroup#getFeatureType()
	 * @see #getFeatureGroup()
	 * @generated
	 */
	EReference getFeatureGroup_FeatureType();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroup#getFeatureGroupType <em>Feature Group Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature Group Type</em>'.
	 * @see org.osate.aadl2.FeatureGroup#getFeatureGroupType()
	 * @see #getFeatureGroup()
	 * @generated
	 */
	EReference getFeatureGroup_FeatureGroupType();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroup#getFeatureGroupPrototype <em>Feature Group Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature Group Prototype</em>'.
	 * @see org.osate.aadl2.FeatureGroup#getFeatureGroupPrototype()
	 * @see #getFeatureGroup()
	 * @generated
	 */
	EReference getFeatureGroup_FeatureGroupPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroupConnectionEnd <em>Feature Group Connection End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group Connection End</em>'.
	 * @see org.osate.aadl2.FeatureGroupConnectionEnd
	 * @generated
	 */
	EClass getFeatureGroupConnectionEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureType <em>Feature Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Type</em>'.
	 * @see org.osate.aadl2.FeatureType
	 * @generated
	 */
	EClass getFeatureType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.CallContext <em>Call Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Context</em>'.
	 * @see org.osate.aadl2.CallContext
	 * @generated
	 */
	EClass getCallContext();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroupType <em>Feature Group Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group Type</em>'.
	 * @see org.osate.aadl2.FeatureGroupType
	 * @generated
	 */
	EClass getFeatureGroupType();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedFeatures <em>Owned Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Owned Feature</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedFeatures()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedFeature();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroupType#getExtended <em>Extended</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Extended</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getExtended()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_Extended();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroupType#getInverse <em>Inverse</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Inverse</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getInverse()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_Inverse();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.FeatureGroupType#getOwnedExtension <em>Owned Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Extension</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedExtension()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedExtension();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedBusAccesses <em>Owned Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Access</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedBusAccesses()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedBusAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedDataAccesses()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedDataPorts()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedEventDataPorts()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedEventPorts()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedFeatureGroups <em>Owned Feature Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Feature Group</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedFeatureGroups()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedFeatureGroup();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedParameters <em>Owned Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Parameter</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedParameters()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedParameter();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedSubprogramAccesses()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedSubprogramGroupAccesses()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupType#getOwnedAbstractFeatures <em>Owned Abstract Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Abstract Feature</em>'.
	 * @see org.osate.aadl2.FeatureGroupType#getOwnedAbstractFeatures()
	 * @see #getFeatureGroupType()
	 * @generated
	 */
	EReference getFeatureGroupType_OwnedAbstractFeature();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.GroupExtension <em>Group Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Group Extension</em>'.
	 * @see org.osate.aadl2.GroupExtension
	 * @generated
	 */
	EClass getGroupExtension();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.GroupExtension#getExtended <em>Extended</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Extended</em>'.
	 * @see org.osate.aadl2.GroupExtension#getExtended()
	 * @see #getGroupExtension()
	 * @generated
	 */
	EReference getGroupExtension_Extended();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BusAccess <em>Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Access</em>'.
	 * @see org.osate.aadl2.BusAccess
	 * @generated
	 */
	EClass getBusAccess();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.BusAccess#getBusFeatureClassifier <em>Bus Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Bus Feature Classifier</em>'.
	 * @see org.osate.aadl2.BusAccess#getBusFeatureClassifier()
	 * @see #getBusAccess()
	 * @generated
	 */
	EReference getBusAccess_BusFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Access <em>Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access</em>'.
	 * @see org.osate.aadl2.Access
	 * @generated
	 */
	EClass getAccess();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Access#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see org.osate.aadl2.Access#getKind()
	 * @see #getAccess()
	 * @generated
	 */
	EAttribute getAccess_Kind();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Access#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see org.osate.aadl2.Access#getCategory()
	 * @see #getAccess()
	 * @generated
	 */
	EAttribute getAccess_Category();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AccessConnectionEnd <em>Access Connection End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access Connection End</em>'.
	 * @see org.osate.aadl2.AccessConnectionEnd
	 * @generated
	 */
	EClass getAccessConnectionEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BusClassifier <em>Bus Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Classifier</em>'.
	 * @see org.osate.aadl2.BusClassifier
	 * @generated
	 */
	EClass getBusClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BusSubcomponentType <em>Bus Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Subcomponent Type</em>'.
	 * @see org.osate.aadl2.BusSubcomponentType
	 * @generated
	 */
	EClass getBusSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Bus <em>Bus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus</em>'.
	 * @see org.osate.aadl2.Bus
	 * @generated
	 */
	EClass getBus();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataAccess <em>Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Access</em>'.
	 * @see org.osate.aadl2.DataAccess
	 * @generated
	 */
	EClass getDataAccess();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.DataAccess#getDataFeatureClassifier <em>Data Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Feature Classifier</em>'.
	 * @see org.osate.aadl2.DataAccess#getDataFeatureClassifier()
	 * @see #getDataAccess()
	 * @generated
	 */
	EReference getDataAccess_DataFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ParameterConnectionEnd <em>Parameter Connection End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Parameter Connection End</em>'.
	 * @see org.osate.aadl2.ParameterConnectionEnd
	 * @generated
	 */
	EClass getParameterConnectionEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FlowElement <em>Flow Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Element</em>'.
	 * @see org.osate.aadl2.FlowElement
	 * @generated
	 */
	EClass getFlowElement();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EndToEndFlowElement <em>End To End Flow Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>End To End Flow Element</em>'.
	 * @see org.osate.aadl2.EndToEndFlowElement
	 * @generated
	 */
	EClass getEndToEndFlowElement();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FlowEnd <em>Flow End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow End</em>'.
	 * @see org.osate.aadl2.FlowEnd
	 * @generated
	 */
	EClass getFlowEnd();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FlowEnd#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Context</em>'.
	 * @see org.osate.aadl2.FlowEnd#getContext()
	 * @see #getFlowEnd()
	 * @generated
	 */
	EReference getFlowEnd_Context();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FlowEnd#getFeature <em>Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature</em>'.
	 * @see org.osate.aadl2.FlowEnd#getFeature()
	 * @see #getFlowEnd()
	 * @generated
	 */
	EReference getFlowEnd_Feature();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataClassifier <em>Data Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Classifier</em>'.
	 * @see org.osate.aadl2.DataClassifier
	 * @generated
	 */
	EClass getDataClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataSubcomponentType <em>Data Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Subcomponent Type</em>'.
	 * @see org.osate.aadl2.DataSubcomponentType
	 * @generated
	 */
	EClass getDataSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Data <em>Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data</em>'.
	 * @see org.osate.aadl2.Data
	 * @generated
	 */
	EClass getData();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataPort <em>Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Port</em>'.
	 * @see org.osate.aadl2.DataPort
	 * @generated
	 */
	EClass getDataPort();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.DataPort#getDataFeatureClassifier <em>Data Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Feature Classifier</em>'.
	 * @see org.osate.aadl2.DataPort#getDataFeatureClassifier()
	 * @see #getDataPort()
	 * @generated
	 */
	EReference getDataPort_DataFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EventDataPort <em>Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Data Port</em>'.
	 * @see org.osate.aadl2.EventDataPort
	 * @generated
	 */
	EClass getEventDataPort();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.EventDataPort#getDataFeatureClassifier <em>Data Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Feature Classifier</em>'.
	 * @see org.osate.aadl2.EventDataPort#getDataFeatureClassifier()
	 * @see #getEventDataPort()
	 * @generated
	 */
	EReference getEventDataPort_DataFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EventPort <em>Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Port</em>'.
	 * @see org.osate.aadl2.EventPort
	 * @generated
	 */
	EClass getEventPort();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Parameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Parameter</em>'.
	 * @see org.osate.aadl2.Parameter
	 * @generated
	 */
	EClass getParameter();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Parameter#getDataFeatureClassifier <em>Data Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Feature Classifier</em>'.
	 * @see org.osate.aadl2.Parameter#getDataFeatureClassifier()
	 * @see #getParameter()
	 * @generated
	 */
	EReference getParameter_DataFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramAccess <em>Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Access</em>'.
	 * @see org.osate.aadl2.SubprogramAccess
	 * @generated
	 */
	EClass getSubprogramAccess();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SubprogramAccess#getSubprogramFeatureClassifier <em>Subprogram Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Subprogram Feature Classifier</em>'.
	 * @see org.osate.aadl2.SubprogramAccess#getSubprogramFeatureClassifier()
	 * @see #getSubprogramAccess()
	 * @generated
	 */
	EReference getSubprogramAccess_SubprogramFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.CalledSubprogram <em>Called Subprogram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Called Subprogram</em>'.
	 * @see org.osate.aadl2.CalledSubprogram
	 * @generated
	 */
	EClass getCalledSubprogram();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramClassifier <em>Subprogram Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Classifier</em>'.
	 * @see org.osate.aadl2.SubprogramClassifier
	 * @generated
	 */
	EClass getSubprogramClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramSubcomponentType <em>Subprogram Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Subcomponent Type</em>'.
	 * @see org.osate.aadl2.SubprogramSubcomponentType
	 * @generated
	 */
	EClass getSubprogramSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Subprogram <em>Subprogram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram</em>'.
	 * @see org.osate.aadl2.Subprogram
	 * @generated
	 */
	EClass getSubprogram();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroupAccess <em>Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.SubprogramGroupAccess
	 * @generated
	 */
	EClass getSubprogramGroupAccess();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SubprogramGroupAccess#getSubprogramGroupFeatureClassifier <em>Subprogram Group Feature Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Subprogram Group Feature Classifier</em>'.
	 * @see org.osate.aadl2.SubprogramGroupAccess#getSubprogramGroupFeatureClassifier()
	 * @see #getSubprogramGroupAccess()
	 * @generated
	 */
	EReference getSubprogramGroupAccess_SubprogramGroupFeatureClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroupClassifier <em>Subprogram Group Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group Classifier</em>'.
	 * @see org.osate.aadl2.SubprogramGroupClassifier
	 * @generated
	 */
	EClass getSubprogramGroupClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroupSubcomponentType <em>Subprogram Group Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group Subcomponent Type</em>'.
	 * @see org.osate.aadl2.SubprogramGroupSubcomponentType
	 * @generated
	 */
	EClass getSubprogramGroupSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroup <em>Subprogram Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group</em>'.
	 * @see org.osate.aadl2.SubprogramGroup
	 * @generated
	 */
	EClass getSubprogramGroup();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractFeature <em>Abstract Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Feature</em>'.
	 * @see org.osate.aadl2.AbstractFeature
	 * @generated
	 */
	EClass getAbstractFeature();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.AbstractFeature#getFeaturePrototype <em>Feature Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature Prototype</em>'.
	 * @see org.osate.aadl2.AbstractFeature#getFeaturePrototype()
	 * @see #getAbstractFeature()
	 * @generated
	 */
	EReference getAbstractFeature_FeaturePrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Subcomponent <em>Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subcomponent</em>'.
	 * @see org.osate.aadl2.Subcomponent
	 * @generated
	 */
	EClass getSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Subcomponent#getSubcomponentType <em>Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Subcomponent Type</em>'.
	 * @see org.osate.aadl2.Subcomponent#getSubcomponentType()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EReference getSubcomponent_SubcomponentType();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Subcomponent#getClassifier <em>Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Classifier</em>'.
	 * @see org.osate.aadl2.Subcomponent#getClassifier()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EReference getSubcomponent_Classifier();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Subcomponent#getOwnedPrototypeBindings <em>Owned Prototype Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Prototype Binding</em>'.
	 * @see org.osate.aadl2.Subcomponent#getOwnedPrototypeBindings()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EReference getSubcomponent_OwnedPrototypeBinding();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Subcomponent#getPrototype <em>Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Prototype</em>'.
	 * @see org.osate.aadl2.Subcomponent#getPrototype()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EReference getSubcomponent_Prototype();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Subcomponent#getOwnedModeBindings <em>Owned Mode Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Mode Binding</em>'.
	 * @see org.osate.aadl2.Subcomponent#getOwnedModeBindings()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EReference getSubcomponent_OwnedModeBinding();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Subcomponent#isAllModes <em>All Modes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>All Modes</em>'.
	 * @see org.osate.aadl2.Subcomponent#isAllModes()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EAttribute getSubcomponent_AllModes();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Subcomponent#getImplementationReferences <em>Implementation Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Implementation Reference</em>'.
	 * @see org.osate.aadl2.Subcomponent#getImplementationReferences()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EReference getSubcomponent_ImplementationReference();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Subcomponent#getRefined <em>Refined</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refined</em>'.
	 * @see org.osate.aadl2.Subcomponent#getRefined()
	 * @see #getSubcomponent()
	 * @generated
	 */
	EReference getSubcomponent_Refined();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentPrototype <em>Component Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Prototype</em>'.
	 * @see org.osate.aadl2.ComponentPrototype
	 * @generated
	 */
	EClass getComponentPrototype();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentPrototype#isArray <em>Array</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Array</em>'.
	 * @see org.osate.aadl2.ComponentPrototype#isArray()
	 * @see #getComponentPrototype()
	 * @generated
	 */
	EAttribute getComponentPrototype_Array();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ComponentPrototype#getConstrainingClassifier <em>Constraining Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Constraining Classifier</em>'.
	 * @see org.osate.aadl2.ComponentPrototype#getConstrainingClassifier()
	 * @see #getComponentPrototype()
	 * @generated
	 */
	EReference getComponentPrototype_ConstrainingClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModeBinding <em>Mode Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Binding</em>'.
	 * @see org.osate.aadl2.ModeBinding
	 * @generated
	 */
	EClass getModeBinding();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ModeBinding#getParentMode <em>Parent Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parent Mode</em>'.
	 * @see org.osate.aadl2.ModeBinding#getParentMode()
	 * @see #getModeBinding()
	 * @generated
	 */
	EReference getModeBinding_ParentMode();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ModeBinding#getDerivedMode <em>Derived Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Derived Mode</em>'.
	 * @see org.osate.aadl2.ModeBinding#getDerivedMode()
	 * @see #getModeBinding()
	 * @generated
	 */
	EReference getModeBinding_DerivedMode();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractSubcomponentType <em>Abstract Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Subcomponent Type</em>'.
	 * @see org.osate.aadl2.AbstractSubcomponentType
	 * @generated
	 */
	EClass getAbstractSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractClassifier <em>Abstract Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Classifier</em>'.
	 * @see org.osate.aadl2.AbstractClassifier
	 * @generated
	 */
	EClass getAbstractClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Abstract <em>Abstract</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract</em>'.
	 * @see org.osate.aadl2.Abstract
	 * @generated
	 */
	EClass getAbstract();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FlowImplementation <em>Flow Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Implementation</em>'.
	 * @see org.osate.aadl2.FlowImplementation
	 * @generated
	 */
	EClass getFlowImplementation();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.FlowImplementation#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see org.osate.aadl2.FlowImplementation#getKind()
	 * @see #getFlowImplementation()
	 * @generated
	 */
	EAttribute getFlowImplementation_Kind();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FlowImplementation#getSpecification <em>Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Specification</em>'.
	 * @see org.osate.aadl2.FlowImplementation#getSpecification()
	 * @see #getFlowImplementation()
	 * @generated
	 */
	EReference getFlowImplementation_Specification();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FlowImplementation#getOwnedFlowSegments <em>Owned Flow Segment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Flow Segment</em>'.
	 * @see org.osate.aadl2.FlowImplementation#getOwnedFlowSegments()
	 * @see #getFlowImplementation()
	 * @generated
	 */
	EReference getFlowImplementation_OwnedFlowSegment();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModalPath <em>Modal Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Modal Path</em>'.
	 * @see org.osate.aadl2.ModalPath
	 * @generated
	 */
	EClass getModalPath();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.ModalPath#getInModeOrTransitions <em>In Mode Or Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>In Mode Or Transition</em>'.
	 * @see org.osate.aadl2.ModalPath#getInModeOrTransitions()
	 * @see #getModalPath()
	 * @generated
	 */
	EReference getModalPath_InModeOrTransition();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FlowSegment <em>Flow Segment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Segment</em>'.
	 * @see org.osate.aadl2.FlowSegment
	 * @generated
	 */
	EClass getFlowSegment();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FlowSegment#getFlowElement <em>Flow Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow Element</em>'.
	 * @see org.osate.aadl2.FlowSegment#getFlowElement()
	 * @see #getFlowSegment()
	 * @generated
	 */
	EReference getFlowSegment_FlowElement();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FlowSegment#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Context</em>'.
	 * @see org.osate.aadl2.FlowSegment#getContext()
	 * @see #getFlowSegment()
	 * @generated
	 */
	EReference getFlowSegment_Context();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Connection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connection</em>'.
	 * @see org.osate.aadl2.Connection
	 * @generated
	 */
	EClass getConnection();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.Connection#getDestination <em>Destination</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Destination</em>'.
	 * @see org.osate.aadl2.Connection#getDestination()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_Destination();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.Connection#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Source</em>'.
	 * @see org.osate.aadl2.Connection#getSource()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_Source();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Connection#isBidirectional <em>Bidirectional</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bidirectional</em>'.
	 * @see org.osate.aadl2.Connection#isBidirectional()
	 * @see #getConnection()
	 * @generated
	 */
	EAttribute getConnection_Bidirectional();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Connection#getRefined <em>Refined</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refined</em>'.
	 * @see org.osate.aadl2.Connection#getRefined()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_Refined();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ConnectedElement <em>Connected Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connected Element</em>'.
	 * @see org.osate.aadl2.ConnectedElement
	 * @generated
	 */
	EClass getConnectedElement();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ConnectedElement#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Context</em>'.
	 * @see org.osate.aadl2.ConnectedElement#getContext()
	 * @see #getConnectedElement()
	 * @generated
	 */
	EReference getConnectedElement_Context();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ConnectedElement#getConnectionEnd <em>Connection End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Connection End</em>'.
	 * @see org.osate.aadl2.ConnectedElement#getConnectionEnd()
	 * @see #getConnectedElement()
	 * @generated
	 */
	EReference getConnectedElement_ConnectionEnd();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ImplementationExtension <em>Implementation Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Implementation Extension</em>'.
	 * @see org.osate.aadl2.ImplementationExtension
	 * @generated
	 */
	EClass getImplementationExtension();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ImplementationExtension#getExtended <em>Extended</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Extended</em>'.
	 * @see org.osate.aadl2.ImplementationExtension#getExtended()
	 * @see #getImplementationExtension()
	 * @generated
	 */
	EReference getImplementationExtension_Extended();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Realization <em>Realization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Realization</em>'.
	 * @see org.osate.aadl2.Realization
	 * @generated
	 */
	EClass getRealization();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.Realization#getImplemented <em>Implemented</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Implemented</em>'.
	 * @see org.osate.aadl2.Realization#getImplemented()
	 * @see #getRealization()
	 * @generated
	 */
	EReference getRealization_Implemented();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EndToEndFlow <em>End To End Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>End To End Flow</em>'.
	 * @see org.osate.aadl2.EndToEndFlow
	 * @generated
	 */
	EClass getEndToEndFlow();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.EndToEndFlow#getRefined <em>Refined</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refined</em>'.
	 * @see org.osate.aadl2.EndToEndFlow#getRefined()
	 * @see #getEndToEndFlow()
	 * @generated
	 */
	EReference getEndToEndFlow_Refined();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.EndToEndFlow#getOwnedEndToEndFlowSegments <em>Owned End To End Flow Segment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned End To End Flow Segment</em>'.
	 * @see org.osate.aadl2.EndToEndFlow#getOwnedEndToEndFlowSegments()
	 * @see #getEndToEndFlow()
	 * @generated
	 */
	EReference getEndToEndFlow_OwnedEndToEndFlowSegment();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EndToEndFlowSegment <em>End To End Flow Segment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>End To End Flow Segment</em>'.
	 * @see org.osate.aadl2.EndToEndFlowSegment
	 * @generated
	 */
	EClass getEndToEndFlowSegment();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.EndToEndFlowSegment#getFlowElement <em>Flow Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow Element</em>'.
	 * @see org.osate.aadl2.EndToEndFlowSegment#getFlowElement()
	 * @see #getEndToEndFlowSegment()
	 * @generated
	 */
	EReference getEndToEndFlowSegment_FlowElement();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.EndToEndFlowSegment#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Context</em>'.
	 * @see org.osate.aadl2.EndToEndFlowSegment#getContext()
	 * @see #getEndToEndFlowSegment()
	 * @generated
	 */
	EReference getEndToEndFlowSegment_Context();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractSubcomponent <em>Abstract Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractSubcomponent
	 * @generated
	 */
	EClass getAbstractSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.AbstractSubcomponent#getAbstractSubcomponentType <em>Abstract Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Abstract Subcomponent Type</em>'.
	 * @see org.osate.aadl2.AbstractSubcomponent#getAbstractSubcomponentType()
	 * @see #getAbstractSubcomponent()
	 * @generated
	 */
	EReference getAbstractSubcomponent_AbstractSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AccessConnection <em>Access Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access Connection</em>'.
	 * @see org.osate.aadl2.AccessConnection
	 * @generated
	 */
	EClass getAccessConnection();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.AccessConnection#getAccessCategory <em>Access Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Access Category</em>'.
	 * @see org.osate.aadl2.AccessConnection#getAccessCategory()
	 * @see #getAccessConnection()
	 * @generated
	 */
	EAttribute getAccessConnection_AccessCategory();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ParameterConnection <em>Parameter Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Parameter Connection</em>'.
	 * @see org.osate.aadl2.ParameterConnection
	 * @generated
	 */
	EClass getParameterConnection();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PortConnection <em>Port Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Connection</em>'.
	 * @see org.osate.aadl2.PortConnection
	 * @generated
	 */
	EClass getPortConnection();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureConnection <em>Feature Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Connection</em>'.
	 * @see org.osate.aadl2.FeatureConnection
	 * @generated
	 */
	EClass getFeatureConnection();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroupConnection <em>Feature Group Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group Connection</em>'.
	 * @see org.osate.aadl2.FeatureGroupConnection
	 * @generated
	 */
	EClass getFeatureGroupConnection();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessorFeature <em>Processor Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor Feature</em>'.
	 * @see org.osate.aadl2.ProcessorFeature
	 * @generated
	 */
	EClass getProcessorFeature();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.InternalFeature <em>Internal Feature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Internal Feature</em>'.
	 * @see org.osate.aadl2.InternalFeature
	 * @generated
	 */
	EClass getInternalFeature();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.InternalFeature#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see org.osate.aadl2.InternalFeature#getDirection()
	 * @see #getInternalFeature()
	 * @generated
	 */
	EAttribute getInternalFeature_Direction();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EventSource <em>Event Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Source</em>'.
	 * @see org.osate.aadl2.EventSource
	 * @generated
	 */
	EClass getEventSource();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EventDataSource <em>Event Data Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Data Source</em>'.
	 * @see org.osate.aadl2.EventDataSource
	 * @generated
	 */
	EClass getEventDataSource();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.EventDataSource#getDataClassifier <em>Data Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Classifier</em>'.
	 * @see org.osate.aadl2.EventDataSource#getDataClassifier()
	 * @see #getEventDataSource()
	 * @generated
	 */
	EReference getEventDataSource_DataClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PortProxy <em>Port Proxy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Proxy</em>'.
	 * @see org.osate.aadl2.PortProxy
	 * @generated
	 */
	EClass getPortProxy();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PortProxy#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see org.osate.aadl2.PortProxy#getDirection()
	 * @see #getPortProxy()
	 * @generated
	 */
	EAttribute getPortProxy_Direction();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PortProxy#getDataClassifier <em>Data Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Classifier</em>'.
	 * @see org.osate.aadl2.PortProxy#getDataClassifier()
	 * @see #getPortProxy()
	 * @generated
	 */
	EReference getPortProxy_DataClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramProxy <em>Subprogram Proxy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Proxy</em>'.
	 * @see org.osate.aadl2.SubprogramProxy
	 * @generated
	 */
	EClass getSubprogramProxy();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SubprogramProxy#getSubprogramClassifier <em>Subprogram Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Subprogram Classifier</em>'.
	 * @see org.osate.aadl2.SubprogramProxy#getSubprogramClassifier()
	 * @see #getSubprogramProxy()
	 * @generated
	 */
	EReference getSubprogramProxy_SubprogramClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AnnexLibrary <em>Annex Library</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Annex Library</em>'.
	 * @see org.osate.aadl2.AnnexLibrary
	 * @generated
	 */
	EClass getAnnexLibrary();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DefaultAnnexLibrary <em>Default Annex Library</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Default Annex Library</em>'.
	 * @see org.osate.aadl2.DefaultAnnexLibrary
	 * @generated
	 */
	EClass getDefaultAnnexLibrary();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.DefaultAnnexLibrary#getSourceText <em>Source Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Text</em>'.
	 * @see org.osate.aadl2.DefaultAnnexLibrary#getSourceText()
	 * @see #getDefaultAnnexLibrary()
	 * @generated
	 */
	EAttribute getDefaultAnnexLibrary_SourceText();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.DefaultAnnexLibrary#getParsedAnnexLibrary <em>Parsed Annex Library</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Parsed Annex Library</em>'.
	 * @see org.osate.aadl2.DefaultAnnexLibrary#getParsedAnnexLibrary()
	 * @see #getDefaultAnnexLibrary()
	 * @generated
	 */
	EReference getDefaultAnnexLibrary_ParsedAnnexLibrary();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DefaultAnnexSubclause <em>Default Annex Subclause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Default Annex Subclause</em>'.
	 * @see org.osate.aadl2.DefaultAnnexSubclause
	 * @generated
	 */
	EClass getDefaultAnnexSubclause();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.DefaultAnnexSubclause#getSourceText <em>Source Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Text</em>'.
	 * @see org.osate.aadl2.DefaultAnnexSubclause#getSourceText()
	 * @see #getDefaultAnnexSubclause()
	 * @generated
	 */
	EAttribute getDefaultAnnexSubclause_SourceText();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.DefaultAnnexSubclause#getParsedAnnexSubclause <em>Parsed Annex Subclause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Parsed Annex Subclause</em>'.
	 * @see org.osate.aadl2.DefaultAnnexSubclause#getParsedAnnexSubclause()
	 * @see #getDefaultAnnexSubclause()
	 * @generated
	 */
	EReference getDefaultAnnexSubclause_ParsedAnnexSubclause();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PublicPackageSection <em>Public Package Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Public Package Section</em>'.
	 * @see org.osate.aadl2.PublicPackageSection
	 * @generated
	 */
	EClass getPublicPackageSection();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PublicPackageSection#getPrivateSection <em>Private Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Private Section</em>'.
	 * @see org.osate.aadl2.PublicPackageSection#getPrivateSection()
	 * @see #getPublicPackageSection()
	 * @generated
	 */
	EReference getPublicPackageSection_PrivateSection();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PackageSection <em>Package Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Package Section</em>'.
	 * @see org.osate.aadl2.PackageSection
	 * @generated
	 */
	EClass getPackageSection();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PackageSection#getOwnedPackageRenames <em>Owned Package Rename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Package Rename</em>'.
	 * @see org.osate.aadl2.PackageSection#getOwnedPackageRenames()
	 * @see #getPackageSection()
	 * @generated
	 */
	EReference getPackageSection_OwnedPackageRename();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PackageSection#getOwnedComponentTypeRenames <em>Owned Component Type Rename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Component Type Rename</em>'.
	 * @see org.osate.aadl2.PackageSection#getOwnedComponentTypeRenames()
	 * @see #getPackageSection()
	 * @generated
	 */
	EReference getPackageSection_OwnedComponentTypeRename();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PackageSection#getOwnedClassifiers <em>Owned Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Classifier</em>'.
	 * @see org.osate.aadl2.PackageSection#getOwnedClassifiers()
	 * @see #getPackageSection()
	 * @generated
	 */
	EReference getPackageSection_OwnedClassifier();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PackageSection#getOwnedFeatureGroupTypeRenames <em>Owned Feature Group Type Rename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Feature Group Type Rename</em>'.
	 * @see org.osate.aadl2.PackageSection#getOwnedFeatureGroupTypeRenames()
	 * @see #getPackageSection()
	 * @generated
	 */
	EReference getPackageSection_OwnedFeatureGroupTypeRename();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PackageSection#getOwnedAnnexLibraries <em>Owned Annex Library</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Annex Library</em>'.
	 * @see org.osate.aadl2.PackageSection#getOwnedAnnexLibraries()
	 * @see #getPackageSection()
	 * @generated
	 */
	EReference getPackageSection_OwnedAnnexLibrary();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.PackageSection#getImportedUnits <em>Imported Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Imported Unit</em>'.
	 * @see org.osate.aadl2.PackageSection#getImportedUnits()
	 * @see #getPackageSection()
	 * @generated
	 */
	EReference getPackageSection_ImportedUnit();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PackageSection#isNoAnnexes <em>No Annexes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Annexes</em>'.
	 * @see org.osate.aadl2.PackageSection#isNoAnnexes()
	 * @see #getPackageSection()
	 * @generated
	 */
	EAttribute getPackageSection_NoAnnexes();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PackageSection#isNoProperties <em>No Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>No Properties</em>'.
	 * @see org.osate.aadl2.PackageSection#isNoProperties()
	 * @see #getPackageSection()
	 * @generated
	 */
	EAttribute getPackageSection_NoProperties();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PackageRename <em>Package Rename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Package Rename</em>'.
	 * @see org.osate.aadl2.PackageRename
	 * @generated
	 */
	EClass getPackageRename();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PackageRename#getRenamedPackage <em>Renamed Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Renamed Package</em>'.
	 * @see org.osate.aadl2.PackageRename#getRenamedPackage()
	 * @see #getPackageRename()
	 * @generated
	 */
	EReference getPackageRename_RenamedPackage();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PackageRename#isRenameAll <em>Rename All</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rename All</em>'.
	 * @see org.osate.aadl2.PackageRename#isRenameAll()
	 * @see #getPackageRename()
	 * @generated
	 */
	EAttribute getPackageRename_RenameAll();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AadlPackage <em>Aadl Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Aadl Package</em>'.
	 * @see org.osate.aadl2.AadlPackage
	 * @generated
	 */
	EClass getAadlPackage();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.AadlPackage#getOwnedPublicSection <em>Owned Public Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Public Section</em>'.
	 * @see org.osate.aadl2.AadlPackage#getOwnedPublicSection()
	 * @see #getAadlPackage()
	 * @generated
	 */
	EReference getAadlPackage_OwnedPublicSection();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.AadlPackage#getOwnedPrivateSection <em>Owned Private Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Private Section</em>'.
	 * @see org.osate.aadl2.AadlPackage#getOwnedPrivateSection()
	 * @see #getAadlPackage()
	 * @generated
	 */
	EReference getAadlPackage_OwnedPrivateSection();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.AadlPackage#getPublicSection <em>Public Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Public Section</em>'.
	 * @see org.osate.aadl2.AadlPackage#getPublicSection()
	 * @see #getAadlPackage()
	 * @generated
	 */
	EReference getAadlPackage_PublicSection();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.AadlPackage#getPrivateSection <em>Private Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Private Section</em>'.
	 * @see org.osate.aadl2.AadlPackage#getPrivateSection()
	 * @see #getAadlPackage()
	 * @generated
	 */
	EReference getAadlPackage_PrivateSection();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ModelUnit <em>Model Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Unit</em>'.
	 * @see org.osate.aadl2.ModelUnit
	 * @generated
	 */
	EClass getModelUnit();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PrivatePackageSection <em>Private Package Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Private Package Section</em>'.
	 * @see org.osate.aadl2.PrivatePackageSection
	 * @generated
	 */
	EClass getPrivatePackageSection();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PrivatePackageSection#getPublicSection <em>Public Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Public Section</em>'.
	 * @see org.osate.aadl2.PrivatePackageSection#getPublicSection()
	 * @see #getPrivatePackageSection()
	 * @generated
	 */
	EReference getPrivatePackageSection_PublicSection();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentTypeRename <em>Component Type Rename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Type Rename</em>'.
	 * @see org.osate.aadl2.ComponentTypeRename
	 * @generated
	 */
	EClass getComponentTypeRename();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentTypeRename#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see org.osate.aadl2.ComponentTypeRename#getCategory()
	 * @see #getComponentTypeRename()
	 * @generated
	 */
	EAttribute getComponentTypeRename_Category();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ComponentTypeRename#getRenamedComponentType <em>Renamed Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Renamed Component Type</em>'.
	 * @see org.osate.aadl2.ComponentTypeRename#getRenamedComponentType()
	 * @see #getComponentTypeRename()
	 * @generated
	 */
	EReference getComponentTypeRename_RenamedComponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroupTypeRename <em>Feature Group Type Rename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group Type Rename</em>'.
	 * @see org.osate.aadl2.FeatureGroupTypeRename
	 * @generated
	 */
	EClass getFeatureGroupTypeRename();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroupTypeRename#getRenamedFeatureGroupType <em>Renamed Feature Group Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Renamed Feature Group Type</em>'.
	 * @see org.osate.aadl2.FeatureGroupTypeRename#getRenamedFeatureGroupType()
	 * @see #getFeatureGroupTypeRename()
	 * @generated
	 */
	EReference getFeatureGroupTypeRename_RenamedFeatureGroupType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractType <em>Abstract Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Type</em>'.
	 * @see org.osate.aadl2.AbstractType
	 * @generated
	 */
	EClass getAbstractType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractType#getOwnedBusAccesses <em>Owned Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Access</em>'.
	 * @see org.osate.aadl2.AbstractType#getOwnedBusAccesses()
	 * @see #getAbstractType()
	 * @generated
	 */
	EReference getAbstractType_OwnedBusAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.AbstractType#getOwnedDataAccesses()
	 * @see #getAbstractType()
	 * @generated
	 */
	EReference getAbstractType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.AbstractType#getOwnedSubprogramAccesses()
	 * @see #getAbstractType()
	 * @generated
	 */
	EReference getAbstractType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.AbstractType#getOwnedDataPorts()
	 * @see #getAbstractType()
	 * @generated
	 */
	EReference getAbstractType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.AbstractType#getOwnedEventPorts()
	 * @see #getAbstractType()
	 * @generated
	 */
	EReference getAbstractType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.AbstractType#getOwnedEventDataPorts()
	 * @see #getAbstractType()
	 * @generated
	 */
	EReference getAbstractType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.AbstractType#getOwnedSubprogramGroupAccesses()
	 * @see #getAbstractType()
	 * @generated
	 */
	EReference getAbstractType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractImplementation <em>Abstract Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Implementation</em>'.
	 * @see org.osate.aadl2.AbstractImplementation
	 * @generated
	 */
	EClass getAbstractImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedBusSubcomponents <em>Owned Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedBusSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedDataSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedDeviceSubcomponents <em>Owned Device Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Device Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedDeviceSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedDeviceSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedMemorySubcomponents <em>Owned Memory Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Memory Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedMemorySubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedMemorySubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedProcessSubcomponents <em>Owned Process Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Process Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedProcessSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedProcessSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedProcessorSubcomponents <em>Owned Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedProcessorSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedProcessorSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedSystemSubcomponents <em>Owned System Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned System Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedSystemSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedSystemSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedSubprogramGroupSubcomponents <em>Owned Subprogram Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedSubprogramGroupSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedSubprogramGroupSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedThreadSubcomponents <em>Owned Thread Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Thread Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedThreadSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedThreadSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedThreadGroupSubcomponents <em>Owned Thread Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Thread Group Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedThreadGroupSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedThreadGroupSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedVirtualBusSubcomponents <em>Owned Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedVirtualBusSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedVirtualBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.AbstractImplementation#getOwnedVirtualProcessorSubcomponents <em>Owned Virtual Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.AbstractImplementation#getOwnedVirtualProcessorSubcomponents()
	 * @see #getAbstractImplementation()
	 * @generated
	 */
	EReference getAbstractImplementation_OwnedVirtualProcessorSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BehavioredImplementation <em>Behaviored Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Behaviored Implementation</em>'.
	 * @see org.osate.aadl2.BehavioredImplementation
	 * @generated
	 */
	EClass getBehavioredImplementation();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.BehavioredImplementation#getSubprogramCalls <em>Subprogram Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Subprogram Call</em>'.
	 * @see org.osate.aadl2.BehavioredImplementation#getSubprogramCalls()
	 * @see #getBehavioredImplementation()
	 * @generated
	 */
	EReference getBehavioredImplementation_SubprogramCall();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.BehavioredImplementation#getOwnedSubprogramCallSequences <em>Owned Subprogram Call Sequence</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Call Sequence</em>'.
	 * @see org.osate.aadl2.BehavioredImplementation#getOwnedSubprogramCallSequences()
	 * @see #getBehavioredImplementation()
	 * @generated
	 */
	EReference getBehavioredImplementation_OwnedSubprogramCallSequence();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramCallSequence <em>Subprogram Call Sequence</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Call Sequence</em>'.
	 * @see org.osate.aadl2.SubprogramCallSequence
	 * @generated
	 */
	EClass getSubprogramCallSequence();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramCallSequence#getOwnedSubprogramCalls <em>Owned Subprogram Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Call</em>'.
	 * @see org.osate.aadl2.SubprogramCallSequence#getOwnedSubprogramCalls()
	 * @see #getSubprogramCallSequence()
	 * @generated
	 */
	EReference getSubprogramCallSequence_OwnedSubprogramCall();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BusSubcomponent <em>Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.BusSubcomponent
	 * @generated
	 */
	EClass getBusSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.BusSubcomponent#getBusSubcomponentType <em>Bus Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Bus Subcomponent Type</em>'.
	 * @see org.osate.aadl2.BusSubcomponent#getBusSubcomponentType()
	 * @see #getBusSubcomponent()
	 * @generated
	 */
	EReference getBusSubcomponent_BusSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataSubcomponent <em>Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Subcomponent</em>'.
	 * @see org.osate.aadl2.DataSubcomponent
	 * @generated
	 */
	EClass getDataSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.DataSubcomponent#getDataSubcomponentType <em>Data Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Subcomponent Type</em>'.
	 * @see org.osate.aadl2.DataSubcomponent#getDataSubcomponentType()
	 * @see #getDataSubcomponent()
	 * @generated
	 */
	EReference getDataSubcomponent_DataSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DeviceSubcomponent <em>Device Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device Subcomponent</em>'.
	 * @see org.osate.aadl2.DeviceSubcomponent
	 * @generated
	 */
	EClass getDeviceSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.DeviceSubcomponent#getDeviceSubcomponentType <em>Device Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Device Subcomponent Type</em>'.
	 * @see org.osate.aadl2.DeviceSubcomponent#getDeviceSubcomponentType()
	 * @see #getDeviceSubcomponent()
	 * @generated
	 */
	EReference getDeviceSubcomponent_DeviceSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Device <em>Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device</em>'.
	 * @see org.osate.aadl2.Device
	 * @generated
	 */
	EClass getDevice();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DeviceSubcomponentType <em>Device Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device Subcomponent Type</em>'.
	 * @see org.osate.aadl2.DeviceSubcomponentType
	 * @generated
	 */
	EClass getDeviceSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DeviceClassifier <em>Device Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device Classifier</em>'.
	 * @see org.osate.aadl2.DeviceClassifier
	 * @generated
	 */
	EClass getDeviceClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.MemorySubcomponent <em>Memory Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory Subcomponent</em>'.
	 * @see org.osate.aadl2.MemorySubcomponent
	 * @generated
	 */
	EClass getMemorySubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.MemorySubcomponent#getMemorySubcomponentType <em>Memory Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Memory Subcomponent Type</em>'.
	 * @see org.osate.aadl2.MemorySubcomponent#getMemorySubcomponentType()
	 * @see #getMemorySubcomponent()
	 * @generated
	 */
	EReference getMemorySubcomponent_MemorySubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Memory <em>Memory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory</em>'.
	 * @see org.osate.aadl2.Memory
	 * @generated
	 */
	EClass getMemory();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.MemorySubcomponentType <em>Memory Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory Subcomponent Type</em>'.
	 * @see org.osate.aadl2.MemorySubcomponentType
	 * @generated
	 */
	EClass getMemorySubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.MemoryClassifier <em>Memory Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory Classifier</em>'.
	 * @see org.osate.aadl2.MemoryClassifier
	 * @generated
	 */
	EClass getMemoryClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessSubcomponent <em>Process Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessSubcomponent
	 * @generated
	 */
	EClass getProcessSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ProcessSubcomponent#getProcessSubcomponentType <em>Process Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ProcessSubcomponent#getProcessSubcomponentType()
	 * @see #getProcessSubcomponent()
	 * @generated
	 */
	EReference getProcessSubcomponent_ProcessSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Process <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process</em>'.
	 * @see org.osate.aadl2.Process
	 * @generated
	 */
	EClass getProcess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessSubcomponentType <em>Process Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ProcessSubcomponentType
	 * @generated
	 */
	EClass getProcessSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessClassifier <em>Process Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Classifier</em>'.
	 * @see org.osate.aadl2.ProcessClassifier
	 * @generated
	 */
	EClass getProcessClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessorSubcomponent <em>Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessorSubcomponent
	 * @generated
	 */
	EClass getProcessorSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ProcessorSubcomponent#getProcessorSubcomponentType <em>Processor Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Processor Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ProcessorSubcomponent#getProcessorSubcomponentType()
	 * @see #getProcessorSubcomponent()
	 * @generated
	 */
	EReference getProcessorSubcomponent_ProcessorSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Processor <em>Processor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor</em>'.
	 * @see org.osate.aadl2.Processor
	 * @generated
	 */
	EClass getProcessor();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessorSubcomponentType <em>Processor Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ProcessorSubcomponentType
	 * @generated
	 */
	EClass getProcessorSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessorClassifier <em>Processor Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor Classifier</em>'.
	 * @see org.osate.aadl2.ProcessorClassifier
	 * @generated
	 */
	EClass getProcessorClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SystemSubcomponent <em>System Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemSubcomponent
	 * @generated
	 */
	EClass getSystemSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SystemSubcomponent#getSystemSubcomponentType <em>System Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>System Subcomponent Type</em>'.
	 * @see org.osate.aadl2.SystemSubcomponent#getSystemSubcomponentType()
	 * @see #getSystemSubcomponent()
	 * @generated
	 */
	EReference getSystemSubcomponent_SystemSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.System <em>System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System</em>'.
	 * @see org.osate.aadl2.System
	 * @generated
	 */
	EClass getSystem();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SystemSubcomponentType <em>System Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Subcomponent Type</em>'.
	 * @see org.osate.aadl2.SystemSubcomponentType
	 * @generated
	 */
	EClass getSystemSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SystemClassifier <em>System Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Classifier</em>'.
	 * @see org.osate.aadl2.SystemClassifier
	 * @generated
	 */
	EClass getSystemClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramSubcomponent <em>Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.SubprogramSubcomponent
	 * @generated
	 */
	EClass getSubprogramSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SubprogramSubcomponent#getSubprogramSubcomponentType <em>Subprogram Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Subprogram Subcomponent Type</em>'.
	 * @see org.osate.aadl2.SubprogramSubcomponent#getSubprogramSubcomponentType()
	 * @see #getSubprogramSubcomponent()
	 * @generated
	 */
	EReference getSubprogramSubcomponent_SubprogramSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroupSubcomponent <em>Subprogram Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group Subcomponent</em>'.
	 * @see org.osate.aadl2.SubprogramGroupSubcomponent
	 * @generated
	 */
	EClass getSubprogramGroupSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SubprogramGroupSubcomponent#getSubprogramGroupSubcomponentType <em>Subprogram Group Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Subprogram Group Subcomponent Type</em>'.
	 * @see org.osate.aadl2.SubprogramGroupSubcomponent#getSubprogramGroupSubcomponentType()
	 * @see #getSubprogramGroupSubcomponent()
	 * @generated
	 */
	EReference getSubprogramGroupSubcomponent_SubprogramGroupSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadSubcomponent <em>Thread Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadSubcomponent
	 * @generated
	 */
	EClass getThreadSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ThreadSubcomponent#getThreadSubcomponentType <em>Thread Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Thread Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ThreadSubcomponent#getThreadSubcomponentType()
	 * @see #getThreadSubcomponent()
	 * @generated
	 */
	EReference getThreadSubcomponent_ThreadSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Thread <em>Thread</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread</em>'.
	 * @see org.osate.aadl2.Thread
	 * @generated
	 */
	EClass getThread();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadSubcomponentType <em>Thread Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ThreadSubcomponentType
	 * @generated
	 */
	EClass getThreadSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadClassifier <em>Thread Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Classifier</em>'.
	 * @see org.osate.aadl2.ThreadClassifier
	 * @generated
	 */
	EClass getThreadClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadGroupSubcomponent <em>Thread Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Group Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadGroupSubcomponent
	 * @generated
	 */
	EClass getThreadGroupSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ThreadGroupSubcomponent#getThreadGroupSubcomponentType <em>Thread Group Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Thread Group Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ThreadGroupSubcomponent#getThreadGroupSubcomponentType()
	 * @see #getThreadGroupSubcomponent()
	 * @generated
	 */
	EReference getThreadGroupSubcomponent_ThreadGroupSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadGroup <em>Thread Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Group</em>'.
	 * @see org.osate.aadl2.ThreadGroup
	 * @generated
	 */
	EClass getThreadGroup();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadGroupSubcomponentType <em>Thread Group Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Group Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ThreadGroupSubcomponentType
	 * @generated
	 */
	EClass getThreadGroupSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadGroupClassifier <em>Thread Group Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Group Classifier</em>'.
	 * @see org.osate.aadl2.ThreadGroupClassifier
	 * @generated
	 */
	EClass getThreadGroupClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualBusSubcomponent <em>Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.VirtualBusSubcomponent
	 * @generated
	 */
	EClass getVirtualBusSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.VirtualBusSubcomponent#getVirtualBusSubcomponentType <em>Virtual Bus Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Virtual Bus Subcomponent Type</em>'.
	 * @see org.osate.aadl2.VirtualBusSubcomponent#getVirtualBusSubcomponentType()
	 * @see #getVirtualBusSubcomponent()
	 * @generated
	 */
	EReference getVirtualBusSubcomponent_VirtualBusSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualBus <em>Virtual Bus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Bus</em>'.
	 * @see org.osate.aadl2.VirtualBus
	 * @generated
	 */
	EClass getVirtualBus();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualBusClassifier <em>Virtual Bus Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Bus Classifier</em>'.
	 * @see org.osate.aadl2.VirtualBusClassifier
	 * @generated
	 */
	EClass getVirtualBusClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualProcessorSubcomponent <em>Virtual Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.VirtualProcessorSubcomponent
	 * @generated
	 */
	EClass getVirtualProcessorSubcomponent();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.VirtualProcessorSubcomponent#getVirtualProcessorSubcomponentType <em>Virtual Processor Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Virtual Processor Subcomponent Type</em>'.
	 * @see org.osate.aadl2.VirtualProcessorSubcomponent#getVirtualProcessorSubcomponentType()
	 * @see #getVirtualProcessorSubcomponent()
	 * @generated
	 */
	EReference getVirtualProcessorSubcomponent_VirtualProcessorSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualProcessor <em>Virtual Processor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Processor</em>'.
	 * @see org.osate.aadl2.VirtualProcessor
	 * @generated
	 */
	EClass getVirtualProcessor();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualBusSubcomponentType <em>Virtual Bus Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Bus Subcomponent Type</em>'.
	 * @see org.osate.aadl2.VirtualBusSubcomponentType
	 * @generated
	 */
	EClass getVirtualBusSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualProcessorSubcomponentType <em>Virtual Processor Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Processor Subcomponent Type</em>'.
	 * @see org.osate.aadl2.VirtualProcessorSubcomponentType
	 * @generated
	 */
	EClass getVirtualProcessorSubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractPrototype <em>Abstract Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Prototype</em>'.
	 * @see org.osate.aadl2.AbstractPrototype
	 * @generated
	 */
	EClass getAbstractPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualProcessorClassifier <em>Virtual Processor Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Processor Classifier</em>'.
	 * @see org.osate.aadl2.VirtualProcessorClassifier
	 * @generated
	 */
	EClass getVirtualProcessorClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BusType <em>Bus Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Type</em>'.
	 * @see org.osate.aadl2.BusType
	 * @generated
	 */
	EClass getBusType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.BusType#getOwnedBusAccesses <em>Owned Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Access</em>'.
	 * @see org.osate.aadl2.BusType#getOwnedBusAccesses()
	 * @see #getBusType()
	 * @generated
	 */
	EReference getBusType_OwnedBusAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.BusType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.BusType#getOwnedDataPorts()
	 * @see #getBusType()
	 * @generated
	 */
	EReference getBusType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.BusType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.BusType#getOwnedEventDataPorts()
	 * @see #getBusType()
	 * @generated
	 */
	EReference getBusType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.BusType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.BusType#getOwnedEventPorts()
	 * @see #getBusType()
	 * @generated
	 */
	EReference getBusType_OwnedEventPort();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BusImplementation <em>Bus Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Implementation</em>'.
	 * @see org.osate.aadl2.BusImplementation
	 * @generated
	 */
	EClass getBusImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.BusImplementation#getOwnedVirtualBusSubcomponents <em>Owned Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.BusImplementation#getOwnedVirtualBusSubcomponents()
	 * @see #getBusImplementation()
	 * @generated
	 */
	EReference getBusImplementation_OwnedVirtualBusSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BusPrototype <em>Bus Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Prototype</em>'.
	 * @see org.osate.aadl2.BusPrototype
	 * @generated
	 */
	EClass getBusPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataType <em>Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Type</em>'.
	 * @see org.osate.aadl2.DataType
	 * @generated
	 */
	EClass getDataType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DataType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.DataType#getOwnedSubprogramAccesses()
	 * @see #getDataType()
	 * @generated
	 */
	EReference getDataType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DataType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.DataType#getOwnedDataAccesses()
	 * @see #getDataType()
	 * @generated
	 */
	EReference getDataType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DataType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.DataType#getOwnedSubprogramGroupAccesses()
	 * @see #getDataType()
	 * @generated
	 */
	EReference getDataType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataImplementation <em>Data Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Implementation</em>'.
	 * @see org.osate.aadl2.DataImplementation
	 * @generated
	 */
	EClass getDataImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DataImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.DataImplementation#getOwnedDataSubcomponents()
	 * @see #getDataImplementation()
	 * @generated
	 */
	EReference getDataImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DataImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.DataImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getDataImplementation()
	 * @generated
	 */
	EReference getDataImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DataPrototype <em>Data Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Prototype</em>'.
	 * @see org.osate.aadl2.DataPrototype
	 * @generated
	 */
	EClass getDataPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DeviceType <em>Device Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device Type</em>'.
	 * @see org.osate.aadl2.DeviceType
	 * @generated
	 */
	EClass getDeviceType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.DeviceType#getOwnedDataPorts()
	 * @see #getDeviceType()
	 * @generated
	 */
	EReference getDeviceType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.DeviceType#getOwnedEventDataPorts()
	 * @see #getDeviceType()
	 * @generated
	 */
	EReference getDeviceType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.DeviceType#getOwnedEventPorts()
	 * @see #getDeviceType()
	 * @generated
	 */
	EReference getDeviceType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceType#getOwnedBusAccesses <em>Owned Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Access</em>'.
	 * @see org.osate.aadl2.DeviceType#getOwnedBusAccesses()
	 * @see #getDeviceType()
	 * @generated
	 */
	EReference getDeviceType_OwnedBusAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.DeviceType#getOwnedSubprogramAccesses()
	 * @see #getDeviceType()
	 * @generated
	 */
	EReference getDeviceType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.DeviceType#getOwnedSubprogramGroupAccesses()
	 * @see #getDeviceType()
	 * @generated
	 */
	EReference getDeviceType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DeviceImplementation <em>Device Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device Implementation</em>'.
	 * @see org.osate.aadl2.DeviceImplementation
	 * @generated
	 */
	EClass getDeviceImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceImplementation#getOwnedBusSubcomponents <em>Owned Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.DeviceImplementation#getOwnedBusSubcomponents()
	 * @see #getDeviceImplementation()
	 * @generated
	 */
	EReference getDeviceImplementation_OwnedBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.DeviceImplementation#getOwnedDataSubcomponents()
	 * @see #getDeviceImplementation()
	 * @generated
	 */
	EReference getDeviceImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.DeviceImplementation#getOwnedVirtualBusSubcomponents <em>Owned Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.DeviceImplementation#getOwnedVirtualBusSubcomponents()
	 * @see #getDeviceImplementation()
	 * @generated
	 */
	EReference getDeviceImplementation_OwnedVirtualBusSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.DevicePrototype <em>Device Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device Prototype</em>'.
	 * @see org.osate.aadl2.DevicePrototype
	 * @generated
	 */
	EClass getDevicePrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.MemoryType <em>Memory Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory Type</em>'.
	 * @see org.osate.aadl2.MemoryType
	 * @generated
	 */
	EClass getMemoryType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.MemoryType#getOwnedBusAccesses <em>Owned Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Access</em>'.
	 * @see org.osate.aadl2.MemoryType#getOwnedBusAccesses()
	 * @see #getMemoryType()
	 * @generated
	 */
	EReference getMemoryType_OwnedBusAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.MemoryType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.MemoryType#getOwnedDataPorts()
	 * @see #getMemoryType()
	 * @generated
	 */
	EReference getMemoryType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.MemoryType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.MemoryType#getOwnedEventDataPorts()
	 * @see #getMemoryType()
	 * @generated
	 */
	EReference getMemoryType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.MemoryType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.MemoryType#getOwnedEventPorts()
	 * @see #getMemoryType()
	 * @generated
	 */
	EReference getMemoryType_OwnedEventPort();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.MemoryImplementation <em>Memory Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory Implementation</em>'.
	 * @see org.osate.aadl2.MemoryImplementation
	 * @generated
	 */
	EClass getMemoryImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.MemoryImplementation#getOwnedBusSubcomponents <em>Owned Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.MemoryImplementation#getOwnedBusSubcomponents()
	 * @see #getMemoryImplementation()
	 * @generated
	 */
	EReference getMemoryImplementation_OwnedBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.MemoryImplementation#getOwnedMemorySubcomponents <em>Owned Memory Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Memory Subcomponent</em>'.
	 * @see org.osate.aadl2.MemoryImplementation#getOwnedMemorySubcomponents()
	 * @see #getMemoryImplementation()
	 * @generated
	 */
	EReference getMemoryImplementation_OwnedMemorySubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.MemoryPrototype <em>Memory Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory Prototype</em>'.
	 * @see org.osate.aadl2.MemoryPrototype
	 * @generated
	 */
	EClass getMemoryPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessType <em>Process Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Type</em>'.
	 * @see org.osate.aadl2.ProcessType
	 * @generated
	 */
	EClass getProcessType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.ProcessType#getOwnedDataPorts()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.ProcessType#getOwnedEventDataPorts()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.ProcessType#getOwnedEventPorts()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.ProcessType#getOwnedDataAccesses()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.ProcessType#getOwnedSubprogramAccesses()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.ProcessType#getOwnedSubprogramGroupAccesses()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessorType <em>Processor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor Type</em>'.
	 * @see org.osate.aadl2.ProcessorType
	 * @generated
	 */
	EClass getProcessorType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.ProcessorType#getOwnedDataPorts()
	 * @see #getProcessorType()
	 * @generated
	 */
	EReference getProcessorType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.ProcessorType#getOwnedEventDataPorts()
	 * @see #getProcessorType()
	 * @generated
	 */
	EReference getProcessorType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.ProcessorType#getOwnedEventPorts()
	 * @see #getProcessorType()
	 * @generated
	 */
	EReference getProcessorType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorType#getOwnedBusAccesses <em>Owned Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Access</em>'.
	 * @see org.osate.aadl2.ProcessorType#getOwnedBusAccesses()
	 * @see #getProcessorType()
	 * @generated
	 */
	EReference getProcessorType_OwnedBusAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.ProcessorType#getOwnedSubprogramAccesses()
	 * @see #getProcessorType()
	 * @generated
	 */
	EReference getProcessorType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.ProcessorType#getOwnedSubprogramGroupAccesses()
	 * @see #getProcessorType()
	 * @generated
	 */
	EReference getProcessorType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessImplementation <em>Process Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Implementation</em>'.
	 * @see org.osate.aadl2.ProcessImplementation
	 * @generated
	 */
	EClass getProcessImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessImplementation#getOwnedDataSubcomponents()
	 * @see #getProcessImplementation()
	 * @generated
	 */
	EReference getProcessImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getProcessImplementation()
	 * @generated
	 */
	EReference getProcessImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessImplementation#getOwnedSubprogramGroupSubcomponents <em>Owned Subprogram Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessImplementation#getOwnedSubprogramGroupSubcomponents()
	 * @see #getProcessImplementation()
	 * @generated
	 */
	EReference getProcessImplementation_OwnedSubprogramGroupSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessImplementation#getOwnedThreadSubcomponents <em>Owned Thread Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Thread Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessImplementation#getOwnedThreadSubcomponents()
	 * @see #getProcessImplementation()
	 * @generated
	 */
	EReference getProcessImplementation_OwnedThreadSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessImplementation#getOwnedThreadGroupSubcomponents <em>Owned Thread Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Thread Group Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessImplementation#getOwnedThreadGroupSubcomponents()
	 * @see #getProcessImplementation()
	 * @generated
	 */
	EReference getProcessImplementation_OwnedThreadGroupSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessPrototype <em>Process Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Prototype</em>'.
	 * @see org.osate.aadl2.ProcessPrototype
	 * @generated
	 */
	EClass getProcessPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessorImplementation <em>Processor Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor Implementation</em>'.
	 * @see org.osate.aadl2.ProcessorImplementation
	 * @generated
	 */
	EClass getProcessorImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorImplementation#getOwnedBusSubcomponents <em>Owned Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessorImplementation#getOwnedBusSubcomponents()
	 * @see #getProcessorImplementation()
	 * @generated
	 */
	EReference getProcessorImplementation_OwnedBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorImplementation#getOwnedMemorySubcomponents <em>Owned Memory Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Memory Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessorImplementation#getOwnedMemorySubcomponents()
	 * @see #getProcessorImplementation()
	 * @generated
	 */
	EReference getProcessorImplementation_OwnedMemorySubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorImplementation#getOwnedVirtualBusSubcomponents <em>Owned Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessorImplementation#getOwnedVirtualBusSubcomponents()
	 * @see #getProcessorImplementation()
	 * @generated
	 */
	EReference getProcessorImplementation_OwnedVirtualBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ProcessorImplementation#getOwnedVirtualProcessorSubcomponents <em>Owned Virtual Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.ProcessorImplementation#getOwnedVirtualProcessorSubcomponents()
	 * @see #getProcessorImplementation()
	 * @generated
	 */
	EReference getProcessorImplementation_OwnedVirtualProcessorSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ProcessorPrototype <em>Processor Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processor Prototype</em>'.
	 * @see org.osate.aadl2.ProcessorPrototype
	 * @generated
	 */
	EClass getProcessorPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramType <em>Subprogram Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Type</em>'.
	 * @see org.osate.aadl2.SubprogramType
	 * @generated
	 */
	EClass getSubprogramType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.SubprogramType#getOwnedEventDataPorts()
	 * @see #getSubprogramType()
	 * @generated
	 */
	EReference getSubprogramType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.SubprogramType#getOwnedEventPorts()
	 * @see #getSubprogramType()
	 * @generated
	 */
	EReference getSubprogramType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramType#getOwnedParameters <em>Owned Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Parameter</em>'.
	 * @see org.osate.aadl2.SubprogramType#getOwnedParameters()
	 * @see #getSubprogramType()
	 * @generated
	 */
	EReference getSubprogramType_OwnedParameter();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.SubprogramType#getOwnedDataAccesses()
	 * @see #getSubprogramType()
	 * @generated
	 */
	EReference getSubprogramType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.SubprogramType#getOwnedSubprogramAccesses()
	 * @see #getSubprogramType()
	 * @generated
	 */
	EReference getSubprogramType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.SubprogramType#getOwnedSubprogramGroupAccesses()
	 * @see #getSubprogramType()
	 * @generated
	 */
	EReference getSubprogramType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramImplementation <em>Subprogram Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Implementation</em>'.
	 * @see org.osate.aadl2.SubprogramImplementation
	 * @generated
	 */
	EClass getSubprogramImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.SubprogramImplementation#getOwnedDataSubcomponents()
	 * @see #getSubprogramImplementation()
	 * @generated
	 */
	EReference getSubprogramImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.SubprogramImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getSubprogramImplementation()
	 * @generated
	 */
	EReference getSubprogramImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramPrototype <em>Subprogram Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Prototype</em>'.
	 * @see org.osate.aadl2.SubprogramPrototype
	 * @generated
	 */
	EClass getSubprogramPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroupType <em>Subprogram Group Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group Type</em>'.
	 * @see org.osate.aadl2.SubprogramGroupType
	 * @generated
	 */
	EClass getSubprogramGroupType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramGroupType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.SubprogramGroupType#getOwnedSubprogramAccesses()
	 * @see #getSubprogramGroupType()
	 * @generated
	 */
	EReference getSubprogramGroupType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramGroupType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.SubprogramGroupType#getOwnedSubprogramGroupAccesses()
	 * @see #getSubprogramGroupType()
	 * @generated
	 */
	EReference getSubprogramGroupType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroupImplementation <em>Subprogram Group Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group Implementation</em>'.
	 * @see org.osate.aadl2.SubprogramGroupImplementation
	 * @generated
	 */
	EClass getSubprogramGroupImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramGroupImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.SubprogramGroupImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getSubprogramGroupImplementation()
	 * @generated
	 */
	EReference getSubprogramGroupImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramGroupImplementation#getOwnedSubprogramGroupSubcomponents <em>Owned Subprogram Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Subcomponent</em>'.
	 * @see org.osate.aadl2.SubprogramGroupImplementation#getOwnedSubprogramGroupSubcomponents()
	 * @see #getSubprogramGroupImplementation()
	 * @generated
	 */
	EReference getSubprogramGroupImplementation_OwnedSubprogramGroupSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SubprogramGroupImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.SubprogramGroupImplementation#getOwnedDataSubcomponents()
	 * @see #getSubprogramGroupImplementation()
	 * @generated
	 */
	EReference getSubprogramGroupImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramGroupPrototype <em>Subprogram Group Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Group Prototype</em>'.
	 * @see org.osate.aadl2.SubprogramGroupPrototype
	 * @generated
	 */
	EClass getSubprogramGroupPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SystemType <em>System Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Type</em>'.
	 * @see org.osate.aadl2.SystemType
	 * @generated
	 */
	EClass getSystemType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemType#getOwnedBusAccesses <em>Owned Bus Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Access</em>'.
	 * @see org.osate.aadl2.SystemType#getOwnedBusAccesses()
	 * @see #getSystemType()
	 * @generated
	 */
	EReference getSystemType_OwnedBusAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.SystemType#getOwnedDataAccesses()
	 * @see #getSystemType()
	 * @generated
	 */
	EReference getSystemType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.SystemType#getOwnedDataPorts()
	 * @see #getSystemType()
	 * @generated
	 */
	EReference getSystemType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.SystemType#getOwnedSubprogramGroupAccesses()
	 * @see #getSystemType()
	 * @generated
	 */
	EReference getSystemType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.SystemType#getOwnedSubprogramAccesses()
	 * @see #getSystemType()
	 * @generated
	 */
	EReference getSystemType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.SystemType#getOwnedEventPorts()
	 * @see #getSystemType()
	 * @generated
	 */
	EReference getSystemType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.SystemType#getOwnedEventDataPorts()
	 * @see #getSystemType()
	 * @generated
	 */
	EReference getSystemType_OwnedEventDataPort();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SystemImplementation <em>System Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Implementation</em>'.
	 * @see org.osate.aadl2.SystemImplementation
	 * @generated
	 */
	EClass getSystemImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedBusSubcomponents <em>Owned Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedBusSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedDataSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedDeviceSubcomponents <em>Owned Device Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Device Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedDeviceSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedDeviceSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedMemorySubcomponents <em>Owned Memory Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Memory Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedMemorySubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedMemorySubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedProcessSubcomponents <em>Owned Process Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Process Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedProcessSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedProcessSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedProcessorSubcomponents <em>Owned Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedProcessorSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedProcessorSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedSubprogramGroupSubcomponents <em>Owned Subprogram Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedSubprogramGroupSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedSubprogramGroupSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedSystemSubcomponents <em>Owned System Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned System Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedSystemSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedSystemSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedVirtualBusSubcomponents <em>Owned Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedVirtualBusSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedVirtualBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.SystemImplementation#getOwnedVirtualProcessorSubcomponents <em>Owned Virtual Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.SystemImplementation#getOwnedVirtualProcessorSubcomponents()
	 * @see #getSystemImplementation()
	 * @generated
	 */
	EReference getSystemImplementation_OwnedVirtualProcessorSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SystemPrototype <em>System Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Prototype</em>'.
	 * @see org.osate.aadl2.SystemPrototype
	 * @generated
	 */
	EClass getSystemPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadType <em>Thread Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Type</em>'.
	 * @see org.osate.aadl2.ThreadType
	 * @generated
	 */
	EClass getThreadType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.ThreadType#getOwnedDataPorts()
	 * @see #getThreadType()
	 * @generated
	 */
	EReference getThreadType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.ThreadType#getOwnedEventDataPorts()
	 * @see #getThreadType()
	 * @generated
	 */
	EReference getThreadType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.ThreadType#getOwnedEventPorts()
	 * @see #getThreadType()
	 * @generated
	 */
	EReference getThreadType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.ThreadType#getOwnedDataAccesses()
	 * @see #getThreadType()
	 * @generated
	 */
	EReference getThreadType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.ThreadType#getOwnedSubprogramAccesses()
	 * @see #getThreadType()
	 * @generated
	 */
	EReference getThreadType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.ThreadType#getOwnedSubprogramGroupAccesses()
	 * @see #getThreadType()
	 * @generated
	 */
	EReference getThreadType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadImplementation <em>Thread Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Implementation</em>'.
	 * @see org.osate.aadl2.ThreadImplementation
	 * @generated
	 */
	EClass getThreadImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadImplementation#getOwnedSubprogramGroupSubcomponents <em>Owned Subprogram Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadImplementation#getOwnedSubprogramGroupSubcomponents()
	 * @see #getThreadImplementation()
	 * @generated
	 */
	EReference getThreadImplementation_OwnedSubprogramGroupSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getThreadImplementation()
	 * @generated
	 */
	EReference getThreadImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadImplementation#getOwnedDataSubcomponents()
	 * @see #getThreadImplementation()
	 * @generated
	 */
	EReference getThreadImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadPrototype <em>Thread Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Prototype</em>'.
	 * @see org.osate.aadl2.ThreadPrototype
	 * @generated
	 */
	EClass getThreadPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadGroupType <em>Thread Group Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Group Type</em>'.
	 * @see org.osate.aadl2.ThreadGroupType
	 * @generated
	 */
	EClass getThreadGroupType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.ThreadGroupType#getOwnedDataPorts()
	 * @see #getThreadGroupType()
	 * @generated
	 */
	EReference getThreadGroupType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.ThreadGroupType#getOwnedEventDataPorts()
	 * @see #getThreadGroupType()
	 * @generated
	 */
	EReference getThreadGroupType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.ThreadGroupType#getOwnedEventPorts()
	 * @see #getThreadGroupType()
	 * @generated
	 */
	EReference getThreadGroupType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupType#getOwnedDataAccesses <em>Owned Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Access</em>'.
	 * @see org.osate.aadl2.ThreadGroupType#getOwnedDataAccesses()
	 * @see #getThreadGroupType()
	 * @generated
	 */
	EReference getThreadGroupType_OwnedDataAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.ThreadGroupType#getOwnedSubprogramAccesses()
	 * @see #getThreadGroupType()
	 * @generated
	 */
	EReference getThreadGroupType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.ThreadGroupType#getOwnedSubprogramGroupAccesses()
	 * @see #getThreadGroupType()
	 * @generated
	 */
	EReference getThreadGroupType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadGroupImplementation <em>Thread Group Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Group Implementation</em>'.
	 * @see org.osate.aadl2.ThreadGroupImplementation
	 * @generated
	 */
	EClass getThreadGroupImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupImplementation#getOwnedDataSubcomponents <em>Owned Data Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadGroupImplementation#getOwnedDataSubcomponents()
	 * @see #getThreadGroupImplementation()
	 * @generated
	 */
	EReference getThreadGroupImplementation_OwnedDataSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupImplementation#getOwnedThreadSubcomponents <em>Owned Thread Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Thread Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadGroupImplementation#getOwnedThreadSubcomponents()
	 * @see #getThreadGroupImplementation()
	 * @generated
	 */
	EReference getThreadGroupImplementation_OwnedThreadSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupImplementation#getOwnedThreadGroupSubcomponents <em>Owned Thread Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Thread Group Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadGroupImplementation#getOwnedThreadGroupSubcomponents()
	 * @see #getThreadGroupImplementation()
	 * @generated
	 */
	EReference getThreadGroupImplementation_OwnedThreadGroupSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupImplementation#getOwnedSubprogramSubcomponents <em>Owned Subprogram Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadGroupImplementation#getOwnedSubprogramSubcomponents()
	 * @see #getThreadGroupImplementation()
	 * @generated
	 */
	EReference getThreadGroupImplementation_OwnedSubprogramSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ThreadGroupImplementation#getOwnedSubprogramGroupSubcomponents <em>Owned Subprogram Group Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Subcomponent</em>'.
	 * @see org.osate.aadl2.ThreadGroupImplementation#getOwnedSubprogramGroupSubcomponents()
	 * @see #getThreadGroupImplementation()
	 * @generated
	 */
	EReference getThreadGroupImplementation_OwnedSubprogramGroupSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ThreadGroupPrototype <em>Thread Group Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread Group Prototype</em>'.
	 * @see org.osate.aadl2.ThreadGroupPrototype
	 * @generated
	 */
	EClass getThreadGroupPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualBusType <em>Virtual Bus Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Bus Type</em>'.
	 * @see org.osate.aadl2.VirtualBusType
	 * @generated
	 */
	EClass getVirtualBusType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualBusType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.VirtualBusType#getOwnedDataPorts()
	 * @see #getVirtualBusType()
	 * @generated
	 */
	EReference getVirtualBusType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualBusType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.VirtualBusType#getOwnedEventDataPorts()
	 * @see #getVirtualBusType()
	 * @generated
	 */
	EReference getVirtualBusType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualBusType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.VirtualBusType#getOwnedEventPorts()
	 * @see #getVirtualBusType()
	 * @generated
	 */
	EReference getVirtualBusType_OwnedEventPort();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualBusImplementation <em>Virtual Bus Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Bus Implementation</em>'.
	 * @see org.osate.aadl2.VirtualBusImplementation
	 * @generated
	 */
	EClass getVirtualBusImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualBusImplementation#getOwnedVirtualBusSubcomponents <em>Owned Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.VirtualBusImplementation#getOwnedVirtualBusSubcomponents()
	 * @see #getVirtualBusImplementation()
	 * @generated
	 */
	EReference getVirtualBusImplementation_OwnedVirtualBusSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualBusPrototype <em>Virtual Bus Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Bus Prototype</em>'.
	 * @see org.osate.aadl2.VirtualBusPrototype
	 * @generated
	 */
	EClass getVirtualBusPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualProcessorType <em>Virtual Processor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Processor Type</em>'.
	 * @see org.osate.aadl2.VirtualProcessorType
	 * @generated
	 */
	EClass getVirtualProcessorType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualProcessorType#getOwnedDataPorts <em>Owned Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Data Port</em>'.
	 * @see org.osate.aadl2.VirtualProcessorType#getOwnedDataPorts()
	 * @see #getVirtualProcessorType()
	 * @generated
	 */
	EReference getVirtualProcessorType_OwnedDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualProcessorType#getOwnedEventDataPorts <em>Owned Event Data Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Data Port</em>'.
	 * @see org.osate.aadl2.VirtualProcessorType#getOwnedEventDataPorts()
	 * @see #getVirtualProcessorType()
	 * @generated
	 */
	EReference getVirtualProcessorType_OwnedEventDataPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualProcessorType#getOwnedEventPorts <em>Owned Event Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Event Port</em>'.
	 * @see org.osate.aadl2.VirtualProcessorType#getOwnedEventPorts()
	 * @see #getVirtualProcessorType()
	 * @generated
	 */
	EReference getVirtualProcessorType_OwnedEventPort();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualProcessorType#getOwnedSubprogramAccesses <em>Owned Subprogram Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Access</em>'.
	 * @see org.osate.aadl2.VirtualProcessorType#getOwnedSubprogramAccesses()
	 * @see #getVirtualProcessorType()
	 * @generated
	 */
	EReference getVirtualProcessorType_OwnedSubprogramAccess();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualProcessorType#getOwnedSubprogramGroupAccesses <em>Owned Subprogram Group Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Subprogram Group Access</em>'.
	 * @see org.osate.aadl2.VirtualProcessorType#getOwnedSubprogramGroupAccesses()
	 * @see #getVirtualProcessorType()
	 * @generated
	 */
	EReference getVirtualProcessorType_OwnedSubprogramGroupAccess();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualProcessorImplementation <em>Virtual Processor Implementation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Processor Implementation</em>'.
	 * @see org.osate.aadl2.VirtualProcessorImplementation
	 * @generated
	 */
	EClass getVirtualProcessorImplementation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualProcessorImplementation#getOwnedVirtualBusSubcomponents <em>Owned Virtual Bus Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Bus Subcomponent</em>'.
	 * @see org.osate.aadl2.VirtualProcessorImplementation#getOwnedVirtualBusSubcomponents()
	 * @see #getVirtualProcessorImplementation()
	 * @generated
	 */
	EReference getVirtualProcessorImplementation_OwnedVirtualBusSubcomponent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.VirtualProcessorImplementation#getOwnedVirtualProcessorSubcomponents <em>Owned Virtual Processor Subcomponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Virtual Processor Subcomponent</em>'.
	 * @see org.osate.aadl2.VirtualProcessorImplementation#getOwnedVirtualProcessorSubcomponents()
	 * @see #getVirtualProcessorImplementation()
	 * @generated
	 */
	EReference getVirtualProcessorImplementation_OwnedVirtualProcessorSubcomponent();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.VirtualProcessorPrototype <em>Virtual Processor Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Processor Prototype</em>'.
	 * @see org.osate.aadl2.VirtualProcessorPrototype
	 * @generated
	 */
	EClass getVirtualProcessorPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentPrototypeBinding <em>Component Prototype Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Prototype Binding</em>'.
	 * @see org.osate.aadl2.ComponentPrototypeBinding
	 * @generated
	 */
	EClass getComponentPrototypeBinding();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentPrototypeBinding#getActuals <em>Actual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Actual</em>'.
	 * @see org.osate.aadl2.ComponentPrototypeBinding#getActuals()
	 * @see #getComponentPrototypeBinding()
	 * @generated
	 */
	EReference getComponentPrototypeBinding_Actual();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComponentPrototypeActual <em>Component Prototype Actual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Prototype Actual</em>'.
	 * @see org.osate.aadl2.ComponentPrototypeActual
	 * @generated
	 */
	EClass getComponentPrototypeActual();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComponentPrototypeActual#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see org.osate.aadl2.ComponentPrototypeActual#getCategory()
	 * @see #getComponentPrototypeActual()
	 * @generated
	 */
	EAttribute getComponentPrototypeActual_Category();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ComponentPrototypeActual#getBindings <em>Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Binding</em>'.
	 * @see org.osate.aadl2.ComponentPrototypeActual#getBindings()
	 * @see #getComponentPrototypeActual()
	 * @generated
	 */
	EReference getComponentPrototypeActual_Binding();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ComponentPrototypeActual#getSubcomponentType <em>Subcomponent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Subcomponent Type</em>'.
	 * @see org.osate.aadl2.ComponentPrototypeActual#getSubcomponentType()
	 * @see #getComponentPrototypeActual()
	 * @generated
	 */
	EReference getComponentPrototypeActual_SubcomponentType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroupPrototype <em>Feature Group Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group Prototype</em>'.
	 * @see org.osate.aadl2.FeatureGroupPrototype
	 * @generated
	 */
	EClass getFeatureGroupPrototype();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroupPrototype#getConstrainingFeatureGroupType <em>Constraining Feature Group Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Constraining Feature Group Type</em>'.
	 * @see org.osate.aadl2.FeatureGroupPrototype#getConstrainingFeatureGroupType()
	 * @see #getFeatureGroupPrototype()
	 * @generated
	 */
	EReference getFeatureGroupPrototype_ConstrainingFeatureGroupType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroupPrototypeBinding <em>Feature Group Prototype Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group Prototype Binding</em>'.
	 * @see org.osate.aadl2.FeatureGroupPrototypeBinding
	 * @generated
	 */
	EClass getFeatureGroupPrototypeBinding();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.FeatureGroupPrototypeBinding#getActual <em>Actual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Actual</em>'.
	 * @see org.osate.aadl2.FeatureGroupPrototypeBinding#getActual()
	 * @see #getFeatureGroupPrototypeBinding()
	 * @generated
	 */
	EReference getFeatureGroupPrototypeBinding_Actual();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeatureGroupPrototypeActual <em>Feature Group Prototype Actual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Group Prototype Actual</em>'.
	 * @see org.osate.aadl2.FeatureGroupPrototypeActual
	 * @generated
	 */
	EClass getFeatureGroupPrototypeActual();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.FeatureGroupPrototypeActual#getBindings <em>Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Binding</em>'.
	 * @see org.osate.aadl2.FeatureGroupPrototypeActual#getBindings()
	 * @see #getFeatureGroupPrototypeActual()
	 * @generated
	 */
	EReference getFeatureGroupPrototypeActual_Binding();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeatureGroupPrototypeActual#getFeatureType <em>Feature Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature Type</em>'.
	 * @see org.osate.aadl2.FeatureGroupPrototypeActual#getFeatureType()
	 * @see #getFeatureGroupPrototypeActual()
	 * @generated
	 */
	EReference getFeatureGroupPrototypeActual_FeatureType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeaturePrototype <em>Feature Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Prototype</em>'.
	 * @see org.osate.aadl2.FeaturePrototype
	 * @generated
	 */
	EClass getFeaturePrototype();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.FeaturePrototype#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see org.osate.aadl2.FeaturePrototype#getDirection()
	 * @see #getFeaturePrototype()
	 * @generated
	 */
	EAttribute getFeaturePrototype_Direction();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeaturePrototype#getConstrainingClassifier <em>Constraining Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Constraining Classifier</em>'.
	 * @see org.osate.aadl2.FeaturePrototype#getConstrainingClassifier()
	 * @see #getFeaturePrototype()
	 * @generated
	 */
	EReference getFeaturePrototype_ConstrainingClassifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeaturePrototypeBinding <em>Feature Prototype Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Prototype Binding</em>'.
	 * @see org.osate.aadl2.FeaturePrototypeBinding
	 * @generated
	 */
	EClass getFeaturePrototypeBinding();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.FeaturePrototypeBinding#getActual <em>Actual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Actual</em>'.
	 * @see org.osate.aadl2.FeaturePrototypeBinding#getActual()
	 * @see #getFeaturePrototypeBinding()
	 * @generated
	 */
	EReference getFeaturePrototypeBinding_Actual();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeaturePrototypeActual <em>Feature Prototype Actual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Prototype Actual</em>'.
	 * @see org.osate.aadl2.FeaturePrototypeActual
	 * @generated
	 */
	EClass getFeaturePrototypeActual();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AccessSpecification <em>Access Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access Specification</em>'.
	 * @see org.osate.aadl2.AccessSpecification
	 * @generated
	 */
	EClass getAccessSpecification();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.AccessSpecification#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see org.osate.aadl2.AccessSpecification#getKind()
	 * @see #getAccessSpecification()
	 * @generated
	 */
	EAttribute getAccessSpecification_Kind();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.AccessSpecification#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see org.osate.aadl2.AccessSpecification#getCategory()
	 * @see #getAccessSpecification()
	 * @generated
	 */
	EAttribute getAccessSpecification_Category();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.AccessSpecification#getClassifier <em>Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Classifier</em>'.
	 * @see org.osate.aadl2.AccessSpecification#getClassifier()
	 * @see #getAccessSpecification()
	 * @generated
	 */
	EReference getAccessSpecification_Classifier();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.AccessSpecification#getComponentPrototype <em>Component Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Component Prototype</em>'.
	 * @see org.osate.aadl2.AccessSpecification#getComponentPrototype()
	 * @see #getAccessSpecification()
	 * @generated
	 */
	EReference getAccessSpecification_ComponentPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PortSpecification <em>Port Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Specification</em>'.
	 * @see org.osate.aadl2.PortSpecification
	 * @generated
	 */
	EClass getPortSpecification();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PortSpecification#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see org.osate.aadl2.PortSpecification#getDirection()
	 * @see #getPortSpecification()
	 * @generated
	 */
	EAttribute getPortSpecification_Direction();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.PortSpecification#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see org.osate.aadl2.PortSpecification#getCategory()
	 * @see #getPortSpecification()
	 * @generated
	 */
	EAttribute getPortSpecification_Category();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PortSpecification#getClassifier <em>Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Classifier</em>'.
	 * @see org.osate.aadl2.PortSpecification#getClassifier()
	 * @see #getPortSpecification()
	 * @generated
	 */
	EReference getPortSpecification_Classifier();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PortSpecification#getComponentPrototype <em>Component Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Component Prototype</em>'.
	 * @see org.osate.aadl2.PortSpecification#getComponentPrototype()
	 * @see #getPortSpecification()
	 * @generated
	 */
	EReference getPortSpecification_ComponentPrototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.FeaturePrototypeReference <em>Feature Prototype Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Prototype Reference</em>'.
	 * @see org.osate.aadl2.FeaturePrototypeReference
	 * @generated
	 */
	EClass getFeaturePrototypeReference();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.FeaturePrototypeReference#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see org.osate.aadl2.FeaturePrototypeReference#getDirection()
	 * @see #getFeaturePrototypeReference()
	 * @generated
	 */
	EAttribute getFeaturePrototypeReference_Direction();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.FeaturePrototypeReference#getPrototype <em>Prototype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Prototype</em>'.
	 * @see org.osate.aadl2.FeaturePrototypeReference#getPrototype()
	 * @see #getFeaturePrototypeReference()
	 * @generated
	 */
	EReference getFeaturePrototypeReference_Prototype();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.SubprogramCall <em>Subprogram Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subprogram Call</em>'.
	 * @see org.osate.aadl2.SubprogramCall
	 * @generated
	 */
	EClass getSubprogramCall();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SubprogramCall#getCalledSubprogram <em>Called Subprogram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Called Subprogram</em>'.
	 * @see org.osate.aadl2.SubprogramCall#getCalledSubprogram()
	 * @see #getSubprogramCall()
	 * @generated
	 */
	EReference getSubprogramCall_CalledSubprogram();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.SubprogramCall#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Context</em>'.
	 * @see org.osate.aadl2.SubprogramCall#getContext()
	 * @see #getSubprogramCall()
	 * @generated
	 */
	EReference getSubprogramCall_Context();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BasicPropertyAssociation <em>Basic Property Association</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Basic Property Association</em>'.
	 * @see org.osate.aadl2.BasicPropertyAssociation
	 * @generated
	 */
	EClass getBasicPropertyAssociation();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.BasicPropertyAssociation#getProperty <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Property</em>'.
	 * @see org.osate.aadl2.BasicPropertyAssociation#getProperty()
	 * @see #getBasicPropertyAssociation()
	 * @generated
	 */
	EReference getBasicPropertyAssociation_Property();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.BasicPropertyAssociation#getOwnedValue <em>Owned Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Value</em>'.
	 * @see org.osate.aadl2.BasicPropertyAssociation#getOwnedValue()
	 * @see #getBasicPropertyAssociation()
	 * @generated
	 */
	EReference getBasicPropertyAssociation_OwnedValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PropertyConstant <em>Property Constant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Constant</em>'.
	 * @see org.osate.aadl2.PropertyConstant
	 * @generated
	 */
	EClass getPropertyConstant();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.PropertyConstant#getPropertyType <em>Property Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Property Type</em>'.
	 * @see org.osate.aadl2.PropertyConstant#getPropertyType()
	 * @see #getPropertyConstant()
	 * @generated
	 */
	EReference getPropertyConstant_PropertyType();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.PropertyConstant#getOwnedPropertyType <em>Owned Property Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Property Type</em>'.
	 * @see org.osate.aadl2.PropertyConstant#getOwnedPropertyType()
	 * @see #getPropertyConstant()
	 * @generated
	 */
	EReference getPropertyConstant_OwnedPropertyType();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.PropertyConstant#getConstantValue <em>Constant Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Constant Value</em>'.
	 * @see org.osate.aadl2.PropertyConstant#getConstantValue()
	 * @see #getPropertyConstant()
	 * @generated
	 */
	EReference getPropertyConstant_ConstantValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AbstractNamedValue <em>Abstract Named Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Named Value</em>'.
	 * @see org.osate.aadl2.AbstractNamedValue
	 * @generated
	 */
	EClass getAbstractNamedValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ArraySizeProperty <em>Array Size Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Size Property</em>'.
	 * @see org.osate.aadl2.ArraySizeProperty
	 * @generated
	 */
	EClass getArraySizeProperty();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PropertyValue <em>Property Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Value</em>'.
	 * @see org.osate.aadl2.PropertyValue
	 * @generated
	 */
	EClass getPropertyValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EnumerationLiteral <em>Enumeration Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enumeration Literal</em>'.
	 * @see org.osate.aadl2.EnumerationLiteral
	 * @generated
	 */
	EClass getEnumerationLiteral();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.UnitLiteral <em>Unit Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unit Literal</em>'.
	 * @see org.osate.aadl2.UnitLiteral
	 * @generated
	 */
	EClass getUnitLiteral();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.UnitLiteral#getBaseUnit <em>Base Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Base Unit</em>'.
	 * @see org.osate.aadl2.UnitLiteral#getBaseUnit()
	 * @see #getUnitLiteral()
	 * @generated
	 */
	EReference getUnitLiteral_BaseUnit();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.UnitLiteral#getFactor <em>Factor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Factor</em>'.
	 * @see org.osate.aadl2.UnitLiteral#getFactor()
	 * @see #getUnitLiteral()
	 * @generated
	 */
	EReference getUnitLiteral_Factor();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.NumberValue <em>Number Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Number Value</em>'.
	 * @see org.osate.aadl2.NumberValue
	 * @generated
	 */
	EClass getNumberValue();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.NumberValue#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Unit</em>'.
	 * @see org.osate.aadl2.NumberValue#getUnit()
	 * @see #getNumberValue()
	 * @generated
	 */
	EReference getNumberValue_Unit();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.StringLiteral <em>String Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>String Literal</em>'.
	 * @see org.osate.aadl2.StringLiteral
	 * @generated
	 */
	EClass getStringLiteral();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.StringLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.osate.aadl2.StringLiteral#getValue()
	 * @see #getStringLiteral()
	 * @generated
	 */
	EAttribute getStringLiteral_Value();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ClassifierValue <em>Classifier Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Classifier Value</em>'.
	 * @see org.osate.aadl2.ClassifierValue
	 * @generated
	 */
	EClass getClassifierValue();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ClassifierValue#getClassifier <em>Classifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Classifier</em>'.
	 * @see org.osate.aadl2.ClassifierValue#getClassifier()
	 * @see #getClassifierValue()
	 * @generated
	 */
	EReference getClassifierValue_Classifier();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ReferenceValue <em>Reference Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Reference Value</em>'.
	 * @see org.osate.aadl2.ReferenceValue
	 * @generated
	 */
	EClass getReferenceValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.BooleanLiteral <em>Boolean Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Boolean Literal</em>'.
	 * @see org.osate.aadl2.BooleanLiteral
	 * @generated
	 */
	EClass getBooleanLiteral();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.BooleanLiteral#isValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.osate.aadl2.BooleanLiteral#isValue()
	 * @see #getBooleanLiteral()
	 * @generated
	 */
	EAttribute getBooleanLiteral_Value();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.RangeValue <em>Range Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Range Value</em>'.
	 * @see org.osate.aadl2.RangeValue
	 * @generated
	 */
	EClass getRangeValue();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.RangeValue#getMinimum <em>Minimum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Minimum</em>'.
	 * @see org.osate.aadl2.RangeValue#getMinimum()
	 * @see #getRangeValue()
	 * @generated
	 */
	EReference getRangeValue_Minimum();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.RangeValue#getMaximum <em>Maximum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Maximum</em>'.
	 * @see org.osate.aadl2.RangeValue#getMaximum()
	 * @see #getRangeValue()
	 * @generated
	 */
	EReference getRangeValue_Maximum();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.RangeValue#getDelta <em>Delta</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delta</em>'.
	 * @see org.osate.aadl2.RangeValue#getDelta()
	 * @see #getRangeValue()
	 * @generated
	 */
	EReference getRangeValue_Delta();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.IntegerLiteral <em>Integer Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Integer Literal</em>'.
	 * @see org.osate.aadl2.IntegerLiteral
	 * @generated
	 */
	EClass getIntegerLiteral();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.IntegerLiteral#getBase <em>Base</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Base</em>'.
	 * @see org.osate.aadl2.IntegerLiteral#getBase()
	 * @see #getIntegerLiteral()
	 * @generated
	 */
	EAttribute getIntegerLiteral_Base();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.IntegerLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.osate.aadl2.IntegerLiteral#getValue()
	 * @see #getIntegerLiteral()
	 * @generated
	 */
	EAttribute getIntegerLiteral_Value();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.RealLiteral <em>Real Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Real Literal</em>'.
	 * @see org.osate.aadl2.RealLiteral
	 * @generated
	 */
	EClass getRealLiteral();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.RealLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.osate.aadl2.RealLiteral#getValue()
	 * @see #getRealLiteral()
	 * @generated
	 */
	EAttribute getRealLiteral_Value();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.Operation <em>Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operation</em>'.
	 * @see org.osate.aadl2.Operation
	 * @generated
	 */
	EClass getOperation();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.Operation#getOp <em>Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Op</em>'.
	 * @see org.osate.aadl2.Operation#getOp()
	 * @see #getOperation()
	 * @generated
	 */
	EAttribute getOperation_Op();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.Operation#getOwnedPropertyExpressions <em>Owned Property Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Property Expression</em>'.
	 * @see org.osate.aadl2.Operation#getOwnedPropertyExpressions()
	 * @see #getOperation()
	 * @generated
	 */
	EReference getOperation_OwnedPropertyExpression();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.RecordValue <em>Record Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Record Value</em>'.
	 * @see org.osate.aadl2.RecordValue
	 * @generated
	 */
	EClass getRecordValue();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.RecordValue#getOwnedFieldValues <em>Owned Field Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Field Value</em>'.
	 * @see org.osate.aadl2.RecordValue#getOwnedFieldValues()
	 * @see #getRecordValue()
	 * @generated
	 */
	EReference getRecordValue_OwnedFieldValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ComputedValue <em>Computed Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Computed Value</em>'.
	 * @see org.osate.aadl2.ComputedValue
	 * @generated
	 */
	EClass getComputedValue();

	/**
	 * Returns the meta object for the attribute '{@link org.osate.aadl2.ComputedValue#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Function</em>'.
	 * @see org.osate.aadl2.ComputedValue#getFunction()
	 * @see #getComputedValue()
	 * @generated
	 */
	EAttribute getComputedValue_Function();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ListValue <em>List Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List Value</em>'.
	 * @see org.osate.aadl2.ListValue
	 * @generated
	 */
	EClass getListValue();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ListValue#getOwnedListElements <em>Owned List Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned List Element</em>'.
	 * @see org.osate.aadl2.ListValue#getOwnedListElements()
	 * @see #getListValue()
	 * @generated
	 */
	EReference getListValue_OwnedListElement();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.NamedValue <em>Named Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Named Value</em>'.
	 * @see org.osate.aadl2.NamedValue
	 * @generated
	 */
	EClass getNamedValue();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.NamedValue#getNamedValue <em>Named Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Named Value</em>'.
	 * @see org.osate.aadl2.NamedValue#getNamedValue()
	 * @see #getNamedValue()
	 * @generated
	 */
	EReference getNamedValue_NamedValue();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.PropertySet <em>Property Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Set</em>'.
	 * @see org.osate.aadl2.PropertySet
	 * @generated
	 */
	EClass getPropertySet();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PropertySet#getOwnedPropertyTypes <em>Owned Property Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Property Type</em>'.
	 * @see org.osate.aadl2.PropertySet#getOwnedPropertyTypes()
	 * @see #getPropertySet()
	 * @generated
	 */
	EReference getPropertySet_OwnedPropertyType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PropertySet#getOwnedProperties <em>Owned Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Property</em>'.
	 * @see org.osate.aadl2.PropertySet#getOwnedProperties()
	 * @see #getPropertySet()
	 * @generated
	 */
	EReference getPropertySet_OwnedProperty();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PropertySet#getOwnedPropertyConstants <em>Owned Property Constant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Property Constant</em>'.
	 * @see org.osate.aadl2.PropertySet#getOwnedPropertyConstants()
	 * @see #getPropertySet()
	 * @generated
	 */
	EReference getPropertySet_OwnedPropertyConstant();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.PropertySet#getImportedUnits <em>Imported Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Imported Unit</em>'.
	 * @see org.osate.aadl2.PropertySet#getImportedUnits()
	 * @see #getPropertySet()
	 * @generated
	 */
	EReference getPropertySet_ImportedUnit();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.PropertySet#getOwnedAnnexSubclauses <em>Owned Annex Subclause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Annex Subclause</em>'.
	 * @see org.osate.aadl2.PropertySet#getOwnedAnnexSubclauses()
	 * @see #getPropertySet()
	 * @generated
	 */
	EReference getPropertySet_OwnedAnnexSubclause();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.GlobalNamespace <em>Global Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Global Namespace</em>'.
	 * @see org.osate.aadl2.GlobalNamespace
	 * @generated
	 */
	EClass getGlobalNamespace();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.GlobalNamespace#getPackages <em>Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Package</em>'.
	 * @see org.osate.aadl2.GlobalNamespace#getPackages()
	 * @see #getGlobalNamespace()
	 * @generated
	 */
	EReference getGlobalNamespace_Package();

	/**
	 * Returns the meta object for the reference list '{@link org.osate.aadl2.GlobalNamespace#getPropertySets <em>Property Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Property Set</em>'.
	 * @see org.osate.aadl2.GlobalNamespace#getPropertySets()
	 * @see #getGlobalNamespace()
	 * @generated
	 */
	EReference getGlobalNamespace_PropertySet();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.NonListType <em>Non List Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Non List Type</em>'.
	 * @see org.osate.aadl2.NonListType
	 * @generated
	 */
	EClass getNonListType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AadlBoolean <em>Aadl Boolean</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Aadl Boolean</em>'.
	 * @see org.osate.aadl2.AadlBoolean
	 * @generated
	 */
	EClass getAadlBoolean();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AadlString <em>Aadl String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Aadl String</em>'.
	 * @see org.osate.aadl2.AadlString
	 * @generated
	 */
	EClass getAadlString();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AadlInteger <em>Aadl Integer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Aadl Integer</em>'.
	 * @see org.osate.aadl2.AadlInteger
	 * @generated
	 */
	EClass getAadlInteger();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.NumberType <em>Number Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Number Type</em>'.
	 * @see org.osate.aadl2.NumberType
	 * @generated
	 */
	EClass getNumberType();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.NumberType#getOwnedUnitsType <em>Owned Units Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Units Type</em>'.
	 * @see org.osate.aadl2.NumberType#getOwnedUnitsType()
	 * @see #getNumberType()
	 * @generated
	 */
	EReference getNumberType_OwnedUnitsType();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.NumberType#getUnitsType <em>Units Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Units Type</em>'.
	 * @see org.osate.aadl2.NumberType#getUnitsType()
	 * @see #getNumberType()
	 * @generated
	 */
	EReference getNumberType_UnitsType();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.NumberType#getRange <em>Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Range</em>'.
	 * @see org.osate.aadl2.NumberType#getRange()
	 * @see #getNumberType()
	 * @generated
	 */
	EReference getNumberType_Range();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.UnitsType <em>Units Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Units Type</em>'.
	 * @see org.osate.aadl2.UnitsType
	 * @generated
	 */
	EClass getUnitsType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.EnumerationType <em>Enumeration Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enumeration Type</em>'.
	 * @see org.osate.aadl2.EnumerationType
	 * @generated
	 */
	EClass getEnumerationType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.EnumerationType#getOwnedLiterals <em>Owned Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Literal</em>'.
	 * @see org.osate.aadl2.EnumerationType#getOwnedLiterals()
	 * @see #getEnumerationType()
	 * @generated
	 */
	EReference getEnumerationType_OwnedLiteral();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.NumericRange <em>Numeric Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Numeric Range</em>'.
	 * @see org.osate.aadl2.NumericRange
	 * @generated
	 */
	EClass getNumericRange();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.NumericRange#getUpperBound <em>Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Upper Bound</em>'.
	 * @see org.osate.aadl2.NumericRange#getUpperBound()
	 * @see #getNumericRange()
	 * @generated
	 */
	EReference getNumericRange_UpperBound();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.NumericRange#getLowerBound <em>Lower Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Lower Bound</em>'.
	 * @see org.osate.aadl2.NumericRange#getLowerBound()
	 * @see #getNumericRange()
	 * @generated
	 */
	EReference getNumericRange_LowerBound();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.AadlReal <em>Aadl Real</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Aadl Real</em>'.
	 * @see org.osate.aadl2.AadlReal
	 * @generated
	 */
	EClass getAadlReal();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ClassifierType <em>Classifier Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Classifier Type</em>'.
	 * @see org.osate.aadl2.ClassifierType
	 * @generated
	 */
	EClass getClassifierType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ClassifierType#getClassifierReferences <em>Classifier Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Classifier Reference</em>'.
	 * @see org.osate.aadl2.ClassifierType#getClassifierReferences()
	 * @see #getClassifierType()
	 * @generated
	 */
	EReference getClassifierType_ClassifierReference();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.RangeType <em>Range Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Range Type</em>'.
	 * @see org.osate.aadl2.RangeType
	 * @generated
	 */
	EClass getRangeType();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.RangeType#getOwnedNumberType <em>Owned Number Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Number Type</em>'.
	 * @see org.osate.aadl2.RangeType#getOwnedNumberType()
	 * @see #getRangeType()
	 * @generated
	 */
	EReference getRangeType_OwnedNumberType();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.RangeType#getNumberType <em>Number Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Number Type</em>'.
	 * @see org.osate.aadl2.RangeType#getNumberType()
	 * @see #getRangeType()
	 * @generated
	 */
	EReference getRangeType_NumberType();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.RecordType <em>Record Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Record Type</em>'.
	 * @see org.osate.aadl2.RecordType
	 * @generated
	 */
	EClass getRecordType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.RecordType#getOwnedFields <em>Owned Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Owned Field</em>'.
	 * @see org.osate.aadl2.RecordType#getOwnedFields()
	 * @see #getRecordType()
	 * @generated
	 */
	EReference getRecordType_OwnedField();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.RecordField <em>Record Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Record Field</em>'.
	 * @see org.osate.aadl2.RecordField
	 * @generated
	 */
	EClass getRecordField();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ReferenceType <em>Reference Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Reference Type</em>'.
	 * @see org.osate.aadl2.ReferenceType
	 * @generated
	 */
	EClass getReferenceType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.osate.aadl2.ReferenceType#getNamedElementReferences <em>Named Element Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Named Element Reference</em>'.
	 * @see org.osate.aadl2.ReferenceType#getNamedElementReferences()
	 * @see #getReferenceType()
	 * @generated
	 */
	EReference getReferenceType_NamedElementReference();

	/**
	 * Returns the meta object for class '{@link org.osate.aadl2.ListType <em>List Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List Type</em>'.
	 * @see org.osate.aadl2.ListType
	 * @generated
	 */
	EClass getListType();

	/**
	 * Returns the meta object for the containment reference '{@link org.osate.aadl2.ListType#getOwnedElementType <em>Owned Element Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Owned Element Type</em>'.
	 * @see org.osate.aadl2.ListType#getOwnedElementType()
	 * @see #getListType()
	 * @generated
	 */
	EReference getListType_OwnedElementType();

	/**
	 * Returns the meta object for the reference '{@link org.osate.aadl2.ListType#getElementType <em>Element Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Element Type</em>'.
	 * @see org.osate.aadl2.ListType#getElementType()
	 * @see #getListType()
	 * @generated
	 */
	EReference getListType_ElementType();

	/**
	 * Returns the meta object for enum '{@link org.osate.aadl2.DirectionType <em>Direction Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Direction Type</em>'.
	 * @see org.osate.aadl2.DirectionType
	 * @generated
	 */
	EEnum getDirectionType();

	/**
	 * Returns the meta object for enum '{@link org.osate.aadl2.PortCategory <em>Port Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Port Category</em>'.
	 * @see org.osate.aadl2.PortCategory
	 * @generated
	 */
	EEnum getPortCategory();

	/**
	 * Returns the meta object for enum '{@link org.osate.aadl2.FlowKind <em>Flow Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Flow Kind</em>'.
	 * @see org.osate.aadl2.FlowKind
	 * @generated
	 */
	EEnum getFlowKind();

	/**
	 * Returns the meta object for enum '{@link org.osate.aadl2.AccessType <em>Access Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Access Type</em>'.
	 * @see org.osate.aadl2.AccessType
	 * @generated
	 */
	EEnum getAccessType();

	/**
	 * Returns the meta object for enum '{@link org.osate.aadl2.AccessCategory <em>Access Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Access Category</em>'.
	 * @see org.osate.aadl2.AccessCategory
	 * @generated
	 */
	EEnum getAccessCategory();

	/**
	 * Returns the meta object for enum '{@link org.osate.aadl2.ComponentCategory <em>Component Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Component Category</em>'.
	 * @see org.osate.aadl2.ComponentCategory
	 * @generated
	 */
	EEnum getComponentCategory();

	/**
	 * Returns the meta object for enum '{@link org.osate.aadl2.OperationKind <em>Operation Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Operation Kind</em>'.
	 * @see org.osate.aadl2.OperationKind
	 * @generated
	 */
	EEnum getOperationKind();

	/**
	 * Returns the meta object for data type '{@link java.lang.String <em>String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>String</em>'.
	 * @see java.lang.String
	 * @model instanceClass="java.lang.String"
	 *        annotation="http://www.topcased.org/documentation documentation='A string is a sequence of characters in some suitable character set used to display information about the model. Character sets may include non-Roman alphabets and characters.'"
	 * @generated
	 */
	EDataType getString();

	/**
	 * Returns the meta object for data type '<em>Boolean</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Boolean</em>'.
	 * @model instanceClass="boolean"
	 *        annotation="http://www.topcased.org/documentation documentation='A Boolean type is used for logical expression, consisting of the predefined values true and false.'"
	 * @generated
	 */
	EDataType getBoolean();

	/**
	 * Returns the meta object for data type '<em>Integer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Integer</em>'.
	 * @model instanceClass="long"
	 *        annotation="http://www.topcased.org/documentation documentation='An integer is a primitive type representing integer values.'"
	 * @generated
	 */
	EDataType getInteger();

	/**
	 * Returns the meta object for data type '<em>Real</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Real</em>'.
	 * @model instanceClass="double"
	 *        annotation="http://www.topcased.org/documentation documentation='A real is a primitive type representing real numeric values.'"
	 * @generated
	 */
	EDataType getReal();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	Aadl2Factory getAadl2Factory();

} // Aadl2Package
